#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 643
#define LARGE_STATE_COUNT 4
#define SYMBOL_COUNT 204
#define ALIAS_COUNT 0
#define TOKEN_COUNT 86
#define EXTERNAL_TOKEN_COUNT 0
#define FIELD_COUNT 8
#define MAX_ALIAS_SEQUENCE_LENGTH 10
#define PRODUCTION_ID_COUNT 14

enum ts_symbol_identifiers {
  anon_sym_POUND = 1,
  anon_sym_LBRACK = 2,
  anon_sym_RBRACK = 3,
  anon_sym_SEMI = 4,
  anon_sym_fn = 5,
  anon_sym_entity = 6,
  anon_sym_DASH_GT = 7,
  anon_sym_pipeline = 8,
  anon_sym_LPAREN = 9,
  anon_sym_RPAREN = 10,
  anon_sym_where = 11,
  anon_sym_COLON = 12,
  anon_sym_COMMA = 13,
  anon_sym_struct = 14,
  anon_sym_port = 15,
  anon_sym_enum = 16,
  anon_sym_impl = 17,
  anon_sym_for = 18,
  anon_sym_LBRACE = 19,
  anon_sym_RBRACE = 20,
  anon_sym_trait = 21,
  anon_sym_use = 22,
  anon_sym_mod = 23,
  anon_sym_DOLLARconfig = 24,
  anon_sym_EQ = 25,
  anon_sym_let = 26,
  anon_sym_reg = 27,
  anon_sym_set = 28,
  anon_sym_decl = 29,
  anon_sym_STAR = 30,
  anon_sym_SQUOTE = 31,
  anon_sym_DOLLARif = 32,
  anon_sym_DOLLARelse = 33,
  anon_sym_assert = 34,
  anon_sym_reset = 35,
  anon_sym_initial = 36,
  anon_sym_PLUS = 37,
  anon_sym_DASH = 38,
  sym_op_div = 39,
  sym_op_mod = 40,
  sym_op_equals = 41,
  sym_op_ne = 42,
  anon_sym_LT = 43,
  anon_sym_GT = 44,
  sym_op_le = 45,
  sym_op_ge = 46,
  sym_op_lshift = 47,
  sym_op_rshift = 48,
  anon_sym_AMP = 49,
  sym_op_bitwise_xor = 50,
  sym_op_bitwise_or = 51,
  sym_op_logical_and = 52,
  sym_op_logical_or = 53,
  anon_sym_BQUOTE = 54,
  anon_sym_BANG = 55,
  anon_sym_TILDE = 56,
  anon_sym_if = 57,
  anon_sym_else = 58,
  anon_sym_match = 59,
  anon_sym_EQ_GT = 60,
  anon_sym_DOT = 61,
  anon_sym_inst = 62,
  anon_sym_COLON_COLON_LT = 63,
  anon_sym_COLON_COLON_DOLLAR_LT = 64,
  anon_sym_stage = 65,
  anon_sym_RPAREN_DOT = 66,
  anon_sym_true = 67,
  anon_sym_false = 68,
  anon_sym___builtin__ = 69,
  anon_sym_DOLLAR_LPAREN = 70,
  sym_self = 71,
  anon_sym_inv = 72,
  anon_sym_int = 73,
  anon_sym_bool = 74,
  anon_sym_clock = 75,
  sym_identifier = 76,
  anon_sym_COLON_COLON = 77,
  aux_sym_int_literal_token1 = 78,
  aux_sym_int_literal_token2 = 79,
  aux_sym_int_literal_token3 = 80,
  sym_doc_comment = 81,
  sym_line_comment = 82,
  anon_sym_SLASH_STAR = 83,
  aux_sym_block_comment_token1 = 84,
  anon_sym_STAR_SLASH = 85,
  sym_source_file = 86,
  sym_attribute = 87,
  sym__item = 88,
  sym_unit_definition = 89,
  sym_unit_declaration = 90,
  sym__unit_head = 91,
  sym__pipeline_start = 92,
  sym_where_clause = 93,
  sym_struct_definition = 94,
  sym_enum_definition = 95,
  sym_impl = 96,
  sym_trait = 97,
  sym_enum_body = 98,
  sym_enum_member = 99,
  sym_use = 100,
  sym_mod = 101,
  sym_comptime_config = 102,
  sym__body_or_builtin = 103,
  sym_block = 104,
  sym__statement = 105,
  sym_let_binding = 106,
  sym_reg_statement = 107,
  sym_set_statement = 108,
  sym_decl_statement = 109,
  sym_pipeline_reg_marker = 110,
  sym_pipeline_stage_name = 111,
  sym__comptime_operator = 112,
  sym_comptime_if = 113,
  sym_comptime_else = 114,
  sym_assert_statement = 115,
  sym_reg_reset = 116,
  sym_reg_initial = 117,
  sym__expression = 118,
  sym_op_add = 119,
  sym_op_sub = 120,
  sym_op_mul = 121,
  sym_op_lt = 122,
  sym_op_gt = 123,
  sym_op_bitwise_and = 124,
  sym__op_mul_like = 125,
  sym__op_add_like = 126,
  sym__op_relational = 127,
  sym__op_eq_like = 128,
  sym__op_shifty = 129,
  sym_op_custom_infix = 130,
  sym_binary_expression = 131,
  sym_unary_expression = 132,
  sym_if_expression = 133,
  sym_match_expression = 134,
  sym_match_block = 135,
  sym_match_arm = 136,
  sym_last_match_arm = 137,
  sym__base_expression = 138,
  sym__simple_base_expression = 139,
  sym_field_access = 140,
  sym_method_call = 141,
  sym_index = 142,
  sym_array_literal = 143,
  sym_tuple_literal = 144,
  sym_paren_expression = 145,
  sym_function_call = 146,
  sym_entity_instance = 147,
  sym_pipeline_instance = 148,
  sym_turbofish = 149,
  sym_named_turbofish_arg = 150,
  sym_stage_reference = 151,
  sym_bool_literal = 152,
  sym_builtin_marker = 153,
  sym_argument_list = 154,
  sym__named_argument_list = 155,
  sym__named_argument = 156,
  sym__positional_argument_list = 157,
  sym_parameter_list = 158,
  sym_braced_parameter_list = 159,
  sym_typed_parameter = 160,
  sym_parameter = 161,
  sym__pattern = 162,
  sym_tuple_pattern = 163,
  sym_named_unpack = 164,
  sym_positional_unpack = 165,
  sym__named_pattern_list = 166,
  sym__positional_pattern_list = 167,
  sym_named_pattern_param = 168,
  sym_type = 169,
  sym_tuple_type = 170,
  sym_array_type = 171,
  sym_wire = 172,
  sym_inverted = 173,
  sym__generic_list = 174,
  sym_generic_parameters = 175,
  sym_generic_param = 176,
  sym__base_type = 177,
  sym_builtin_type = 178,
  sym_scoped_identifier = 179,
  sym__path = 180,
  sym__scoped_or_raw_ident = 181,
  sym_int_literal = 182,
  sym_block_comment = 183,
  aux_sym_source_file_repeat1 = 184,
  aux_sym__item_repeat1 = 185,
  aux_sym_where_clause_repeat1 = 186,
  aux_sym_impl_repeat1 = 187,
  aux_sym_trait_repeat1 = 188,
  aux_sym_enum_body_repeat1 = 189,
  aux_sym_block_repeat1 = 190,
  aux_sym_reg_statement_repeat1 = 191,
  aux_sym_decl_statement_repeat1 = 192,
  aux_sym_match_block_repeat1 = 193,
  aux_sym_array_literal_repeat1 = 194,
  aux_sym_turbofish_repeat1 = 195,
  aux_sym_turbofish_repeat2 = 196,
  aux_sym__named_argument_list_repeat1 = 197,
  aux_sym__positional_argument_list_repeat1 = 198,
  aux_sym_parameter_list_repeat1 = 199,
  aux_sym_tuple_pattern_repeat1 = 200,
  aux_sym__named_pattern_list_repeat1 = 201,
  aux_sym_generic_parameters_repeat1 = 202,
  aux_sym_block_comment_repeat1 = 203,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_POUND] = "#",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_SEMI] = ";",
  [anon_sym_fn] = "fn",
  [anon_sym_entity] = "entity",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_pipeline] = "pipeline",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_where] = "where",
  [anon_sym_COLON] = ":",
  [anon_sym_COMMA] = ",",
  [anon_sym_struct] = "struct",
  [anon_sym_port] = "port",
  [anon_sym_enum] = "enum",
  [anon_sym_impl] = "impl",
  [anon_sym_for] = "for",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_trait] = "trait",
  [anon_sym_use] = "use",
  [anon_sym_mod] = "mod",
  [anon_sym_DOLLARconfig] = "$config",
  [anon_sym_EQ] = "=",
  [anon_sym_let] = "let",
  [anon_sym_reg] = "reg",
  [anon_sym_set] = "set",
  [anon_sym_decl] = "decl",
  [anon_sym_STAR] = "*",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_DOLLARif] = "$if",
  [anon_sym_DOLLARelse] = "$else",
  [anon_sym_assert] = "assert",
  [anon_sym_reset] = "reset",
  [anon_sym_initial] = "initial",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [sym_op_div] = "op_div",
  [sym_op_mod] = "op_mod",
  [sym_op_equals] = "op_equals",
  [sym_op_ne] = "op_ne",
  [anon_sym_LT] = "<",
  [anon_sym_GT] = ">",
  [sym_op_le] = "op_le",
  [sym_op_ge] = "op_ge",
  [sym_op_lshift] = "op_lshift",
  [sym_op_rshift] = "op_rshift",
  [anon_sym_AMP] = "&",
  [sym_op_bitwise_xor] = "op_bitwise_xor",
  [sym_op_bitwise_or] = "op_bitwise_or",
  [sym_op_logical_and] = "op_logical_and",
  [sym_op_logical_or] = "op_logical_or",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_match] = "match",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_DOT] = ".",
  [anon_sym_inst] = "inst",
  [anon_sym_COLON_COLON_LT] = "::<",
  [anon_sym_COLON_COLON_DOLLAR_LT] = "::$<",
  [anon_sym_stage] = "stage",
  [anon_sym_RPAREN_DOT] = ").",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym___builtin__] = "__builtin__",
  [anon_sym_DOLLAR_LPAREN] = "$(",
  [sym_self] = "self",
  [anon_sym_inv] = "inv",
  [anon_sym_int] = "int",
  [anon_sym_bool] = "bool",
  [anon_sym_clock] = "clock",
  [sym_identifier] = "identifier",
  [anon_sym_COLON_COLON] = "::",
  [aux_sym_int_literal_token1] = "int_literal_token1",
  [aux_sym_int_literal_token2] = "int_literal_token2",
  [aux_sym_int_literal_token3] = "int_literal_token3",
  [sym_doc_comment] = "doc_comment",
  [sym_line_comment] = "line_comment",
  [anon_sym_SLASH_STAR] = "/*",
  [aux_sym_block_comment_token1] = "block_comment_token1",
  [anon_sym_STAR_SLASH] = "*/",
  [sym_source_file] = "source_file",
  [sym_attribute] = "attribute",
  [sym__item] = "_item",
  [sym_unit_definition] = "unit_definition",
  [sym_unit_declaration] = "unit_declaration",
  [sym__unit_head] = "_unit_head",
  [sym__pipeline_start] = "_pipeline_start",
  [sym_where_clause] = "where_clause",
  [sym_struct_definition] = "struct_definition",
  [sym_enum_definition] = "enum_definition",
  [sym_impl] = "impl",
  [sym_trait] = "trait",
  [sym_enum_body] = "enum_body",
  [sym_enum_member] = "enum_member",
  [sym_use] = "use",
  [sym_mod] = "mod",
  [sym_comptime_config] = "comptime_config",
  [sym__body_or_builtin] = "_body_or_builtin",
  [sym_block] = "block",
  [sym__statement] = "_statement",
  [sym_let_binding] = "let_binding",
  [sym_reg_statement] = "reg_statement",
  [sym_set_statement] = "set_statement",
  [sym_decl_statement] = "decl_statement",
  [sym_pipeline_reg_marker] = "pipeline_reg_marker",
  [sym_pipeline_stage_name] = "pipeline_stage_name",
  [sym__comptime_operator] = "_comptime_operator",
  [sym_comptime_if] = "comptime_if",
  [sym_comptime_else] = "comptime_else",
  [sym_assert_statement] = "assert_statement",
  [sym_reg_reset] = "reg_reset",
  [sym_reg_initial] = "reg_initial",
  [sym__expression] = "_expression",
  [sym_op_add] = "op_add",
  [sym_op_sub] = "op_sub",
  [sym_op_mul] = "op_mul",
  [sym_op_lt] = "op_lt",
  [sym_op_gt] = "op_gt",
  [sym_op_bitwise_and] = "op_bitwise_and",
  [sym__op_mul_like] = "_op_mul_like",
  [sym__op_add_like] = "_op_add_like",
  [sym__op_relational] = "_op_relational",
  [sym__op_eq_like] = "_op_eq_like",
  [sym__op_shifty] = "_op_shifty",
  [sym_op_custom_infix] = "op_custom_infix",
  [sym_binary_expression] = "binary_expression",
  [sym_unary_expression] = "unary_expression",
  [sym_if_expression] = "if_expression",
  [sym_match_expression] = "match_expression",
  [sym_match_block] = "match_block",
  [sym_match_arm] = "match_arm",
  [sym_last_match_arm] = "match_arm",
  [sym__base_expression] = "_base_expression",
  [sym__simple_base_expression] = "_simple_base_expression",
  [sym_field_access] = "field_access",
  [sym_method_call] = "method_call",
  [sym_index] = "index",
  [sym_array_literal] = "array_literal",
  [sym_tuple_literal] = "tuple_literal",
  [sym_paren_expression] = "paren_expression",
  [sym_function_call] = "function_call",
  [sym_entity_instance] = "entity_instance",
  [sym_pipeline_instance] = "pipeline_instance",
  [sym_turbofish] = "turbofish",
  [sym_named_turbofish_arg] = "named_turbofish_arg",
  [sym_stage_reference] = "stage_reference",
  [sym_bool_literal] = "bool_literal",
  [sym_builtin_marker] = "builtin_marker",
  [sym_argument_list] = "argument_list",
  [sym__named_argument_list] = "_named_argument_list",
  [sym__named_argument] = "_named_argument",
  [sym__positional_argument_list] = "_positional_argument_list",
  [sym_parameter_list] = "parameter_list",
  [sym_braced_parameter_list] = "braced_parameter_list",
  [sym_typed_parameter] = "typed_parameter",
  [sym_parameter] = "parameter",
  [sym__pattern] = "_pattern",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_named_unpack] = "named_unpack",
  [sym_positional_unpack] = "positional_unpack",
  [sym__named_pattern_list] = "_named_pattern_list",
  [sym__positional_pattern_list] = "_positional_pattern_list",
  [sym_named_pattern_param] = "named_pattern_param",
  [sym_type] = "type",
  [sym_tuple_type] = "tuple_type",
  [sym_array_type] = "array_type",
  [sym_wire] = "wire",
  [sym_inverted] = "inverted",
  [sym__generic_list] = "_generic_list",
  [sym_generic_parameters] = "generic_parameters",
  [sym_generic_param] = "generic_param",
  [sym__base_type] = "_base_type",
  [sym_builtin_type] = "builtin_type",
  [sym_scoped_identifier] = "scoped_identifier",
  [sym__path] = "_path",
  [sym__scoped_or_raw_ident] = "_scoped_or_raw_ident",
  [sym_int_literal] = "int_literal",
  [sym_block_comment] = "block_comment",
  [aux_sym_source_file_repeat1] = "source_file_repeat1",
  [aux_sym__item_repeat1] = "_item_repeat1",
  [aux_sym_where_clause_repeat1] = "where_clause_repeat1",
  [aux_sym_impl_repeat1] = "impl_repeat1",
  [aux_sym_trait_repeat1] = "trait_repeat1",
  [aux_sym_enum_body_repeat1] = "enum_body_repeat1",
  [aux_sym_block_repeat1] = "block_repeat1",
  [aux_sym_reg_statement_repeat1] = "reg_statement_repeat1",
  [aux_sym_decl_statement_repeat1] = "decl_statement_repeat1",
  [aux_sym_match_block_repeat1] = "match_block_repeat1",
  [aux_sym_array_literal_repeat1] = "array_literal_repeat1",
  [aux_sym_turbofish_repeat1] = "turbofish_repeat1",
  [aux_sym_turbofish_repeat2] = "turbofish_repeat2",
  [aux_sym__named_argument_list_repeat1] = "_named_argument_list_repeat1",
  [aux_sym__positional_argument_list_repeat1] = "_positional_argument_list_repeat1",
  [aux_sym_parameter_list_repeat1] = "parameter_list_repeat1",
  [aux_sym_tuple_pattern_repeat1] = "tuple_pattern_repeat1",
  [aux_sym__named_pattern_list_repeat1] = "_named_pattern_list_repeat1",
  [aux_sym_generic_parameters_repeat1] = "generic_parameters_repeat1",
  [aux_sym_block_comment_repeat1] = "block_comment_repeat1",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_POUND] = anon_sym_POUND,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_fn] = anon_sym_fn,
  [anon_sym_entity] = anon_sym_entity,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_pipeline] = anon_sym_pipeline,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_where] = anon_sym_where,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_port] = anon_sym_port,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_impl] = anon_sym_impl,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_trait] = anon_sym_trait,
  [anon_sym_use] = anon_sym_use,
  [anon_sym_mod] = anon_sym_mod,
  [anon_sym_DOLLARconfig] = anon_sym_DOLLARconfig,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_reg] = anon_sym_reg,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_decl] = anon_sym_decl,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_DOLLARif] = anon_sym_DOLLARif,
  [anon_sym_DOLLARelse] = anon_sym_DOLLARelse,
  [anon_sym_assert] = anon_sym_assert,
  [anon_sym_reset] = anon_sym_reset,
  [anon_sym_initial] = anon_sym_initial,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [sym_op_div] = sym_op_div,
  [sym_op_mod] = sym_op_mod,
  [sym_op_equals] = sym_op_equals,
  [sym_op_ne] = sym_op_ne,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_GT] = anon_sym_GT,
  [sym_op_le] = sym_op_le,
  [sym_op_ge] = sym_op_ge,
  [sym_op_lshift] = sym_op_lshift,
  [sym_op_rshift] = sym_op_rshift,
  [anon_sym_AMP] = anon_sym_AMP,
  [sym_op_bitwise_xor] = sym_op_bitwise_xor,
  [sym_op_bitwise_or] = sym_op_bitwise_or,
  [sym_op_logical_and] = sym_op_logical_and,
  [sym_op_logical_or] = sym_op_logical_or,
  [anon_sym_BQUOTE] = anon_sym_BQUOTE,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_match] = anon_sym_match,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_inst] = anon_sym_inst,
  [anon_sym_COLON_COLON_LT] = anon_sym_COLON_COLON_LT,
  [anon_sym_COLON_COLON_DOLLAR_LT] = anon_sym_COLON_COLON_DOLLAR_LT,
  [anon_sym_stage] = anon_sym_stage,
  [anon_sym_RPAREN_DOT] = anon_sym_RPAREN_DOT,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym___builtin__] = anon_sym___builtin__,
  [anon_sym_DOLLAR_LPAREN] = anon_sym_DOLLAR_LPAREN,
  [sym_self] = sym_self,
  [anon_sym_inv] = anon_sym_inv,
  [anon_sym_int] = anon_sym_int,
  [anon_sym_bool] = anon_sym_bool,
  [anon_sym_clock] = anon_sym_clock,
  [sym_identifier] = sym_identifier,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [aux_sym_int_literal_token1] = aux_sym_int_literal_token1,
  [aux_sym_int_literal_token2] = aux_sym_int_literal_token2,
  [aux_sym_int_literal_token3] = aux_sym_int_literal_token3,
  [sym_doc_comment] = sym_doc_comment,
  [sym_line_comment] = sym_line_comment,
  [anon_sym_SLASH_STAR] = anon_sym_SLASH_STAR,
  [aux_sym_block_comment_token1] = aux_sym_block_comment_token1,
  [anon_sym_STAR_SLASH] = anon_sym_STAR_SLASH,
  [sym_source_file] = sym_source_file,
  [sym_attribute] = sym_attribute,
  [sym__item] = sym__item,
  [sym_unit_definition] = sym_unit_definition,
  [sym_unit_declaration] = sym_unit_declaration,
  [sym__unit_head] = sym__unit_head,
  [sym__pipeline_start] = sym__pipeline_start,
  [sym_where_clause] = sym_where_clause,
  [sym_struct_definition] = sym_struct_definition,
  [sym_enum_definition] = sym_enum_definition,
  [sym_impl] = sym_impl,
  [sym_trait] = sym_trait,
  [sym_enum_body] = sym_enum_body,
  [sym_enum_member] = sym_enum_member,
  [sym_use] = sym_use,
  [sym_mod] = sym_mod,
  [sym_comptime_config] = sym_comptime_config,
  [sym__body_or_builtin] = sym__body_or_builtin,
  [sym_block] = sym_block,
  [sym__statement] = sym__statement,
  [sym_let_binding] = sym_let_binding,
  [sym_reg_statement] = sym_reg_statement,
  [sym_set_statement] = sym_set_statement,
  [sym_decl_statement] = sym_decl_statement,
  [sym_pipeline_reg_marker] = sym_pipeline_reg_marker,
  [sym_pipeline_stage_name] = sym_pipeline_stage_name,
  [sym__comptime_operator] = sym__comptime_operator,
  [sym_comptime_if] = sym_comptime_if,
  [sym_comptime_else] = sym_comptime_else,
  [sym_assert_statement] = sym_assert_statement,
  [sym_reg_reset] = sym_reg_reset,
  [sym_reg_initial] = sym_reg_initial,
  [sym__expression] = sym__expression,
  [sym_op_add] = sym_op_add,
  [sym_op_sub] = sym_op_sub,
  [sym_op_mul] = sym_op_mul,
  [sym_op_lt] = sym_op_lt,
  [sym_op_gt] = sym_op_gt,
  [sym_op_bitwise_and] = sym_op_bitwise_and,
  [sym__op_mul_like] = sym__op_mul_like,
  [sym__op_add_like] = sym__op_add_like,
  [sym__op_relational] = sym__op_relational,
  [sym__op_eq_like] = sym__op_eq_like,
  [sym__op_shifty] = sym__op_shifty,
  [sym_op_custom_infix] = sym_op_custom_infix,
  [sym_binary_expression] = sym_binary_expression,
  [sym_unary_expression] = sym_unary_expression,
  [sym_if_expression] = sym_if_expression,
  [sym_match_expression] = sym_match_expression,
  [sym_match_block] = sym_match_block,
  [sym_match_arm] = sym_match_arm,
  [sym_last_match_arm] = sym_match_arm,
  [sym__base_expression] = sym__base_expression,
  [sym__simple_base_expression] = sym__simple_base_expression,
  [sym_field_access] = sym_field_access,
  [sym_method_call] = sym_method_call,
  [sym_index] = sym_index,
  [sym_array_literal] = sym_array_literal,
  [sym_tuple_literal] = sym_tuple_literal,
  [sym_paren_expression] = sym_paren_expression,
  [sym_function_call] = sym_function_call,
  [sym_entity_instance] = sym_entity_instance,
  [sym_pipeline_instance] = sym_pipeline_instance,
  [sym_turbofish] = sym_turbofish,
  [sym_named_turbofish_arg] = sym_named_turbofish_arg,
  [sym_stage_reference] = sym_stage_reference,
  [sym_bool_literal] = sym_bool_literal,
  [sym_builtin_marker] = sym_builtin_marker,
  [sym_argument_list] = sym_argument_list,
  [sym__named_argument_list] = sym__named_argument_list,
  [sym__named_argument] = sym__named_argument,
  [sym__positional_argument_list] = sym__positional_argument_list,
  [sym_parameter_list] = sym_parameter_list,
  [sym_braced_parameter_list] = sym_braced_parameter_list,
  [sym_typed_parameter] = sym_typed_parameter,
  [sym_parameter] = sym_parameter,
  [sym__pattern] = sym__pattern,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym_named_unpack] = sym_named_unpack,
  [sym_positional_unpack] = sym_positional_unpack,
  [sym__named_pattern_list] = sym__named_pattern_list,
  [sym__positional_pattern_list] = sym__positional_pattern_list,
  [sym_named_pattern_param] = sym_named_pattern_param,
  [sym_type] = sym_type,
  [sym_tuple_type] = sym_tuple_type,
  [sym_array_type] = sym_array_type,
  [sym_wire] = sym_wire,
  [sym_inverted] = sym_inverted,
  [sym__generic_list] = sym__generic_list,
  [sym_generic_parameters] = sym_generic_parameters,
  [sym_generic_param] = sym_generic_param,
  [sym__base_type] = sym__base_type,
  [sym_builtin_type] = sym_builtin_type,
  [sym_scoped_identifier] = sym_scoped_identifier,
  [sym__path] = sym__path,
  [sym__scoped_or_raw_ident] = sym__scoped_or_raw_ident,
  [sym_int_literal] = sym_int_literal,
  [sym_block_comment] = sym_block_comment,
  [aux_sym_source_file_repeat1] = aux_sym_source_file_repeat1,
  [aux_sym__item_repeat1] = aux_sym__item_repeat1,
  [aux_sym_where_clause_repeat1] = aux_sym_where_clause_repeat1,
  [aux_sym_impl_repeat1] = aux_sym_impl_repeat1,
  [aux_sym_trait_repeat1] = aux_sym_trait_repeat1,
  [aux_sym_enum_body_repeat1] = aux_sym_enum_body_repeat1,
  [aux_sym_block_repeat1] = aux_sym_block_repeat1,
  [aux_sym_reg_statement_repeat1] = aux_sym_reg_statement_repeat1,
  [aux_sym_decl_statement_repeat1] = aux_sym_decl_statement_repeat1,
  [aux_sym_match_block_repeat1] = aux_sym_match_block_repeat1,
  [aux_sym_array_literal_repeat1] = aux_sym_array_literal_repeat1,
  [aux_sym_turbofish_repeat1] = aux_sym_turbofish_repeat1,
  [aux_sym_turbofish_repeat2] = aux_sym_turbofish_repeat2,
  [aux_sym__named_argument_list_repeat1] = aux_sym__named_argument_list_repeat1,
  [aux_sym__positional_argument_list_repeat1] = aux_sym__positional_argument_list_repeat1,
  [aux_sym_parameter_list_repeat1] = aux_sym_parameter_list_repeat1,
  [aux_sym_tuple_pattern_repeat1] = aux_sym_tuple_pattern_repeat1,
  [aux_sym__named_pattern_list_repeat1] = aux_sym__named_pattern_list_repeat1,
  [aux_sym_generic_parameters_repeat1] = aux_sym_generic_parameters_repeat1,
  [aux_sym_block_comment_repeat1] = aux_sym_block_comment_repeat1,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_POUND] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fn] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_entity] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pipeline] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_port] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_impl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_trait] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_mod] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLARconfig] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_reg] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_decl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLARif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLARelse] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_reset] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_initial] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [sym_op_div] = {
    .visible = true,
    .named = true,
  },
  [sym_op_mod] = {
    .visible = true,
    .named = true,
  },
  [sym_op_equals] = {
    .visible = true,
    .named = true,
  },
  [sym_op_ne] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_op_le] = {
    .visible = true,
    .named = true,
  },
  [sym_op_ge] = {
    .visible = true,
    .named = true,
  },
  [sym_op_lshift] = {
    .visible = true,
    .named = true,
  },
  [sym_op_rshift] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [sym_op_bitwise_xor] = {
    .visible = true,
    .named = true,
  },
  [sym_op_bitwise_or] = {
    .visible = true,
    .named = true,
  },
  [sym_op_logical_and] = {
    .visible = true,
    .named = true,
  },
  [sym_op_logical_or] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_match] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_inst] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON_DOLLAR_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stage] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___builtin__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_self] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_inv] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_int] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_bool] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_clock] = {
    .visible = true,
    .named = false,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_int_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_int_literal_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_int_literal_token3] = {
    .visible = false,
    .named = false,
  },
  [sym_doc_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_line_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_SLASH_STAR] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_block_comment_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_STAR_SLASH] = {
    .visible = true,
    .named = false,
  },
  [sym_source_file] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym__item] = {
    .visible = false,
    .named = true,
  },
  [sym_unit_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_unit_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__unit_head] = {
    .visible = false,
    .named = true,
  },
  [sym__pipeline_start] = {
    .visible = false,
    .named = true,
  },
  [sym_where_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_impl] = {
    .visible = true,
    .named = true,
  },
  [sym_trait] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_body] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_member] = {
    .visible = true,
    .named = true,
  },
  [sym_use] = {
    .visible = true,
    .named = true,
  },
  [sym_mod] = {
    .visible = true,
    .named = true,
  },
  [sym_comptime_config] = {
    .visible = true,
    .named = true,
  },
  [sym__body_or_builtin] = {
    .visible = false,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_let_binding] = {
    .visible = true,
    .named = true,
  },
  [sym_reg_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_set_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_decl_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline_reg_marker] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline_stage_name] = {
    .visible = true,
    .named = true,
  },
  [sym__comptime_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_comptime_if] = {
    .visible = true,
    .named = true,
  },
  [sym_comptime_else] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_reg_reset] = {
    .visible = true,
    .named = true,
  },
  [sym_reg_initial] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym_op_add] = {
    .visible = true,
    .named = true,
  },
  [sym_op_sub] = {
    .visible = true,
    .named = true,
  },
  [sym_op_mul] = {
    .visible = true,
    .named = true,
  },
  [sym_op_lt] = {
    .visible = true,
    .named = true,
  },
  [sym_op_gt] = {
    .visible = true,
    .named = true,
  },
  [sym_op_bitwise_and] = {
    .visible = true,
    .named = true,
  },
  [sym__op_mul_like] = {
    .visible = false,
    .named = true,
  },
  [sym__op_add_like] = {
    .visible = false,
    .named = true,
  },
  [sym__op_relational] = {
    .visible = false,
    .named = true,
  },
  [sym__op_eq_like] = {
    .visible = false,
    .named = true,
  },
  [sym__op_shifty] = {
    .visible = false,
    .named = true,
  },
  [sym_op_custom_infix] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_if_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_match_block] = {
    .visible = true,
    .named = true,
  },
  [sym_match_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_last_match_arm] = {
    .visible = true,
    .named = true,
  },
  [sym__base_expression] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_base_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_field_access] = {
    .visible = true,
    .named = true,
  },
  [sym_method_call] = {
    .visible = true,
    .named = true,
  },
  [sym_index] = {
    .visible = true,
    .named = true,
  },
  [sym_array_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_paren_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_function_call] = {
    .visible = true,
    .named = true,
  },
  [sym_entity_instance] = {
    .visible = true,
    .named = true,
  },
  [sym_pipeline_instance] = {
    .visible = true,
    .named = true,
  },
  [sym_turbofish] = {
    .visible = true,
    .named = true,
  },
  [sym_named_turbofish_arg] = {
    .visible = true,
    .named = true,
  },
  [sym_stage_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_bool_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_builtin_marker] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym__named_argument_list] = {
    .visible = false,
    .named = true,
  },
  [sym__named_argument] = {
    .visible = false,
    .named = true,
  },
  [sym__positional_argument_list] = {
    .visible = false,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_braced_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_named_unpack] = {
    .visible = true,
    .named = true,
  },
  [sym_positional_unpack] = {
    .visible = true,
    .named = true,
  },
  [sym__named_pattern_list] = {
    .visible = false,
    .named = true,
  },
  [sym__positional_pattern_list] = {
    .visible = false,
    .named = true,
  },
  [sym_named_pattern_param] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_wire] = {
    .visible = true,
    .named = true,
  },
  [sym_inverted] = {
    .visible = true,
    .named = true,
  },
  [sym__generic_list] = {
    .visible = false,
    .named = true,
  },
  [sym_generic_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_generic_param] = {
    .visible = true,
    .named = true,
  },
  [sym__base_type] = {
    .visible = false,
    .named = true,
  },
  [sym_builtin_type] = {
    .visible = true,
    .named = true,
  },
  [sym_scoped_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym__path] = {
    .visible = false,
    .named = true,
  },
  [sym__scoped_or_raw_ident] = {
    .visible = false,
    .named = true,
  },
  [sym_int_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_block_comment] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_source_file_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__item_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_where_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_impl_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_trait_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_reg_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decl_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_match_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_turbofish_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_turbofish_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__named_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__positional_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__named_pattern_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_generic_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_comment_repeat1] = {
    .visible = false,
    .named = false,
  },
};

enum ts_field_identifiers {
  field_base = 1,
  field_for = 2,
  field_meta = 3,
  field_name = 4,
  field_path = 5,
  field_pattern = 6,
  field_stage = 7,
  field_value = 8,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_base] = "base",
  [field_for] = "for",
  [field_meta] = "meta",
  [field_name] = "name",
  [field_path] = "path",
  [field_pattern] = "pattern",
  [field_stage] = "stage",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 2},
  [3] = {.index = 3, .length = 2},
  [4] = {.index = 5, .length = 2},
  [5] = {.index = 7, .length = 2},
  [6] = {.index = 9, .length = 2},
  [7] = {.index = 11, .length = 3},
  [8] = {.index = 14, .length = 1},
  [9] = {.index = 15, .length = 2},
  [10] = {.index = 17, .length = 3},
  [11] = {.index = 20, .length = 2},
  [12] = {.index = 22, .length = 2},
  [13] = {.index = 24, .length = 3},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 1},
  [1] =
    {field_name, 2},
    {field_path, 0},
  [3] =
    {field_meta, 0},
    {field_meta, 1},
  [5] =
    {field_for, 2},
    {field_for, 3},
  [7] =
    {field_base, 0},
    {field_name, 2},
  [9] =
    {field_for, 3},
    {field_for, 4},
  [11] =
    {field_for, 2},
    {field_for, 3},
    {field_for, 4},
  [14] =
    {field_stage, 2},
  [15] =
    {field_base, 0},
    {field_name, 3},
  [17] =
    {field_for, 3},
    {field_for, 4},
    {field_for, 5},
  [20] =
    {field_for, 4},
    {field_for, 5},
  [22] =
    {field_pattern, 0},
    {field_value, 2},
  [24] =
    {field_for, 4},
    {field_for, 5},
    {field_for, 6},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
};

static const uint16_t ts_non_terminal_alias_map[] = {
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 28,
  [29] = 29,
  [30] = 30,
  [31] = 31,
  [32] = 32,
  [33] = 33,
  [34] = 34,
  [35] = 35,
  [36] = 36,
  [37] = 37,
  [38] = 38,
  [39] = 14,
  [40] = 40,
  [41] = 41,
  [42] = 42,
  [43] = 43,
  [44] = 44,
  [45] = 45,
  [46] = 46,
  [47] = 47,
  [48] = 48,
  [49] = 49,
  [50] = 50,
  [51] = 51,
  [52] = 52,
  [53] = 53,
  [54] = 54,
  [55] = 55,
  [56] = 56,
  [57] = 57,
  [58] = 58,
  [59] = 59,
  [60] = 60,
  [61] = 61,
  [62] = 62,
  [63] = 63,
  [64] = 64,
  [65] = 65,
  [66] = 66,
  [67] = 67,
  [68] = 68,
  [69] = 69,
  [70] = 70,
  [71] = 71,
  [72] = 72,
  [73] = 73,
  [74] = 74,
  [75] = 75,
  [76] = 76,
  [77] = 77,
  [78] = 78,
  [79] = 79,
  [80] = 80,
  [81] = 81,
  [82] = 82,
  [83] = 83,
  [84] = 84,
  [85] = 85,
  [86] = 86,
  [87] = 87,
  [88] = 88,
  [89] = 89,
  [90] = 90,
  [91] = 91,
  [92] = 92,
  [93] = 93,
  [94] = 94,
  [95] = 95,
  [96] = 96,
  [97] = 97,
  [98] = 98,
  [99] = 99,
  [100] = 100,
  [101] = 101,
  [102] = 98,
  [103] = 103,
  [104] = 104,
  [105] = 105,
  [106] = 106,
  [107] = 107,
  [108] = 108,
  [109] = 109,
  [110] = 110,
  [111] = 111,
  [112] = 112,
  [113] = 113,
  [114] = 114,
  [115] = 115,
  [116] = 116,
  [117] = 117,
  [118] = 118,
  [119] = 119,
  [120] = 120,
  [121] = 121,
  [122] = 122,
  [123] = 123,
  [124] = 124,
  [125] = 125,
  [126] = 126,
  [127] = 127,
  [128] = 128,
  [129] = 129,
  [130] = 130,
  [131] = 131,
  [132] = 132,
  [133] = 133,
  [134] = 134,
  [135] = 135,
  [136] = 136,
  [137] = 137,
  [138] = 138,
  [139] = 139,
  [140] = 140,
  [141] = 141,
  [142] = 142,
  [143] = 143,
  [144] = 144,
  [145] = 145,
  [146] = 146,
  [147] = 147,
  [148] = 148,
  [149] = 149,
  [150] = 150,
  [151] = 151,
  [152] = 152,
  [153] = 153,
  [154] = 154,
  [155] = 155,
  [156] = 156,
  [157] = 157,
  [158] = 158,
  [159] = 159,
  [160] = 160,
  [161] = 161,
  [162] = 162,
  [163] = 163,
  [164] = 161,
  [165] = 165,
  [166] = 166,
  [167] = 160,
  [168] = 168,
  [169] = 163,
  [170] = 158,
  [171] = 166,
  [172] = 168,
  [173] = 173,
  [174] = 174,
  [175] = 175,
  [176] = 176,
  [177] = 177,
  [178] = 178,
  [179] = 179,
  [180] = 173,
  [181] = 181,
  [182] = 182,
  [183] = 183,
  [184] = 184,
  [185] = 185,
  [186] = 186,
  [187] = 187,
  [188] = 188,
  [189] = 189,
  [190] = 190,
  [191] = 191,
  [192] = 192,
  [193] = 193,
  [194] = 194,
  [195] = 195,
  [196] = 196,
  [197] = 197,
  [198] = 198,
  [199] = 182,
  [200] = 181,
  [201] = 184,
  [202] = 202,
  [203] = 203,
  [204] = 204,
  [205] = 181,
  [206] = 184,
  [207] = 188,
  [208] = 208,
  [209] = 209,
  [210] = 210,
  [211] = 211,
  [212] = 212,
  [213] = 213,
  [214] = 214,
  [215] = 215,
  [216] = 216,
  [217] = 217,
  [218] = 218,
  [219] = 67,
  [220] = 220,
  [221] = 220,
  [222] = 210,
  [223] = 212,
  [224] = 218,
  [225] = 225,
  [226] = 226,
  [227] = 227,
  [228] = 228,
  [229] = 229,
  [230] = 230,
  [231] = 231,
  [232] = 232,
  [233] = 233,
  [234] = 234,
  [235] = 235,
  [236] = 236,
  [237] = 237,
  [238] = 238,
  [239] = 239,
  [240] = 240,
  [241] = 241,
  [242] = 242,
  [243] = 243,
  [244] = 244,
  [245] = 245,
  [246] = 246,
  [247] = 247,
  [248] = 248,
  [249] = 249,
  [250] = 250,
  [251] = 251,
  [252] = 252,
  [253] = 253,
  [254] = 254,
  [255] = 255,
  [256] = 256,
  [257] = 257,
  [258] = 258,
  [259] = 259,
  [260] = 260,
  [261] = 261,
  [262] = 262,
  [263] = 263,
  [264] = 264,
  [265] = 265,
  [266] = 266,
  [267] = 267,
  [268] = 268,
  [269] = 269,
  [270] = 270,
  [271] = 271,
  [272] = 272,
  [273] = 273,
  [274] = 274,
  [275] = 275,
  [276] = 276,
  [277] = 277,
  [278] = 278,
  [279] = 279,
  [280] = 280,
  [281] = 281,
  [282] = 282,
  [283] = 283,
  [284] = 284,
  [285] = 285,
  [286] = 286,
  [287] = 287,
  [288] = 288,
  [289] = 289,
  [290] = 290,
  [291] = 291,
  [292] = 123,
  [293] = 134,
  [294] = 294,
  [295] = 150,
  [296] = 296,
  [297] = 297,
  [298] = 298,
  [299] = 299,
  [300] = 300,
  [301] = 301,
  [302] = 302,
  [303] = 303,
  [304] = 304,
  [305] = 305,
  [306] = 306,
  [307] = 307,
  [308] = 308,
  [309] = 309,
  [310] = 310,
  [311] = 311,
  [312] = 312,
  [313] = 313,
  [314] = 314,
  [315] = 297,
  [316] = 316,
  [317] = 317,
  [318] = 318,
  [319] = 319,
  [320] = 143,
  [321] = 147,
  [322] = 145,
  [323] = 323,
  [324] = 146,
  [325] = 148,
  [326] = 151,
  [327] = 149,
  [328] = 328,
  [329] = 329,
  [330] = 330,
  [331] = 331,
  [332] = 332,
  [333] = 333,
  [334] = 334,
  [335] = 335,
  [336] = 336,
  [337] = 337,
  [338] = 338,
  [339] = 339,
  [340] = 340,
  [341] = 341,
  [342] = 342,
  [343] = 343,
  [344] = 344,
  [345] = 71,
  [346] = 69,
  [347] = 347,
  [348] = 348,
  [349] = 349,
  [350] = 350,
  [351] = 351,
  [352] = 352,
  [353] = 353,
  [354] = 354,
  [355] = 355,
  [356] = 356,
  [357] = 357,
  [358] = 358,
  [359] = 359,
  [360] = 360,
  [361] = 361,
  [362] = 362,
  [363] = 70,
  [364] = 364,
  [365] = 365,
  [366] = 366,
  [367] = 367,
  [368] = 368,
  [369] = 369,
  [370] = 370,
  [371] = 371,
  [372] = 372,
  [373] = 373,
  [374] = 374,
  [375] = 375,
  [376] = 376,
  [377] = 377,
  [378] = 378,
  [379] = 379,
  [380] = 380,
  [381] = 381,
  [382] = 382,
  [383] = 383,
  [384] = 384,
  [385] = 385,
  [386] = 386,
  [387] = 387,
  [388] = 388,
  [389] = 389,
  [390] = 390,
  [391] = 391,
  [392] = 392,
  [393] = 393,
  [394] = 394,
  [395] = 395,
  [396] = 396,
  [397] = 397,
  [398] = 4,
  [399] = 399,
  [400] = 400,
  [401] = 401,
  [402] = 402,
  [403] = 403,
  [404] = 404,
  [405] = 405,
  [406] = 406,
  [407] = 407,
  [408] = 408,
  [409] = 409,
  [410] = 410,
  [411] = 411,
  [412] = 412,
  [413] = 413,
  [414] = 414,
  [415] = 415,
  [416] = 416,
  [417] = 417,
  [418] = 418,
  [419] = 407,
  [420] = 420,
  [421] = 421,
  [422] = 421,
  [423] = 423,
  [424] = 424,
  [425] = 425,
  [426] = 426,
  [427] = 427,
  [428] = 428,
  [429] = 429,
  [430] = 430,
  [431] = 431,
  [432] = 432,
  [433] = 414,
  [434] = 434,
  [435] = 236,
  [436] = 408,
  [437] = 437,
  [438] = 438,
  [439] = 439,
  [440] = 440,
  [441] = 441,
  [442] = 442,
  [443] = 443,
  [444] = 444,
  [445] = 445,
  [446] = 446,
  [447] = 447,
  [448] = 448,
  [449] = 449,
  [450] = 450,
  [451] = 451,
  [452] = 452,
  [453] = 453,
  [454] = 454,
  [455] = 455,
  [456] = 456,
  [457] = 457,
  [458] = 458,
  [459] = 459,
  [460] = 460,
  [461] = 461,
  [462] = 462,
  [463] = 463,
  [464] = 464,
  [465] = 465,
  [466] = 466,
  [467] = 467,
  [468] = 468,
  [469] = 469,
  [470] = 470,
  [471] = 471,
  [472] = 472,
  [473] = 473,
  [474] = 474,
  [475] = 475,
  [476] = 476,
  [477] = 477,
  [478] = 478,
  [479] = 479,
  [480] = 480,
  [481] = 481,
  [482] = 482,
  [483] = 483,
  [484] = 484,
  [485] = 485,
  [486] = 486,
  [487] = 487,
  [488] = 488,
  [489] = 489,
  [490] = 490,
  [491] = 491,
  [492] = 492,
  [493] = 493,
  [494] = 494,
  [495] = 495,
  [496] = 496,
  [497] = 497,
  [498] = 233,
  [499] = 499,
  [500] = 500,
  [501] = 501,
  [502] = 502,
  [503] = 503,
  [504] = 504,
  [505] = 505,
  [506] = 485,
  [507] = 489,
  [508] = 508,
  [509] = 509,
  [510] = 461,
  [511] = 465,
  [512] = 508,
  [513] = 459,
  [514] = 460,
  [515] = 515,
  [516] = 516,
  [517] = 517,
  [518] = 518,
  [519] = 519,
  [520] = 520,
  [521] = 521,
  [522] = 522,
  [523] = 523,
  [524] = 524,
  [525] = 525,
  [526] = 526,
  [527] = 527,
  [528] = 528,
  [529] = 529,
  [530] = 290,
  [531] = 235,
  [532] = 237,
  [533] = 533,
  [534] = 424,
  [535] = 535,
  [536] = 536,
  [537] = 537,
  [538] = 409,
  [539] = 539,
  [540] = 411,
  [541] = 423,
  [542] = 542,
  [543] = 543,
  [544] = 544,
  [545] = 545,
  [546] = 546,
  [547] = 547,
  [548] = 548,
  [549] = 549,
  [550] = 550,
  [551] = 551,
  [552] = 552,
  [553] = 553,
  [554] = 554,
  [555] = 291,
  [556] = 556,
  [557] = 557,
  [558] = 558,
  [559] = 559,
  [560] = 560,
  [561] = 561,
  [562] = 562,
  [563] = 563,
  [564] = 564,
  [565] = 288,
  [566] = 566,
  [567] = 567,
  [568] = 568,
  [569] = 569,
  [570] = 570,
  [571] = 571,
  [572] = 277,
  [573] = 281,
  [574] = 283,
  [575] = 282,
  [576] = 576,
  [577] = 577,
  [578] = 578,
  [579] = 579,
  [580] = 580,
  [581] = 276,
  [582] = 286,
  [583] = 280,
  [584] = 584,
  [585] = 279,
  [586] = 284,
  [587] = 587,
  [588] = 285,
  [589] = 287,
  [590] = 590,
  [591] = 278,
  [592] = 275,
  [593] = 593,
  [594] = 594,
  [595] = 595,
  [596] = 596,
  [597] = 597,
  [598] = 598,
  [599] = 599,
  [600] = 600,
  [601] = 560,
  [602] = 602,
  [603] = 603,
  [604] = 604,
  [605] = 605,
  [606] = 584,
  [607] = 607,
  [608] = 608,
  [609] = 609,
  [610] = 610,
  [611] = 611,
  [612] = 612,
  [613] = 613,
  [614] = 614,
  [615] = 615,
  [616] = 616,
  [617] = 617,
  [618] = 568,
  [619] = 619,
  [620] = 620,
  [621] = 621,
  [622] = 622,
  [623] = 623,
  [624] = 624,
  [625] = 625,
  [626] = 626,
  [627] = 608,
  [628] = 569,
  [629] = 577,
  [630] = 630,
  [631] = 631,
  [632] = 605,
  [633] = 559,
  [634] = 614,
  [635] = 587,
  [636] = 636,
  [637] = 637,
  [638] = 607,
  [639] = 570,
  [640] = 630,
  [641] = 641,
  [642] = 642,
};

static TSCharacterRange sym_identifier_character_set_1[] = {
  {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xba, 0xba}, {0xc0, 0xd6}, {0xd8, 0xf6},
  {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x370, 0x374}, {0x376, 0x377}, {0x37b, 0x37d},
  {0x37f, 0x37f}, {0x386, 0x386}, {0x388, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481}, {0x48a, 0x52f},
  {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x620, 0x64a}, {0x66e, 0x66f}, {0x671, 0x6d3},
  {0x6d5, 0x6d5}, {0x6e5, 0x6e6}, {0x6ee, 0x6ef}, {0x6fa, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x710}, {0x712, 0x72f}, {0x74d, 0x7a5},
  {0x7b1, 0x7b1}, {0x7ca, 0x7ea}, {0x7f4, 0x7f5}, {0x7fa, 0x7fa}, {0x800, 0x815}, {0x81a, 0x81a}, {0x824, 0x824}, {0x828, 0x828},
  {0x840, 0x858}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x8a0, 0x8c9}, {0x904, 0x939}, {0x93d, 0x93d}, {0x950, 0x950},
  {0x958, 0x961}, {0x971, 0x980}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9},
  {0x9bd, 0x9bd}, {0x9ce, 0x9ce}, {0x9dc, 0x9dd}, {0x9df, 0x9e1}, {0x9f0, 0x9f1}, {0x9fc, 0x9fc}, {0xa05, 0xa0a}, {0xa0f, 0xa10},
  {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa72, 0xa74},
  {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabd, 0xabd}, {0xad0, 0xad0},
  {0xae0, 0xae1}, {0xaf9, 0xaf9}, {0xb05, 0xb0c}, {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39},
  {0xb3d, 0xb3d}, {0xb5c, 0xb5d}, {0xb5f, 0xb61}, {0xb71, 0xb71}, {0xb83, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90}, {0xb92, 0xb95},
  {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbd0, 0xbd0}, {0xc05, 0xc0c},
  {0xc0e, 0xc10}, {0xc12, 0xc28}, {0xc2a, 0xc39}, {0xc3d, 0xc3d}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc61}, {0xc80, 0xc80},
  {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbd, 0xcbd}, {0xcdd, 0xcde}, {0xce0, 0xce1},
  {0xcf1, 0xcf2}, {0xd04, 0xd0c}, {0xd0e, 0xd10}, {0xd12, 0xd3a}, {0xd3d, 0xd3d}, {0xd4e, 0xd4e}, {0xd54, 0xd56}, {0xd5f, 0xd61},
  {0xd7a, 0xd7f}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xe01, 0xe30}, {0xe32, 0xe32},
  {0xe40, 0xe46}, {0xe81, 0xe82}, {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xeb0}, {0xeb2, 0xeb2},
  {0xebd, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf40, 0xf47}, {0xf49, 0xf6c}, {0xf88, 0xf8c},
  {0x1000, 0x102a}, {0x103f, 0x103f}, {0x1050, 0x1055}, {0x105a, 0x105d}, {0x1061, 0x1061}, {0x1065, 0x1066}, {0x106e, 0x1070}, {0x1075, 0x1081},
  {0x108e, 0x108e}, {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256},
  {0x1258, 0x1258}, {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0},
  {0x12c2, 0x12c5}, {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x1380, 0x138f}, {0x13a0, 0x13f5}, {0x13f8, 0x13fd},
  {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1711}, {0x171f, 0x1731}, {0x1740, 0x1751},
  {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1780, 0x17b3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dc}, {0x1820, 0x1878}, {0x1880, 0x18a8}, {0x18aa, 0x18aa},
  {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1950, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x1a00, 0x1a16}, {0x1a20, 0x1a54},
  {0x1aa7, 0x1aa7}, {0x1b05, 0x1b33}, {0x1b45, 0x1b4c}, {0x1b83, 0x1ba0}, {0x1bae, 0x1baf}, {0x1bba, 0x1be5}, {0x1c00, 0x1c23}, {0x1c4d, 0x1c4f},
  {0x1c5a, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1ce9, 0x1cec}, {0x1cee, 0x1cf3}, {0x1cf5, 0x1cf6}, {0x1cfa, 0x1cfa},
  {0x1d00, 0x1dbf}, {0x1e00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x2071, 0x2071}, {0x207f, 0x207f}, {0x2090, 0x209c}, {0x2102, 0x2102},
  {0x2107, 0x2107}, {0x210a, 0x2113}, {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139},
  {0x213c, 0x213f}, {0x2145, 0x2149}, {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cee}, {0x2cf2, 0x2cf3}, {0x2d00, 0x2d25},
  {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67}, {0x2d6f, 0x2d6f}, {0x2d80, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6},
  {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce}, {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x3005, 0x3007}, {0x3021, 0x3029}, {0x3031, 0x3035},
  {0x3038, 0x303c}, {0x3041, 0x3096}, {0x309d, 0x309f}, {0x30a1, 0x30fa}, {0x30fc, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf},
  {0x31f0, 0x31ff}, {0x3400, 0x4dbf}, {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa61f}, {0xa62a, 0xa62b}, {0xa640, 0xa66e},
  {0xa67f, 0xa69d}, {0xa6a0, 0xa6ef}, {0xa717, 0xa71f}, {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9},
  {0xa7f2, 0xa801}, {0xa803, 0xa805}, {0xa807, 0xa80a}, {0xa80c, 0xa822}, {0xa840, 0xa873}, {0xa882, 0xa8b3}, {0xa8f2, 0xa8f7}, {0xa8fb, 0xa8fb},
  {0xa8fd, 0xa8fe}, {0xa90a, 0xa925}, {0xa930, 0xa946}, {0xa960, 0xa97c}, {0xa984, 0xa9b2}, {0xa9cf, 0xa9cf}, {0xa9e0, 0xa9e4}, {0xa9e6, 0xa9ef},
  {0xa9fa, 0xa9fe}, {0xaa00, 0xaa28}, {0xaa40, 0xaa42}, {0xaa44, 0xaa4b}, {0xaa60, 0xaa76}, {0xaa7a, 0xaa7a}, {0xaa7e, 0xaaaf}, {0xaab1, 0xaab1},
  {0xaab5, 0xaab6}, {0xaab9, 0xaabd}, {0xaac0, 0xaac0}, {0xaac2, 0xaac2}, {0xaadb, 0xaadd}, {0xaae0, 0xaaea}, {0xaaf2, 0xaaf4}, {0xab01, 0xab06},
  {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a}, {0xab5c, 0xab69}, {0xab70, 0xabe2}, {0xac00, 0xd7a3},
  {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d}, {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb1d}, {0xfb1f, 0xfb28},
  {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41}, {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d},
  {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff21, 0xff3a}, {0xff41, 0xff5a}, {0xff66, 0xff9d}, {0xffa0, 0xffbe}, {0xffc2, 0xffc7}, {0xffca, 0xffcf},
  {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d}, {0x10050, 0x1005d},
  {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x10300, 0x1031f}, {0x1032d, 0x1034a}, {0x10350, 0x10375}, {0x10380, 0x1039d},
  {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563},
  {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595}, {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc},
  {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785}, {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808},
  {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855}, {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5},
  {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf}, {0x10a00, 0x10a00}, {0x10a10, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35},
  {0x10a60, 0x10a7c}, {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae4}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91},
  {0x10c00, 0x10c48}, {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d23}, {0x10e80, 0x10ea9}, {0x10eb0, 0x10eb1}, {0x10f00, 0x10f1c}, {0x10f27, 0x10f27},
  {0x10f30, 0x10f45}, {0x10f70, 0x10f81}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11003, 0x11037}, {0x11071, 0x11072}, {0x11075, 0x11075}, {0x11083, 0x110af},
  {0x110d0, 0x110e8}, {0x11103, 0x11126}, {0x11144, 0x11144}, {0x11147, 0x11147}, {0x11150, 0x11172}, {0x11176, 0x11176}, {0x11183, 0x111b2}, {0x111c1, 0x111c4},
  {0x111da, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x1122b}, {0x1123f, 0x11240}, {0x11280, 0x11286}, {0x11288, 0x11288}, {0x1128a, 0x1128d},
  {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112de}, {0x11305, 0x1130c}, {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333},
  {0x11335, 0x11339}, {0x1133d, 0x1133d}, {0x11350, 0x11350}, {0x1135d, 0x11361}, {0x11400, 0x11434}, {0x11447, 0x1144a}, {0x1145f, 0x11461}, {0x11480, 0x114af},
  {0x114c4, 0x114c5}, {0x114c7, 0x114c7}, {0x11580, 0x115ae}, {0x115d8, 0x115db}, {0x11600, 0x1162f}, {0x11644, 0x11644}, {0x11680, 0x116aa}, {0x116b8, 0x116b8},
  {0x11700, 0x1171a}, {0x11740, 0x11746}, {0x11800, 0x1182b}, {0x118a0, 0x118df}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916},
  {0x11918, 0x1192f}, {0x1193f, 0x1193f}, {0x11941, 0x11941}, {0x119a0, 0x119a7}, {0x119aa, 0x119d0}, {0x119e1, 0x119e1}, {0x119e3, 0x119e3}, {0x11a00, 0x11a00},
  {0x11a0b, 0x11a32}, {0x11a3a, 0x11a3a}, {0x11a50, 0x11a50}, {0x11a5c, 0x11a89}, {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c2e},
  {0x11c40, 0x11c40}, {0x11c72, 0x11c8f}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d30}, {0x11d46, 0x11d46}, {0x11d60, 0x11d65}, {0x11d67, 0x11d68},
  {0x11d6a, 0x11d89}, {0x11d98, 0x11d98}, {0x11ee0, 0x11ef2}, {0x11f02, 0x11f02}, {0x11f04, 0x11f10}, {0x11f12, 0x11f33}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399},
  {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0}, {0x13000, 0x1342f}, {0x13441, 0x13446}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e},
  {0x16a70, 0x16abe}, {0x16ad0, 0x16aed}, {0x16b00, 0x16b2f}, {0x16b40, 0x16b43}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f}, {0x16f00, 0x16f4a},
  {0x16f50, 0x16f50}, {0x16f93, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe3}, {0x17000, 0x187f7}, {0x18800, 0x18cd5}, {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3},
  {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155}, {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb},
  {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1d400, 0x1d454}, {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2},
  {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3}, {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514},
  {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546}, {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0},
  {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e}, {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8},
  {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e030, 0x1e06d}, {0x1e100, 0x1e12c}, {0x1e137, 0x1e13d}, {0x1e14e, 0x1e14e},
  {0x1e290, 0x1e2ad}, {0x1e2c0, 0x1e2eb}, {0x1e4d0, 0x1e4eb}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe}, {0x1e800, 0x1e8c4},
  {0x1e900, 0x1e943}, {0x1e94b, 0x1e94b}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24}, {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32},
  {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49}, {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f},
  {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d}, {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62},
  {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e}, {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b},
  {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739}, {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0},
  {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af},
};

static TSCharacterRange sym_identifier_character_set_2[] = {
  {'0', '9'}, {'A', 'Z'}, {'_', '_'}, {'a', 'z'}, {0xaa, 0xaa}, {0xb5, 0xb5}, {0xb7, 0xb7}, {0xba, 0xba},
  {0xc0, 0xd6}, {0xd8, 0xf6}, {0xf8, 0x2c1}, {0x2c6, 0x2d1}, {0x2e0, 0x2e4}, {0x2ec, 0x2ec}, {0x2ee, 0x2ee}, {0x300, 0x374},
  {0x376, 0x377}, {0x37b, 0x37d}, {0x37f, 0x37f}, {0x386, 0x38a}, {0x38c, 0x38c}, {0x38e, 0x3a1}, {0x3a3, 0x3f5}, {0x3f7, 0x481},
  {0x483, 0x487}, {0x48a, 0x52f}, {0x531, 0x556}, {0x559, 0x559}, {0x560, 0x588}, {0x591, 0x5bd}, {0x5bf, 0x5bf}, {0x5c1, 0x5c2},
  {0x5c4, 0x5c5}, {0x5c7, 0x5c7}, {0x5d0, 0x5ea}, {0x5ef, 0x5f2}, {0x610, 0x61a}, {0x620, 0x669}, {0x66e, 0x6d3}, {0x6d5, 0x6dc},
  {0x6df, 0x6e8}, {0x6ea, 0x6fc}, {0x6ff, 0x6ff}, {0x710, 0x74a}, {0x74d, 0x7b1}, {0x7c0, 0x7f5}, {0x7fa, 0x7fa}, {0x7fd, 0x7fd},
  {0x800, 0x82d}, {0x840, 0x85b}, {0x860, 0x86a}, {0x870, 0x887}, {0x889, 0x88e}, {0x898, 0x8e1}, {0x8e3, 0x963}, {0x966, 0x96f},
  {0x971, 0x983}, {0x985, 0x98c}, {0x98f, 0x990}, {0x993, 0x9a8}, {0x9aa, 0x9b0}, {0x9b2, 0x9b2}, {0x9b6, 0x9b9}, {0x9bc, 0x9c4},
  {0x9c7, 0x9c8}, {0x9cb, 0x9ce}, {0x9d7, 0x9d7}, {0x9dc, 0x9dd}, {0x9df, 0x9e3}, {0x9e6, 0x9f1}, {0x9fc, 0x9fc}, {0x9fe, 0x9fe},
  {0xa01, 0xa03}, {0xa05, 0xa0a}, {0xa0f, 0xa10}, {0xa13, 0xa28}, {0xa2a, 0xa30}, {0xa32, 0xa33}, {0xa35, 0xa36}, {0xa38, 0xa39},
  {0xa3c, 0xa3c}, {0xa3e, 0xa42}, {0xa47, 0xa48}, {0xa4b, 0xa4d}, {0xa51, 0xa51}, {0xa59, 0xa5c}, {0xa5e, 0xa5e}, {0xa66, 0xa75},
  {0xa81, 0xa83}, {0xa85, 0xa8d}, {0xa8f, 0xa91}, {0xa93, 0xaa8}, {0xaaa, 0xab0}, {0xab2, 0xab3}, {0xab5, 0xab9}, {0xabc, 0xac5},
  {0xac7, 0xac9}, {0xacb, 0xacd}, {0xad0, 0xad0}, {0xae0, 0xae3}, {0xae6, 0xaef}, {0xaf9, 0xaff}, {0xb01, 0xb03}, {0xb05, 0xb0c},
  {0xb0f, 0xb10}, {0xb13, 0xb28}, {0xb2a, 0xb30}, {0xb32, 0xb33}, {0xb35, 0xb39}, {0xb3c, 0xb44}, {0xb47, 0xb48}, {0xb4b, 0xb4d},
  {0xb55, 0xb57}, {0xb5c, 0xb5d}, {0xb5f, 0xb63}, {0xb66, 0xb6f}, {0xb71, 0xb71}, {0xb82, 0xb83}, {0xb85, 0xb8a}, {0xb8e, 0xb90},
  {0xb92, 0xb95}, {0xb99, 0xb9a}, {0xb9c, 0xb9c}, {0xb9e, 0xb9f}, {0xba3, 0xba4}, {0xba8, 0xbaa}, {0xbae, 0xbb9}, {0xbbe, 0xbc2},
  {0xbc6, 0xbc8}, {0xbca, 0xbcd}, {0xbd0, 0xbd0}, {0xbd7, 0xbd7}, {0xbe6, 0xbef}, {0xc00, 0xc0c}, {0xc0e, 0xc10}, {0xc12, 0xc28},
  {0xc2a, 0xc39}, {0xc3c, 0xc44}, {0xc46, 0xc48}, {0xc4a, 0xc4d}, {0xc55, 0xc56}, {0xc58, 0xc5a}, {0xc5d, 0xc5d}, {0xc60, 0xc63},
  {0xc66, 0xc6f}, {0xc80, 0xc83}, {0xc85, 0xc8c}, {0xc8e, 0xc90}, {0xc92, 0xca8}, {0xcaa, 0xcb3}, {0xcb5, 0xcb9}, {0xcbc, 0xcc4},
  {0xcc6, 0xcc8}, {0xcca, 0xccd}, {0xcd5, 0xcd6}, {0xcdd, 0xcde}, {0xce0, 0xce3}, {0xce6, 0xcef}, {0xcf1, 0xcf3}, {0xd00, 0xd0c},
  {0xd0e, 0xd10}, {0xd12, 0xd44}, {0xd46, 0xd48}, {0xd4a, 0xd4e}, {0xd54, 0xd57}, {0xd5f, 0xd63}, {0xd66, 0xd6f}, {0xd7a, 0xd7f},
  {0xd81, 0xd83}, {0xd85, 0xd96}, {0xd9a, 0xdb1}, {0xdb3, 0xdbb}, {0xdbd, 0xdbd}, {0xdc0, 0xdc6}, {0xdca, 0xdca}, {0xdcf, 0xdd4},
  {0xdd6, 0xdd6}, {0xdd8, 0xddf}, {0xde6, 0xdef}, {0xdf2, 0xdf3}, {0xe01, 0xe3a}, {0xe40, 0xe4e}, {0xe50, 0xe59}, {0xe81, 0xe82},
  {0xe84, 0xe84}, {0xe86, 0xe8a}, {0xe8c, 0xea3}, {0xea5, 0xea5}, {0xea7, 0xebd}, {0xec0, 0xec4}, {0xec6, 0xec6}, {0xec8, 0xece},
  {0xed0, 0xed9}, {0xedc, 0xedf}, {0xf00, 0xf00}, {0xf18, 0xf19}, {0xf20, 0xf29}, {0xf35, 0xf35}, {0xf37, 0xf37}, {0xf39, 0xf39},
  {0xf3e, 0xf47}, {0xf49, 0xf6c}, {0xf71, 0xf84}, {0xf86, 0xf97}, {0xf99, 0xfbc}, {0xfc6, 0xfc6}, {0x1000, 0x1049}, {0x1050, 0x109d},
  {0x10a0, 0x10c5}, {0x10c7, 0x10c7}, {0x10cd, 0x10cd}, {0x10d0, 0x10fa}, {0x10fc, 0x1248}, {0x124a, 0x124d}, {0x1250, 0x1256}, {0x1258, 0x1258},
  {0x125a, 0x125d}, {0x1260, 0x1288}, {0x128a, 0x128d}, {0x1290, 0x12b0}, {0x12b2, 0x12b5}, {0x12b8, 0x12be}, {0x12c0, 0x12c0}, {0x12c2, 0x12c5},
  {0x12c8, 0x12d6}, {0x12d8, 0x1310}, {0x1312, 0x1315}, {0x1318, 0x135a}, {0x135d, 0x135f}, {0x1369, 0x1371}, {0x1380, 0x138f}, {0x13a0, 0x13f5},
  {0x13f8, 0x13fd}, {0x1401, 0x166c}, {0x166f, 0x167f}, {0x1681, 0x169a}, {0x16a0, 0x16ea}, {0x16ee, 0x16f8}, {0x1700, 0x1715}, {0x171f, 0x1734},
  {0x1740, 0x1753}, {0x1760, 0x176c}, {0x176e, 0x1770}, {0x1772, 0x1773}, {0x1780, 0x17d3}, {0x17d7, 0x17d7}, {0x17dc, 0x17dd}, {0x17e0, 0x17e9},
  {0x180b, 0x180d}, {0x180f, 0x1819}, {0x1820, 0x1878}, {0x1880, 0x18aa}, {0x18b0, 0x18f5}, {0x1900, 0x191e}, {0x1920, 0x192b}, {0x1930, 0x193b},
  {0x1946, 0x196d}, {0x1970, 0x1974}, {0x1980, 0x19ab}, {0x19b0, 0x19c9}, {0x19d0, 0x19da}, {0x1a00, 0x1a1b}, {0x1a20, 0x1a5e}, {0x1a60, 0x1a7c},
  {0x1a7f, 0x1a89}, {0x1a90, 0x1a99}, {0x1aa7, 0x1aa7}, {0x1ab0, 0x1abd}, {0x1abf, 0x1ace}, {0x1b00, 0x1b4c}, {0x1b50, 0x1b59}, {0x1b6b, 0x1b73},
  {0x1b80, 0x1bf3}, {0x1c00, 0x1c37}, {0x1c40, 0x1c49}, {0x1c4d, 0x1c7d}, {0x1c80, 0x1c88}, {0x1c90, 0x1cba}, {0x1cbd, 0x1cbf}, {0x1cd0, 0x1cd2},
  {0x1cd4, 0x1cfa}, {0x1d00, 0x1f15}, {0x1f18, 0x1f1d}, {0x1f20, 0x1f45}, {0x1f48, 0x1f4d}, {0x1f50, 0x1f57}, {0x1f59, 0x1f59}, {0x1f5b, 0x1f5b},
  {0x1f5d, 0x1f5d}, {0x1f5f, 0x1f7d}, {0x1f80, 0x1fb4}, {0x1fb6, 0x1fbc}, {0x1fbe, 0x1fbe}, {0x1fc2, 0x1fc4}, {0x1fc6, 0x1fcc}, {0x1fd0, 0x1fd3},
  {0x1fd6, 0x1fdb}, {0x1fe0, 0x1fec}, {0x1ff2, 0x1ff4}, {0x1ff6, 0x1ffc}, {0x200c, 0x200d}, {0x203f, 0x2040}, {0x2054, 0x2054}, {0x2071, 0x2071},
  {0x207f, 0x207f}, {0x2090, 0x209c}, {0x20d0, 0x20dc}, {0x20e1, 0x20e1}, {0x20e5, 0x20f0}, {0x2102, 0x2102}, {0x2107, 0x2107}, {0x210a, 0x2113},
  {0x2115, 0x2115}, {0x2118, 0x211d}, {0x2124, 0x2124}, {0x2126, 0x2126}, {0x2128, 0x2128}, {0x212a, 0x2139}, {0x213c, 0x213f}, {0x2145, 0x2149},
  {0x214e, 0x214e}, {0x2160, 0x2188}, {0x2c00, 0x2ce4}, {0x2ceb, 0x2cf3}, {0x2d00, 0x2d25}, {0x2d27, 0x2d27}, {0x2d2d, 0x2d2d}, {0x2d30, 0x2d67},
  {0x2d6f, 0x2d6f}, {0x2d7f, 0x2d96}, {0x2da0, 0x2da6}, {0x2da8, 0x2dae}, {0x2db0, 0x2db6}, {0x2db8, 0x2dbe}, {0x2dc0, 0x2dc6}, {0x2dc8, 0x2dce},
  {0x2dd0, 0x2dd6}, {0x2dd8, 0x2dde}, {0x2de0, 0x2dff}, {0x3005, 0x3007}, {0x3021, 0x302f}, {0x3031, 0x3035}, {0x3038, 0x303c}, {0x3041, 0x3096},
  {0x3099, 0x309a}, {0x309d, 0x309f}, {0x30a1, 0x30ff}, {0x3105, 0x312f}, {0x3131, 0x318e}, {0x31a0, 0x31bf}, {0x31f0, 0x31ff}, {0x3400, 0x4dbf},
  {0x4e00, 0xa48c}, {0xa4d0, 0xa4fd}, {0xa500, 0xa60c}, {0xa610, 0xa62b}, {0xa640, 0xa66f}, {0xa674, 0xa67d}, {0xa67f, 0xa6f1}, {0xa717, 0xa71f},
  {0xa722, 0xa788}, {0xa78b, 0xa7ca}, {0xa7d0, 0xa7d1}, {0xa7d3, 0xa7d3}, {0xa7d5, 0xa7d9}, {0xa7f2, 0xa827}, {0xa82c, 0xa82c}, {0xa840, 0xa873},
  {0xa880, 0xa8c5}, {0xa8d0, 0xa8d9}, {0xa8e0, 0xa8f7}, {0xa8fb, 0xa8fb}, {0xa8fd, 0xa92d}, {0xa930, 0xa953}, {0xa960, 0xa97c}, {0xa980, 0xa9c0},
  {0xa9cf, 0xa9d9}, {0xa9e0, 0xa9fe}, {0xaa00, 0xaa36}, {0xaa40, 0xaa4d}, {0xaa50, 0xaa59}, {0xaa60, 0xaa76}, {0xaa7a, 0xaac2}, {0xaadb, 0xaadd},
  {0xaae0, 0xaaef}, {0xaaf2, 0xaaf6}, {0xab01, 0xab06}, {0xab09, 0xab0e}, {0xab11, 0xab16}, {0xab20, 0xab26}, {0xab28, 0xab2e}, {0xab30, 0xab5a},
  {0xab5c, 0xab69}, {0xab70, 0xabea}, {0xabec, 0xabed}, {0xabf0, 0xabf9}, {0xac00, 0xd7a3}, {0xd7b0, 0xd7c6}, {0xd7cb, 0xd7fb}, {0xf900, 0xfa6d},
  {0xfa70, 0xfad9}, {0xfb00, 0xfb06}, {0xfb13, 0xfb17}, {0xfb1d, 0xfb28}, {0xfb2a, 0xfb36}, {0xfb38, 0xfb3c}, {0xfb3e, 0xfb3e}, {0xfb40, 0xfb41},
  {0xfb43, 0xfb44}, {0xfb46, 0xfbb1}, {0xfbd3, 0xfc5d}, {0xfc64, 0xfd3d}, {0xfd50, 0xfd8f}, {0xfd92, 0xfdc7}, {0xfdf0, 0xfdf9}, {0xfe00, 0xfe0f},
  {0xfe20, 0xfe2f}, {0xfe33, 0xfe34}, {0xfe4d, 0xfe4f}, {0xfe71, 0xfe71}, {0xfe73, 0xfe73}, {0xfe77, 0xfe77}, {0xfe79, 0xfe79}, {0xfe7b, 0xfe7b},
  {0xfe7d, 0xfe7d}, {0xfe7f, 0xfefc}, {0xff10, 0xff19}, {0xff21, 0xff3a}, {0xff3f, 0xff3f}, {0xff41, 0xff5a}, {0xff65, 0xffbe}, {0xffc2, 0xffc7},
  {0xffca, 0xffcf}, {0xffd2, 0xffd7}, {0xffda, 0xffdc}, {0x10000, 0x1000b}, {0x1000d, 0x10026}, {0x10028, 0x1003a}, {0x1003c, 0x1003d}, {0x1003f, 0x1004d},
  {0x10050, 0x1005d}, {0x10080, 0x100fa}, {0x10140, 0x10174}, {0x101fd, 0x101fd}, {0x10280, 0x1029c}, {0x102a0, 0x102d0}, {0x102e0, 0x102e0}, {0x10300, 0x1031f},
  {0x1032d, 0x1034a}, {0x10350, 0x1037a}, {0x10380, 0x1039d}, {0x103a0, 0x103c3}, {0x103c8, 0x103cf}, {0x103d1, 0x103d5}, {0x10400, 0x1049d}, {0x104a0, 0x104a9},
  {0x104b0, 0x104d3}, {0x104d8, 0x104fb}, {0x10500, 0x10527}, {0x10530, 0x10563}, {0x10570, 0x1057a}, {0x1057c, 0x1058a}, {0x1058c, 0x10592}, {0x10594, 0x10595},
  {0x10597, 0x105a1}, {0x105a3, 0x105b1}, {0x105b3, 0x105b9}, {0x105bb, 0x105bc}, {0x10600, 0x10736}, {0x10740, 0x10755}, {0x10760, 0x10767}, {0x10780, 0x10785},
  {0x10787, 0x107b0}, {0x107b2, 0x107ba}, {0x10800, 0x10805}, {0x10808, 0x10808}, {0x1080a, 0x10835}, {0x10837, 0x10838}, {0x1083c, 0x1083c}, {0x1083f, 0x10855},
  {0x10860, 0x10876}, {0x10880, 0x1089e}, {0x108e0, 0x108f2}, {0x108f4, 0x108f5}, {0x10900, 0x10915}, {0x10920, 0x10939}, {0x10980, 0x109b7}, {0x109be, 0x109bf},
  {0x10a00, 0x10a03}, {0x10a05, 0x10a06}, {0x10a0c, 0x10a13}, {0x10a15, 0x10a17}, {0x10a19, 0x10a35}, {0x10a38, 0x10a3a}, {0x10a3f, 0x10a3f}, {0x10a60, 0x10a7c},
  {0x10a80, 0x10a9c}, {0x10ac0, 0x10ac7}, {0x10ac9, 0x10ae6}, {0x10b00, 0x10b35}, {0x10b40, 0x10b55}, {0x10b60, 0x10b72}, {0x10b80, 0x10b91}, {0x10c00, 0x10c48},
  {0x10c80, 0x10cb2}, {0x10cc0, 0x10cf2}, {0x10d00, 0x10d27}, {0x10d30, 0x10d39}, {0x10e80, 0x10ea9}, {0x10eab, 0x10eac}, {0x10eb0, 0x10eb1}, {0x10efd, 0x10f1c},
  {0x10f27, 0x10f27}, {0x10f30, 0x10f50}, {0x10f70, 0x10f85}, {0x10fb0, 0x10fc4}, {0x10fe0, 0x10ff6}, {0x11000, 0x11046}, {0x11066, 0x11075}, {0x1107f, 0x110ba},
  {0x110c2, 0x110c2}, {0x110d0, 0x110e8}, {0x110f0, 0x110f9}, {0x11100, 0x11134}, {0x11136, 0x1113f}, {0x11144, 0x11147}, {0x11150, 0x11173}, {0x11176, 0x11176},
  {0x11180, 0x111c4}, {0x111c9, 0x111cc}, {0x111ce, 0x111da}, {0x111dc, 0x111dc}, {0x11200, 0x11211}, {0x11213, 0x11237}, {0x1123e, 0x11241}, {0x11280, 0x11286},
  {0x11288, 0x11288}, {0x1128a, 0x1128d}, {0x1128f, 0x1129d}, {0x1129f, 0x112a8}, {0x112b0, 0x112ea}, {0x112f0, 0x112f9}, {0x11300, 0x11303}, {0x11305, 0x1130c},
  {0x1130f, 0x11310}, {0x11313, 0x11328}, {0x1132a, 0x11330}, {0x11332, 0x11333}, {0x11335, 0x11339}, {0x1133b, 0x11344}, {0x11347, 0x11348}, {0x1134b, 0x1134d},
  {0x11350, 0x11350}, {0x11357, 0x11357}, {0x1135d, 0x11363}, {0x11366, 0x1136c}, {0x11370, 0x11374}, {0x11400, 0x1144a}, {0x11450, 0x11459}, {0x1145e, 0x11461},
  {0x11480, 0x114c5}, {0x114c7, 0x114c7}, {0x114d0, 0x114d9}, {0x11580, 0x115b5}, {0x115b8, 0x115c0}, {0x115d8, 0x115dd}, {0x11600, 0x11640}, {0x11644, 0x11644},
  {0x11650, 0x11659}, {0x11680, 0x116b8}, {0x116c0, 0x116c9}, {0x11700, 0x1171a}, {0x1171d, 0x1172b}, {0x11730, 0x11739}, {0x11740, 0x11746}, {0x11800, 0x1183a},
  {0x118a0, 0x118e9}, {0x118ff, 0x11906}, {0x11909, 0x11909}, {0x1190c, 0x11913}, {0x11915, 0x11916}, {0x11918, 0x11935}, {0x11937, 0x11938}, {0x1193b, 0x11943},
  {0x11950, 0x11959}, {0x119a0, 0x119a7}, {0x119aa, 0x119d7}, {0x119da, 0x119e1}, {0x119e3, 0x119e4}, {0x11a00, 0x11a3e}, {0x11a47, 0x11a47}, {0x11a50, 0x11a99},
  {0x11a9d, 0x11a9d}, {0x11ab0, 0x11af8}, {0x11c00, 0x11c08}, {0x11c0a, 0x11c36}, {0x11c38, 0x11c40}, {0x11c50, 0x11c59}, {0x11c72, 0x11c8f}, {0x11c92, 0x11ca7},
  {0x11ca9, 0x11cb6}, {0x11d00, 0x11d06}, {0x11d08, 0x11d09}, {0x11d0b, 0x11d36}, {0x11d3a, 0x11d3a}, {0x11d3c, 0x11d3d}, {0x11d3f, 0x11d47}, {0x11d50, 0x11d59},
  {0x11d60, 0x11d65}, {0x11d67, 0x11d68}, {0x11d6a, 0x11d8e}, {0x11d90, 0x11d91}, {0x11d93, 0x11d98}, {0x11da0, 0x11da9}, {0x11ee0, 0x11ef6}, {0x11f00, 0x11f10},
  {0x11f12, 0x11f3a}, {0x11f3e, 0x11f42}, {0x11f50, 0x11f59}, {0x11fb0, 0x11fb0}, {0x12000, 0x12399}, {0x12400, 0x1246e}, {0x12480, 0x12543}, {0x12f90, 0x12ff0},
  {0x13000, 0x1342f}, {0x13440, 0x13455}, {0x14400, 0x14646}, {0x16800, 0x16a38}, {0x16a40, 0x16a5e}, {0x16a60, 0x16a69}, {0x16a70, 0x16abe}, {0x16ac0, 0x16ac9},
  {0x16ad0, 0x16aed}, {0x16af0, 0x16af4}, {0x16b00, 0x16b36}, {0x16b40, 0x16b43}, {0x16b50, 0x16b59}, {0x16b63, 0x16b77}, {0x16b7d, 0x16b8f}, {0x16e40, 0x16e7f},
  {0x16f00, 0x16f4a}, {0x16f4f, 0x16f87}, {0x16f8f, 0x16f9f}, {0x16fe0, 0x16fe1}, {0x16fe3, 0x16fe4}, {0x16ff0, 0x16ff1}, {0x17000, 0x187f7}, {0x18800, 0x18cd5},
  {0x18d00, 0x18d08}, {0x1aff0, 0x1aff3}, {0x1aff5, 0x1affb}, {0x1affd, 0x1affe}, {0x1b000, 0x1b122}, {0x1b132, 0x1b132}, {0x1b150, 0x1b152}, {0x1b155, 0x1b155},
  {0x1b164, 0x1b167}, {0x1b170, 0x1b2fb}, {0x1bc00, 0x1bc6a}, {0x1bc70, 0x1bc7c}, {0x1bc80, 0x1bc88}, {0x1bc90, 0x1bc99}, {0x1bc9d, 0x1bc9e}, {0x1cf00, 0x1cf2d},
  {0x1cf30, 0x1cf46}, {0x1d165, 0x1d169}, {0x1d16d, 0x1d172}, {0x1d17b, 0x1d182}, {0x1d185, 0x1d18b}, {0x1d1aa, 0x1d1ad}, {0x1d242, 0x1d244}, {0x1d400, 0x1d454},
  {0x1d456, 0x1d49c}, {0x1d49e, 0x1d49f}, {0x1d4a2, 0x1d4a2}, {0x1d4a5, 0x1d4a6}, {0x1d4a9, 0x1d4ac}, {0x1d4ae, 0x1d4b9}, {0x1d4bb, 0x1d4bb}, {0x1d4bd, 0x1d4c3},
  {0x1d4c5, 0x1d505}, {0x1d507, 0x1d50a}, {0x1d50d, 0x1d514}, {0x1d516, 0x1d51c}, {0x1d51e, 0x1d539}, {0x1d53b, 0x1d53e}, {0x1d540, 0x1d544}, {0x1d546, 0x1d546},
  {0x1d54a, 0x1d550}, {0x1d552, 0x1d6a5}, {0x1d6a8, 0x1d6c0}, {0x1d6c2, 0x1d6da}, {0x1d6dc, 0x1d6fa}, {0x1d6fc, 0x1d714}, {0x1d716, 0x1d734}, {0x1d736, 0x1d74e},
  {0x1d750, 0x1d76e}, {0x1d770, 0x1d788}, {0x1d78a, 0x1d7a8}, {0x1d7aa, 0x1d7c2}, {0x1d7c4, 0x1d7cb}, {0x1d7ce, 0x1d7ff}, {0x1da00, 0x1da36}, {0x1da3b, 0x1da6c},
  {0x1da75, 0x1da75}, {0x1da84, 0x1da84}, {0x1da9b, 0x1da9f}, {0x1daa1, 0x1daaf}, {0x1df00, 0x1df1e}, {0x1df25, 0x1df2a}, {0x1e000, 0x1e006}, {0x1e008, 0x1e018},
  {0x1e01b, 0x1e021}, {0x1e023, 0x1e024}, {0x1e026, 0x1e02a}, {0x1e030, 0x1e06d}, {0x1e08f, 0x1e08f}, {0x1e100, 0x1e12c}, {0x1e130, 0x1e13d}, {0x1e140, 0x1e149},
  {0x1e14e, 0x1e14e}, {0x1e290, 0x1e2ae}, {0x1e2c0, 0x1e2f9}, {0x1e4d0, 0x1e4f9}, {0x1e7e0, 0x1e7e6}, {0x1e7e8, 0x1e7eb}, {0x1e7ed, 0x1e7ee}, {0x1e7f0, 0x1e7fe},
  {0x1e800, 0x1e8c4}, {0x1e8d0, 0x1e8d6}, {0x1e900, 0x1e94b}, {0x1e950, 0x1e959}, {0x1ee00, 0x1ee03}, {0x1ee05, 0x1ee1f}, {0x1ee21, 0x1ee22}, {0x1ee24, 0x1ee24},
  {0x1ee27, 0x1ee27}, {0x1ee29, 0x1ee32}, {0x1ee34, 0x1ee37}, {0x1ee39, 0x1ee39}, {0x1ee3b, 0x1ee3b}, {0x1ee42, 0x1ee42}, {0x1ee47, 0x1ee47}, {0x1ee49, 0x1ee49},
  {0x1ee4b, 0x1ee4b}, {0x1ee4d, 0x1ee4f}, {0x1ee51, 0x1ee52}, {0x1ee54, 0x1ee54}, {0x1ee57, 0x1ee57}, {0x1ee59, 0x1ee59}, {0x1ee5b, 0x1ee5b}, {0x1ee5d, 0x1ee5d},
  {0x1ee5f, 0x1ee5f}, {0x1ee61, 0x1ee62}, {0x1ee64, 0x1ee64}, {0x1ee67, 0x1ee6a}, {0x1ee6c, 0x1ee72}, {0x1ee74, 0x1ee77}, {0x1ee79, 0x1ee7c}, {0x1ee7e, 0x1ee7e},
  {0x1ee80, 0x1ee89}, {0x1ee8b, 0x1ee9b}, {0x1eea1, 0x1eea3}, {0x1eea5, 0x1eea9}, {0x1eeab, 0x1eebb}, {0x1fbf0, 0x1fbf9}, {0x20000, 0x2a6df}, {0x2a700, 0x2b739},
  {0x2b740, 0x2b81d}, {0x2b820, 0x2cea1}, {0x2ceb0, 0x2ebe0}, {0x2ebf0, 0x2ee5d}, {0x2f800, 0x2fa1d}, {0x30000, 0x3134a}, {0x31350, 0x323af}, {0xe0100, 0xe01ef},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(145);
      ADVANCE_MAP(
        '!', 218,
        '#', 146,
        '$', 13,
        '%', 197,
        '&', 211,
        '\'', 186,
        '(', 154,
        ')', 155,
        '*', 185,
        '+', 193,
        ',', 161,
        '-', 195,
        '.', 226,
        '/', 196,
        '0', 312,
        ':', 158,
        ';', 149,
        '<', 201,
        '=', 176,
        '>', 205,
        '[', 147,
        ']', 148,
        '^', 212,
        '_', 26,
        '`', 216,
        'a', 121,
        'b', 104,
        'c', 86,
        'd', 42,
        'e', 89,
        'f', 34,
        'i', 60,
        'l', 43,
        'm', 30,
        'p', 71,
        'r', 44,
        's', 45,
        't', 108,
        'u', 115,
        'w', 68,
        '{', 168,
        '|', 213,
        '}', 169,
        '~', 219,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(0);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(313);
      END_STATE();
    case 1:
      ADVANCE_MAP(
        '!', 217,
        '$', 54,
        '&', 210,
        '\'', 186,
        '(', 154,
        ')', 17,
        '*', 185,
        '-', 194,
        '/', 15,
        '0', 312,
        ':', 21,
        '<', 202,
        '=', 24,
        '>', 204,
        '[', 147,
        'a', 296,
        'd', 261,
        'f', 254,
        'i', 271,
        'l', 262,
        'm', 255,
        'r', 263,
        's', 264,
        't', 293,
        '{', 168,
        '}', 169,
        '~', 219,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(1);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(313);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(309);
      END_STATE();
    case 2:
      ADVANCE_MAP(
        '!', 217,
        '&', 210,
        '(', 154,
        ')', 155,
        '*', 185,
        ',', 161,
        '-', 194,
        '/', 15,
        '0', 312,
        ':', 21,
        '=', 174,
        '>', 203,
        '[', 147,
        ']', 148,
        'f', 254,
        'i', 271,
        'm', 255,
        's', 269,
        't', 293,
        '{', 168,
        '~', 219,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(2);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(313);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(309);
      END_STATE();
    case 3:
      ADVANCE_MAP(
        '!', 23,
        '$', 11,
        '%', 197,
        '&', 211,
        '(', 154,
        ')', 155,
        '*', 185,
        '+', 193,
        ',', 161,
        '-', 194,
        '.', 226,
        '/', 196,
        ':', 158,
        ';', 149,
        '<', 201,
        '=', 176,
        '>', 205,
        '[', 147,
        ']', 148,
        '^', 212,
        '_', 26,
        '`', 216,
        'f', 102,
        '{', 168,
        '|', 213,
        '}', 169,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(3);
      END_STATE();
    case 4:
      ADVANCE_MAP(
        '!', 23,
        '$', 11,
        '%', 197,
        '&', 211,
        '(', 154,
        ')', 155,
        '*', 185,
        '+', 193,
        ',', 161,
        '-', 194,
        '.', 226,
        '/', 196,
        ':', 160,
        ';', 149,
        '<', 201,
        '=', 175,
        '>', 205,
        '[', 147,
        ']', 148,
        '^', 212,
        '_', 26,
        '`', 216,
        '{', 168,
        '|', 213,
        '}', 169,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(4);
      END_STATE();
    case 5:
      ADVANCE_MAP(
        '#', 146,
        '$', 11,
        '(', 154,
        ')', 155,
        '+', 193,
        ',', 161,
        '-', 194,
        '/', 15,
        ':', 20,
        ';', 149,
        '<', 200,
        '>', 203,
        '{', 168,
        '}', 169,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(5);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(309);
      END_STATE();
    case 6:
      if (lookahead == '#') ADVANCE(146);
      if (lookahead == ')') ADVANCE(155);
      if (lookahead == '/') ADVANCE(15);
      if (lookahead == 's') ADVANCE(270);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(6);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(309);
      END_STATE();
    case 7:
      if (lookahead == '$') ADVANCE(22);
      if (lookahead == '<') ADVANCE(229);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '$', 11,
        '(', 154,
        ')', 155,
        ',', 161,
        '-', 25,
        '/', 15,
        ':', 159,
        ';', 149,
        '<', 200,
        '=', 174,
        '>', 203,
        ']', 148,
        '_', 26,
        'i', 99,
        'r', 59,
        'w', 68,
        '{', 168,
        '}', 169,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(8);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '&', 210,
        '(', 154,
        ')', 155,
        ',', 161,
        '/', 15,
        '0', 312,
        ':', 157,
        '>', 203,
        '[', 147,
        'b', 289,
        'c', 283,
        'i', 286,
        '{', 168,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(9);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(313);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(309);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '(', 154,
        ')', 155,
        '/', 15,
        '0', 312,
        ':', 21,
        'f', 254,
        't', 293,
        '}', 169,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(10);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(313);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(309);
      END_STATE();
    case 11:
      if (lookahead == '(') ADVANCE(240);
      END_STATE();
    case 12:
      if (lookahead == '(') ADVANCE(240);
      if (lookahead == 'c') ADVANCE(101);
      END_STATE();
    case 13:
      if (lookahead == '(') ADVANCE(240);
      if (lookahead == 'c') ADVANCE(101);
      if (lookahead == 'e') ADVANCE(90);
      if (lookahead == 'i') ADVANCE(61);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        ')', 17,
        ',', 161,
        '/', 15,
        ';', 149,
        '<', 200,
        '>', 203,
        '_', 251,
        '{', 168,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(14);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(309);
      END_STATE();
    case 15:
      if (lookahead == '*') ADVANCE(322);
      if (lookahead == '/') ADVANCE(320);
      END_STATE();
    case 16:
      if (lookahead == '*') ADVANCE(326);
      if (lookahead == '/') ADVANCE(324);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(325);
      if (lookahead != 0) ADVANCE(323);
      END_STATE();
    case 17:
      if (lookahead == '.') ADVANCE(233);
      END_STATE();
    case 18:
      if (lookahead == '/') ADVANCE(15);
      if (lookahead == 'i') ADVANCE(288);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(18);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(309);
      END_STATE();
    case 19:
      if (lookahead == '/') ADVANCE(15);
      if (lookahead == 'p') ADVANCE(292);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(19);
      if (set_contains(sym_identifier_character_set_1, 668, lookahead)) ADVANCE(309);
      END_STATE();
    case 20:
      if (lookahead == ':') ADVANCE(311);
      END_STATE();
    case 21:
      if (lookahead == ':') ADVANCE(310);
      END_STATE();
    case 22:
      if (lookahead == '<') ADVANCE(230);
      END_STATE();
    case 23:
      if (lookahead == '=') ADVANCE(199);
      END_STATE();
    case 24:
      if (lookahead == '=') ADVANCE(198);
      if (lookahead == '>') ADVANCE(225);
      END_STATE();
    case 25:
      if (lookahead == '>') ADVANCE(152);
      END_STATE();
    case 26:
      if (lookahead == '_') ADVANCE(35);
      END_STATE();
    case 27:
      if (lookahead == '_') ADVANCE(238);
      END_STATE();
    case 28:
      if (lookahead == '_') ADVANCE(27);
      END_STATE();
    case 29:
      if (lookahead == 'a') ADVANCE(66);
      if (lookahead == 'r') ADVANCE(136);
      END_STATE();
    case 30:
      if (lookahead == 'a') ADVANCE(131);
      if (lookahead == 'o') ADVANCE(41);
      END_STATE();
    case 31:
      if (lookahead == 'a') ADVANCE(84);
      END_STATE();
    case 32:
      if (lookahead == 'a') ADVANCE(79);
      END_STATE();
    case 33:
      if (lookahead == 'a') ADVANCE(79);
      if (lookahead == 'u') ADVANCE(48);
      END_STATE();
    case 34:
      if (lookahead == 'a') ADVANCE(91);
      if (lookahead == 'n') ADVANCE(150);
      if (lookahead == 'o') ADVANCE(109);
      END_STATE();
    case 35:
      if (lookahead == 'b') ADVANCE(135);
      END_STATE();
    case 36:
      if (lookahead == 'c') ADVANCE(80);
      END_STATE();
    case 37:
      if (lookahead == 'c') ADVANCE(101);
      END_STATE();
    case 38:
      if (lookahead == 'c') ADVANCE(67);
      END_STATE();
    case 39:
      if (lookahead == 'c') ADVANCE(82);
      END_STATE();
    case 40:
      if (lookahead == 'c') ADVANCE(130);
      END_STATE();
    case 41:
      if (lookahead == 'd') ADVANCE(172);
      END_STATE();
    case 42:
      if (lookahead == 'e') ADVANCE(39);
      END_STATE();
    case 43:
      if (lookahead == 'e') ADVANCE(123);
      END_STATE();
    case 44:
      if (lookahead == 'e') ADVANCE(64);
      END_STATE();
    case 45:
      if (lookahead == 'e') ADVANCE(85);
      if (lookahead == 't') ADVANCE(29);
      END_STATE();
    case 46:
      if (lookahead == 'e') ADVANCE(171);
      END_STATE();
    case 47:
      if (lookahead == 'e') ADVANCE(222);
      END_STATE();
    case 48:
      if (lookahead == 'e') ADVANCE(234);
      END_STATE();
    case 49:
      if (lookahead == 'e') ADVANCE(188);
      END_STATE();
    case 50:
      if (lookahead == 'e') ADVANCE(236);
      END_STATE();
    case 51:
      if (lookahead == 'e') ADVANCE(231);
      END_STATE();
    case 52:
      if (lookahead == 'e') ADVANCE(156);
      END_STATE();
    case 53:
      if (lookahead == 'e') ADVANCE(153);
      END_STATE();
    case 54:
      if (lookahead == 'e') ADVANCE(90);
      if (lookahead == 'i') ADVANCE(61);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(114);
      END_STATE();
    case 56:
      if (lookahead == 'e') ADVANCE(87);
      END_STATE();
    case 57:
      if (lookahead == 'e') ADVANCE(127);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(113);
      END_STATE();
    case 59:
      if (lookahead == 'e') ADVANCE(118);
      END_STATE();
    case 60:
      if (lookahead == 'f') ADVANCE(220);
      if (lookahead == 'm') ADVANCE(106);
      if (lookahead == 'n') ADVANCE(75);
      END_STATE();
    case 61:
      if (lookahead == 'f') ADVANCE(187);
      END_STATE();
    case 62:
      if (lookahead == 'f') ADVANCE(241);
      END_STATE();
    case 63:
      if (lookahead == 'f') ADVANCE(73);
      END_STATE();
    case 64:
      if (lookahead == 'g') ADVANCE(179);
      if (lookahead == 's') ADVANCE(57);
      END_STATE();
    case 65:
      if (lookahead == 'g') ADVANCE(173);
      END_STATE();
    case 66:
      if (lookahead == 'g') ADVANCE(51);
      END_STATE();
    case 67:
      if (lookahead == 'h') ADVANCE(223);
      END_STATE();
    case 68:
      if (lookahead == 'h') ADVANCE(55);
      END_STATE();
    case 69:
      if (lookahead == 'i') ADVANCE(31);
      END_STATE();
    case 70:
      if (lookahead == 'i') ADVANCE(107);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(107);
      if (lookahead == 'o') ADVANCE(112);
      END_STATE();
    case 72:
      if (lookahead == 'i') ADVANCE(98);
      END_STATE();
    case 73:
      if (lookahead == 'i') ADVANCE(65);
      END_STATE();
    case 74:
      if (lookahead == 'i') ADVANCE(132);
      END_STATE();
    case 75:
      if (lookahead == 'i') ADVANCE(132);
      if (lookahead == 's') ADVANCE(124);
      if (lookahead == 't') ADVANCE(245);
      if (lookahead == 'v') ADVANCE(243);
      END_STATE();
    case 76:
      if (lookahead == 'i') ADVANCE(96);
      END_STATE();
    case 77:
      if (lookahead == 'i') ADVANCE(126);
      END_STATE();
    case 78:
      if (lookahead == 'i') ADVANCE(88);
      END_STATE();
    case 79:
      if (lookahead == 'i') ADVANCE(128);
      END_STATE();
    case 80:
      if (lookahead == 'k') ADVANCE(249);
      END_STATE();
    case 81:
      if (lookahead == 'l') ADVANCE(247);
      END_STATE();
    case 82:
      if (lookahead == 'l') ADVANCE(183);
      END_STATE();
    case 83:
      if (lookahead == 'l') ADVANCE(166);
      END_STATE();
    case 84:
      if (lookahead == 'l') ADVANCE(192);
      END_STATE();
    case 85:
      if (lookahead == 'l') ADVANCE(62);
      if (lookahead == 't') ADVANCE(181);
      END_STATE();
    case 86:
      if (lookahead == 'l') ADVANCE(103);
      END_STATE();
    case 87:
      if (lookahead == 'l') ADVANCE(72);
      END_STATE();
    case 88:
      if (lookahead == 'l') ADVANCE(134);
      END_STATE();
    case 89:
      if (lookahead == 'l') ADVANCE(117);
      if (lookahead == 'n') ADVANCE(122);
      END_STATE();
    case 90:
      if (lookahead == 'l') ADVANCE(119);
      END_STATE();
    case 91:
      if (lookahead == 'l') ADVANCE(120);
      END_STATE();
    case 92:
      if (lookahead == 'm') ADVANCE(106);
      if (lookahead == 'n') ADVANCE(74);
      END_STATE();
    case 93:
      if (lookahead == 'm') ADVANCE(165);
      END_STATE();
    case 94:
      if (lookahead == 'n') ADVANCE(122);
      END_STATE();
    case 95:
      if (lookahead == 'n') ADVANCE(150);
      END_STATE();
    case 96:
      if (lookahead == 'n') ADVANCE(28);
      END_STATE();
    case 97:
      if (lookahead == 'n') ADVANCE(63);
      END_STATE();
    case 98:
      if (lookahead == 'n') ADVANCE(53);
      END_STATE();
    case 99:
      if (lookahead == 'n') ADVANCE(74);
      END_STATE();
    case 100:
      if (lookahead == 'o') ADVANCE(41);
      END_STATE();
    case 101:
      if (lookahead == 'o') ADVANCE(97);
      END_STATE();
    case 102:
      if (lookahead == 'o') ADVANCE(109);
      END_STATE();
    case 103:
      if (lookahead == 'o') ADVANCE(36);
      END_STATE();
    case 104:
      if (lookahead == 'o') ADVANCE(105);
      END_STATE();
    case 105:
      if (lookahead == 'o') ADVANCE(81);
      END_STATE();
    case 106:
      if (lookahead == 'p') ADVANCE(83);
      END_STATE();
    case 107:
      if (lookahead == 'p') ADVANCE(56);
      END_STATE();
    case 108:
      if (lookahead == 'r') ADVANCE(33);
      END_STATE();
    case 109:
      if (lookahead == 'r') ADVANCE(167);
      END_STATE();
    case 110:
      if (lookahead == 'r') ADVANCE(136);
      END_STATE();
    case 111:
      if (lookahead == 'r') ADVANCE(32);
      END_STATE();
    case 112:
      if (lookahead == 'r') ADVANCE(125);
      END_STATE();
    case 113:
      if (lookahead == 'r') ADVANCE(129);
      END_STATE();
    case 114:
      if (lookahead == 'r') ADVANCE(52);
      END_STATE();
    case 115:
      if (lookahead == 's') ADVANCE(46);
      END_STATE();
    case 116:
      if (lookahead == 's') ADVANCE(58);
      END_STATE();
    case 117:
      if (lookahead == 's') ADVANCE(47);
      END_STATE();
    case 118:
      if (lookahead == 's') ADVANCE(57);
      END_STATE();
    case 119:
      if (lookahead == 's') ADVANCE(49);
      END_STATE();
    case 120:
      if (lookahead == 's') ADVANCE(50);
      END_STATE();
    case 121:
      if (lookahead == 's') ADVANCE(116);
      END_STATE();
    case 122:
      if (lookahead == 't') ADVANCE(77);
      if (lookahead == 'u') ADVANCE(93);
      END_STATE();
    case 123:
      if (lookahead == 't') ADVANCE(177);
      END_STATE();
    case 124:
      if (lookahead == 't') ADVANCE(227);
      END_STATE();
    case 125:
      if (lookahead == 't') ADVANCE(163);
      END_STATE();
    case 126:
      if (lookahead == 't') ADVANCE(137);
      END_STATE();
    case 127:
      if (lookahead == 't') ADVANCE(191);
      END_STATE();
    case 128:
      if (lookahead == 't') ADVANCE(170);
      END_STATE();
    case 129:
      if (lookahead == 't') ADVANCE(189);
      END_STATE();
    case 130:
      if (lookahead == 't') ADVANCE(162);
      END_STATE();
    case 131:
      if (lookahead == 't') ADVANCE(38);
      END_STATE();
    case 132:
      if (lookahead == 't') ADVANCE(69);
      END_STATE();
    case 133:
      if (lookahead == 't') ADVANCE(110);
      END_STATE();
    case 134:
      if (lookahead == 't') ADVANCE(76);
      END_STATE();
    case 135:
      if (lookahead == 'u') ADVANCE(78);
      END_STATE();
    case 136:
      if (lookahead == 'u') ADVANCE(40);
      END_STATE();
    case 137:
      if (lookahead == 'y') ADVANCE(151);
      END_STATE();
    case 138:
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(317);
      END_STATE();
    case 139:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(314);
      END_STATE();
    case 140:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(318);
      END_STATE();
    case 141:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(316);
      END_STATE();
    case 142:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(315);
      END_STATE();
    case 143:
      if (eof) ADVANCE(145);
      ADVANCE_MAP(
        '!', 23,
        '#', 146,
        '$', 12,
        '%', 197,
        '&', 211,
        '(', 154,
        ')', 155,
        '*', 185,
        '+', 193,
        ',', 161,
        '-', 194,
        '.', 226,
        '/', 196,
        ':', 157,
        ';', 149,
        '<', 201,
        '=', 176,
        '>', 205,
        '[', 147,
        ']', 148,
        '^', 212,
        '_', 26,
        '`', 216,
        'e', 94,
        'f', 95,
        'i', 92,
        'm', 100,
        'p', 70,
        'r', 59,
        's', 133,
        't', 111,
        'u', 115,
        'w', 68,
        '{', 168,
        '|', 213,
        '}', 169,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(143);
      END_STATE();
    case 144:
      if (eof) ADVANCE(145);
      ADVANCE_MAP(
        '!', 23,
        '#', 146,
        '$', 37,
        '%', 197,
        '&', 211,
        ')', 155,
        '*', 185,
        '+', 193,
        ',', 161,
        '-', 194,
        '.', 226,
        '/', 196,
        ':', 157,
        ';', 149,
        '<', 201,
        '=', 175,
        '>', 205,
        '[', 147,
        ']', 148,
        '^', 212,
        '_', 26,
        '`', 216,
        'e', 89,
        'f', 95,
        'i', 92,
        'm', 100,
        'p', 70,
        'r', 59,
        's', 133,
        't', 111,
        'u', 115,
        '{', 168,
        '|', 213,
        '}', 169,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(144);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_POUND);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_fn);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(anon_sym_entity);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(anon_sym_pipeline);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(311);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(310);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(7);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_port);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_port);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_impl);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_trait);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_use);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(anon_sym_mod);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(anon_sym_DOLLARconfig);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(198);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(198);
      if (lookahead == '>') ADVANCE(225);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(anon_sym_let);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_reg);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(anon_sym_reg);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(anon_sym_set);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(anon_sym_decl);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(anon_sym_decl);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_DOLLARif);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(anon_sym_DOLLARelse);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 190:
      ACCEPT_TOKEN(anon_sym_assert);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(anon_sym_reset);
      END_STATE();
    case 192:
      ACCEPT_TOKEN(anon_sym_initial);
      END_STATE();
    case 193:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 194:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '>') ADVANCE(152);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(sym_op_div);
      if (lookahead == '*') ADVANCE(322);
      if (lookahead == '/') ADVANCE(320);
      END_STATE();
    case 197:
      ACCEPT_TOKEN(sym_op_mod);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(sym_op_equals);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(sym_op_ne);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 201:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(208);
      if (lookahead == '=') ADVANCE(206);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(206);
      END_STATE();
    case 203:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(207);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(207);
      if (lookahead == '>') ADVANCE(209);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(sym_op_le);
      END_STATE();
    case 207:
      ACCEPT_TOKEN(sym_op_ge);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(sym_op_lshift);
      END_STATE();
    case 209:
      ACCEPT_TOKEN(sym_op_rshift);
      END_STATE();
    case 210:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 211:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(214);
      END_STATE();
    case 212:
      ACCEPT_TOKEN(sym_op_bitwise_xor);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(sym_op_bitwise_or);
      if (lookahead == '|') ADVANCE(215);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(sym_op_logical_and);
      END_STATE();
    case 215:
      ACCEPT_TOKEN(sym_op_logical_or);
      END_STATE();
    case 216:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 217:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 218:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(199);
      END_STATE();
    case 219:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 220:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 221:
      ACCEPT_TOKEN(anon_sym_if);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_match);
      END_STATE();
    case 224:
      ACCEPT_TOKEN(anon_sym_match);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 225:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 226:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 227:
      ACCEPT_TOKEN(anon_sym_inst);
      END_STATE();
    case 228:
      ACCEPT_TOKEN(anon_sym_inst);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_COLON_COLON_LT);
      END_STATE();
    case 230:
      ACCEPT_TOKEN(anon_sym_COLON_COLON_DOLLAR_LT);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_stage);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_stage);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 233:
      ACCEPT_TOKEN(anon_sym_RPAREN_DOT);
      END_STATE();
    case 234:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 235:
      ACCEPT_TOKEN(anon_sym_true);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 236:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 237:
      ACCEPT_TOKEN(anon_sym_false);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym___builtin__);
      END_STATE();
    case 239:
      ACCEPT_TOKEN(anon_sym___builtin__);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 240:
      ACCEPT_TOKEN(anon_sym_DOLLAR_LPAREN);
      END_STATE();
    case 241:
      ACCEPT_TOKEN(sym_self);
      END_STATE();
    case 242:
      ACCEPT_TOKEN(sym_self);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 243:
      ACCEPT_TOKEN(anon_sym_inv);
      END_STATE();
    case 244:
      ACCEPT_TOKEN(anon_sym_inv);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_int);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(anon_sym_int);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 247:
      ACCEPT_TOKEN(anon_sym_bool);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_bool);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 249:
      ACCEPT_TOKEN(anon_sym_clock);
      END_STATE();
    case 250:
      ACCEPT_TOKEN(anon_sym_clock);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 251:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(257);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 252:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(239);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 253:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '_') ADVANCE(252);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 254:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(285);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(305);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 256:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'a') ADVANCE(274);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 257:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'b') ADVANCE(307);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(275);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(278);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'c') ADVANCE(281);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(260);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(300);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(273);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(279);
      if (lookahead == 't') ADVANCE(256);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(235);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(237);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(232);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(294);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(280);
      if (lookahead == 't') ADVANCE(256);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'e') ADVANCE(280);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(221);
      if (lookahead == 'n') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'f') ADVANCE(242);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'g') ADVANCE(180);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'g') ADVANCE(267);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'h') ADVANCE(224);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(287);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'i') ADVANCE(284);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'k') ADVANCE(250);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(272);
      if (lookahead == 't') ADVANCE(182);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(272);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(184);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(248);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(290);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(306);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'l') ADVANCE(299);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(303);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(253);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'n') ADVANCE(297);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(291);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(259);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(282);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'o') ADVANCE(295);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(308);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(302);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'r') ADVANCE(304);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(298);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(301);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(268);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 's') ADVANCE(266);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(178);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(228);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(190);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(246);
      if (lookahead == 'v') ADVANCE(244);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(164);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(258);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 't') ADVANCE(276);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(277);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == 'u') ADVANCE(265);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(sym_identifier);
      if (set_contains(sym_identifier_character_set_2, 776, lookahead)) ADVANCE(309);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      if (lookahead == '$') ADVANCE(22);
      if (lookahead == '<') ADVANCE(229);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(aux_sym_int_literal_token1);
      if (lookahead == 'b') ADVANCE(138);
      if (lookahead == 'x') ADVANCE(142);
      if (lookahead == 'i' ||
          lookahead == 'u') ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(313);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(aux_sym_int_literal_token1);
      if (lookahead == 'i' ||
          lookahead == 'u') ADVANCE(139);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(313);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(aux_sym_int_literal_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(314);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(aux_sym_int_literal_token2);
      if (lookahead == 'i' ||
          lookahead == 'u') ADVANCE(141);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(315);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(aux_sym_int_literal_token2);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(316);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(aux_sym_int_literal_token3);
      if (lookahead == 'i' ||
          lookahead == 'u') ADVANCE(140);
      if (lookahead == '0' ||
          lookahead == '1' ||
          lookahead == '_') ADVANCE(317);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(aux_sym_int_literal_token3);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(318);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(sym_doc_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(319);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead == '/') ADVANCE(319);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(321);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(sym_line_comment);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(321);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(anon_sym_SLASH_STAR);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(aux_sym_block_comment_token1);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(aux_sym_block_comment_token1);
      if (lookahead == '*') ADVANCE(322);
      if (lookahead == '/') ADVANCE(320);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(aux_sym_block_comment_token1);
      if (lookahead == '*') ADVANCE(326);
      if (lookahead == '/') ADVANCE(324);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(325);
      if (lookahead != 0) ADVANCE(323);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(aux_sym_block_comment_token1);
      if (lookahead == '/') ADVANCE(327);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(anon_sym_STAR_SLASH);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 0},
  [2] = {.lex_state = 1},
  [3] = {.lex_state = 1},
  [4] = {.lex_state = 143},
  [5] = {.lex_state = 2},
  [6] = {.lex_state = 2},
  [7] = {.lex_state = 2},
  [8] = {.lex_state = 2},
  [9] = {.lex_state = 2},
  [10] = {.lex_state = 2},
  [11] = {.lex_state = 2},
  [12] = {.lex_state = 2},
  [13] = {.lex_state = 2},
  [14] = {.lex_state = 2},
  [15] = {.lex_state = 2},
  [16] = {.lex_state = 2},
  [17] = {.lex_state = 2},
  [18] = {.lex_state = 2},
  [19] = {.lex_state = 2},
  [20] = {.lex_state = 2},
  [21] = {.lex_state = 2},
  [22] = {.lex_state = 2},
  [23] = {.lex_state = 2},
  [24] = {.lex_state = 2},
  [25] = {.lex_state = 2},
  [26] = {.lex_state = 2},
  [27] = {.lex_state = 2},
  [28] = {.lex_state = 2},
  [29] = {.lex_state = 2},
  [30] = {.lex_state = 2},
  [31] = {.lex_state = 2},
  [32] = {.lex_state = 2},
  [33] = {.lex_state = 2},
  [34] = {.lex_state = 2},
  [35] = {.lex_state = 2},
  [36] = {.lex_state = 2},
  [37] = {.lex_state = 2},
  [38] = {.lex_state = 2},
  [39] = {.lex_state = 2},
  [40] = {.lex_state = 2},
  [41] = {.lex_state = 2},
  [42] = {.lex_state = 2},
  [43] = {.lex_state = 2},
  [44] = {.lex_state = 2},
  [45] = {.lex_state = 2},
  [46] = {.lex_state = 2},
  [47] = {.lex_state = 2},
  [48] = {.lex_state = 2},
  [49] = {.lex_state = 2},
  [50] = {.lex_state = 2},
  [51] = {.lex_state = 144},
  [52] = {.lex_state = 144},
  [53] = {.lex_state = 144},
  [54] = {.lex_state = 144},
  [55] = {.lex_state = 144},
  [56] = {.lex_state = 144},
  [57] = {.lex_state = 144},
  [58] = {.lex_state = 144},
  [59] = {.lex_state = 144},
  [60] = {.lex_state = 144},
  [61] = {.lex_state = 144},
  [62] = {.lex_state = 144},
  [63] = {.lex_state = 144},
  [64] = {.lex_state = 144},
  [65] = {.lex_state = 144},
  [66] = {.lex_state = 4},
  [67] = {.lex_state = 1},
  [68] = {.lex_state = 4},
  [69] = {.lex_state = 3},
  [70] = {.lex_state = 3},
  [71] = {.lex_state = 3},
  [72] = {.lex_state = 143},
  [73] = {.lex_state = 143},
  [74] = {.lex_state = 143},
  [75] = {.lex_state = 143},
  [76] = {.lex_state = 143},
  [77] = {.lex_state = 143},
  [78] = {.lex_state = 143},
  [79] = {.lex_state = 143},
  [80] = {.lex_state = 143},
  [81] = {.lex_state = 143},
  [82] = {.lex_state = 143},
  [83] = {.lex_state = 143},
  [84] = {.lex_state = 143},
  [85] = {.lex_state = 143},
  [86] = {.lex_state = 144},
  [87] = {.lex_state = 143},
  [88] = {.lex_state = 143},
  [89] = {.lex_state = 143},
  [90] = {.lex_state = 143},
  [91] = {.lex_state = 143},
  [92] = {.lex_state = 143},
  [93] = {.lex_state = 143},
  [94] = {.lex_state = 143},
  [95] = {.lex_state = 143},
  [96] = {.lex_state = 143},
  [97] = {.lex_state = 143},
  [98] = {.lex_state = 143},
  [99] = {.lex_state = 143},
  [100] = {.lex_state = 143},
  [101] = {.lex_state = 143},
  [102] = {.lex_state = 143},
  [103] = {.lex_state = 144},
  [104] = {.lex_state = 144},
  [105] = {.lex_state = 144},
  [106] = {.lex_state = 144},
  [107] = {.lex_state = 144},
  [108] = {.lex_state = 144},
  [109] = {.lex_state = 144},
  [110] = {.lex_state = 144},
  [111] = {.lex_state = 144},
  [112] = {.lex_state = 144},
  [113] = {.lex_state = 144},
  [114] = {.lex_state = 144},
  [115] = {.lex_state = 144},
  [116] = {.lex_state = 144},
  [117] = {.lex_state = 144},
  [118] = {.lex_state = 144},
  [119] = {.lex_state = 144},
  [120] = {.lex_state = 144},
  [121] = {.lex_state = 144},
  [122] = {.lex_state = 144},
  [123] = {.lex_state = 1},
  [124] = {.lex_state = 144},
  [125] = {.lex_state = 144},
  [126] = {.lex_state = 144},
  [127] = {.lex_state = 144},
  [128] = {.lex_state = 144},
  [129] = {.lex_state = 144},
  [130] = {.lex_state = 144},
  [131] = {.lex_state = 144},
  [132] = {.lex_state = 144},
  [133] = {.lex_state = 144},
  [134] = {.lex_state = 1},
  [135] = {.lex_state = 144},
  [136] = {.lex_state = 144},
  [137] = {.lex_state = 144},
  [138] = {.lex_state = 144},
  [139] = {.lex_state = 144},
  [140] = {.lex_state = 144},
  [141] = {.lex_state = 144},
  [142] = {.lex_state = 144},
  [143] = {.lex_state = 1},
  [144] = {.lex_state = 144},
  [145] = {.lex_state = 1},
  [146] = {.lex_state = 1},
  [147] = {.lex_state = 1},
  [148] = {.lex_state = 1},
  [149] = {.lex_state = 1},
  [150] = {.lex_state = 1},
  [151] = {.lex_state = 1},
  [152] = {.lex_state = 0},
  [153] = {.lex_state = 0},
  [154] = {.lex_state = 0},
  [155] = {.lex_state = 0},
  [156] = {.lex_state = 0},
  [157] = {.lex_state = 9},
  [158] = {.lex_state = 9},
  [159] = {.lex_state = 10},
  [160] = {.lex_state = 9},
  [161] = {.lex_state = 9},
  [162] = {.lex_state = 9},
  [163] = {.lex_state = 9},
  [164] = {.lex_state = 9},
  [165] = {.lex_state = 9},
  [166] = {.lex_state = 9},
  [167] = {.lex_state = 9},
  [168] = {.lex_state = 9},
  [169] = {.lex_state = 9},
  [170] = {.lex_state = 9},
  [171] = {.lex_state = 9},
  [172] = {.lex_state = 9},
  [173] = {.lex_state = 9},
  [174] = {.lex_state = 2},
  [175] = {.lex_state = 2},
  [176] = {.lex_state = 10},
  [177] = {.lex_state = 2},
  [178] = {.lex_state = 2},
  [179] = {.lex_state = 9},
  [180] = {.lex_state = 9},
  [181] = {.lex_state = 9},
  [182] = {.lex_state = 9},
  [183] = {.lex_state = 9},
  [184] = {.lex_state = 9},
  [185] = {.lex_state = 9},
  [186] = {.lex_state = 2},
  [187] = {.lex_state = 9},
  [188] = {.lex_state = 9},
  [189] = {.lex_state = 9},
  [190] = {.lex_state = 9},
  [191] = {.lex_state = 9},
  [192] = {.lex_state = 9},
  [193] = {.lex_state = 9},
  [194] = {.lex_state = 2},
  [195] = {.lex_state = 2},
  [196] = {.lex_state = 9},
  [197] = {.lex_state = 2},
  [198] = {.lex_state = 2},
  [199] = {.lex_state = 9},
  [200] = {.lex_state = 9},
  [201] = {.lex_state = 9},
  [202] = {.lex_state = 2},
  [203] = {.lex_state = 2},
  [204] = {.lex_state = 2},
  [205] = {.lex_state = 9},
  [206] = {.lex_state = 9},
  [207] = {.lex_state = 9},
  [208] = {.lex_state = 9},
  [209] = {.lex_state = 10},
  [210] = {.lex_state = 0},
  [211] = {.lex_state = 10},
  [212] = {.lex_state = 0},
  [213] = {.lex_state = 10},
  [214] = {.lex_state = 10},
  [215] = {.lex_state = 10},
  [216] = {.lex_state = 10},
  [217] = {.lex_state = 10},
  [218] = {.lex_state = 0},
  [219] = {.lex_state = 0},
  [220] = {.lex_state = 0},
  [221] = {.lex_state = 0},
  [222] = {.lex_state = 0},
  [223] = {.lex_state = 0},
  [224] = {.lex_state = 0},
  [225] = {.lex_state = 10},
  [226] = {.lex_state = 10},
  [227] = {.lex_state = 10},
  [228] = {.lex_state = 10},
  [229] = {.lex_state = 0},
  [230] = {.lex_state = 0},
  [231] = {.lex_state = 0},
  [232] = {.lex_state = 0},
  [233] = {.lex_state = 8},
  [234] = {.lex_state = 0},
  [235] = {.lex_state = 8},
  [236] = {.lex_state = 0},
  [237] = {.lex_state = 8},
  [238] = {.lex_state = 0},
  [239] = {.lex_state = 0},
  [240] = {.lex_state = 0},
  [241] = {.lex_state = 0},
  [242] = {.lex_state = 0},
  [243] = {.lex_state = 0},
  [244] = {.lex_state = 0},
  [245] = {.lex_state = 0},
  [246] = {.lex_state = 0},
  [247] = {.lex_state = 0},
  [248] = {.lex_state = 0},
  [249] = {.lex_state = 0},
  [250] = {.lex_state = 0},
  [251] = {.lex_state = 0},
  [252] = {.lex_state = 0},
  [253] = {.lex_state = 0},
  [254] = {.lex_state = 0},
  [255] = {.lex_state = 0},
  [256] = {.lex_state = 0},
  [257] = {.lex_state = 0},
  [258] = {.lex_state = 0},
  [259] = {.lex_state = 0},
  [260] = {.lex_state = 0},
  [261] = {.lex_state = 0},
  [262] = {.lex_state = 0},
  [263] = {.lex_state = 0},
  [264] = {.lex_state = 0},
  [265] = {.lex_state = 0},
  [266] = {.lex_state = 0},
  [267] = {.lex_state = 0},
  [268] = {.lex_state = 0},
  [269] = {.lex_state = 0},
  [270] = {.lex_state = 0},
  [271] = {.lex_state = 0},
  [272] = {.lex_state = 0},
  [273] = {.lex_state = 0},
  [274] = {.lex_state = 0},
  [275] = {.lex_state = 8},
  [276] = {.lex_state = 8},
  [277] = {.lex_state = 8},
  [278] = {.lex_state = 8},
  [279] = {.lex_state = 8},
  [280] = {.lex_state = 8},
  [281] = {.lex_state = 8},
  [282] = {.lex_state = 8},
  [283] = {.lex_state = 8},
  [284] = {.lex_state = 8},
  [285] = {.lex_state = 8},
  [286] = {.lex_state = 8},
  [287] = {.lex_state = 8},
  [288] = {.lex_state = 8},
  [289] = {.lex_state = 143},
  [290] = {.lex_state = 0},
  [291] = {.lex_state = 0},
  [292] = {.lex_state = 0},
  [293] = {.lex_state = 0},
  [294] = {.lex_state = 10},
  [295] = {.lex_state = 0},
  [296] = {.lex_state = 0},
  [297] = {.lex_state = 1},
  [298] = {.lex_state = 0},
  [299] = {.lex_state = 0},
  [300] = {.lex_state = 0},
  [301] = {.lex_state = 0},
  [302] = {.lex_state = 0},
  [303] = {.lex_state = 0},
  [304] = {.lex_state = 0},
  [305] = {.lex_state = 0},
  [306] = {.lex_state = 0},
  [307] = {.lex_state = 0},
  [308] = {.lex_state = 0},
  [309] = {.lex_state = 0},
  [310] = {.lex_state = 0},
  [311] = {.lex_state = 0},
  [312] = {.lex_state = 0},
  [313] = {.lex_state = 6},
  [314] = {.lex_state = 10},
  [315] = {.lex_state = 1},
  [316] = {.lex_state = 5},
  [317] = {.lex_state = 0},
  [318] = {.lex_state = 0},
  [319] = {.lex_state = 10},
  [320] = {.lex_state = 0},
  [321] = {.lex_state = 0},
  [322] = {.lex_state = 0},
  [323] = {.lex_state = 5},
  [324] = {.lex_state = 0},
  [325] = {.lex_state = 0},
  [326] = {.lex_state = 0},
  [327] = {.lex_state = 0},
  [328] = {.lex_state = 0},
  [329] = {.lex_state = 0},
  [330] = {.lex_state = 0},
  [331] = {.lex_state = 0},
  [332] = {.lex_state = 0},
  [333] = {.lex_state = 0},
  [334] = {.lex_state = 0},
  [335] = {.lex_state = 0},
  [336] = {.lex_state = 143},
  [337] = {.lex_state = 143},
  [338] = {.lex_state = 5},
  [339] = {.lex_state = 143},
  [340] = {.lex_state = 5},
  [341] = {.lex_state = 143},
  [342] = {.lex_state = 143},
  [343] = {.lex_state = 144},
  [344] = {.lex_state = 5},
  [345] = {.lex_state = 8},
  [346] = {.lex_state = 8},
  [347] = {.lex_state = 143},
  [348] = {.lex_state = 143},
  [349] = {.lex_state = 143},
  [350] = {.lex_state = 5},
  [351] = {.lex_state = 5},
  [352] = {.lex_state = 143},
  [353] = {.lex_state = 143},
  [354] = {.lex_state = 5},
  [355] = {.lex_state = 143},
  [356] = {.lex_state = 5},
  [357] = {.lex_state = 143},
  [358] = {.lex_state = 143},
  [359] = {.lex_state = 5},
  [360] = {.lex_state = 5},
  [361] = {.lex_state = 143},
  [362] = {.lex_state = 143},
  [363] = {.lex_state = 8},
  [364] = {.lex_state = 144},
  [365] = {.lex_state = 0},
  [366] = {.lex_state = 8},
  [367] = {.lex_state = 144},
  [368] = {.lex_state = 5},
  [369] = {.lex_state = 144},
  [370] = {.lex_state = 8},
  [371] = {.lex_state = 144},
  [372] = {.lex_state = 5},
  [373] = {.lex_state = 5},
  [374] = {.lex_state = 0},
  [375] = {.lex_state = 0},
  [376] = {.lex_state = 0},
  [377] = {.lex_state = 0},
  [378] = {.lex_state = 5},
  [379] = {.lex_state = 8},
  [380] = {.lex_state = 5},
  [381] = {.lex_state = 0},
  [382] = {.lex_state = 0},
  [383] = {.lex_state = 8},
  [384] = {.lex_state = 0},
  [385] = {.lex_state = 5},
  [386] = {.lex_state = 8},
  [387] = {.lex_state = 0},
  [388] = {.lex_state = 0},
  [389] = {.lex_state = 5},
  [390] = {.lex_state = 5},
  [391] = {.lex_state = 5},
  [392] = {.lex_state = 8},
  [393] = {.lex_state = 0},
  [394] = {.lex_state = 8},
  [395] = {.lex_state = 0},
  [396] = {.lex_state = 8},
  [397] = {.lex_state = 0},
  [398] = {.lex_state = 14},
  [399] = {.lex_state = 5},
  [400] = {.lex_state = 0},
  [401] = {.lex_state = 0},
  [402] = {.lex_state = 5},
  [403] = {.lex_state = 5},
  [404] = {.lex_state = 0},
  [405] = {.lex_state = 5},
  [406] = {.lex_state = 5},
  [407] = {.lex_state = 5},
  [408] = {.lex_state = 5},
  [409] = {.lex_state = 5},
  [410] = {.lex_state = 0},
  [411] = {.lex_state = 5},
  [412] = {.lex_state = 5},
  [413] = {.lex_state = 5},
  [414] = {.lex_state = 0},
  [415] = {.lex_state = 0},
  [416] = {.lex_state = 5},
  [417] = {.lex_state = 0},
  [418] = {.lex_state = 5},
  [419] = {.lex_state = 5},
  [420] = {.lex_state = 0},
  [421] = {.lex_state = 5},
  [422] = {.lex_state = 5},
  [423] = {.lex_state = 5},
  [424] = {.lex_state = 5},
  [425] = {.lex_state = 0},
  [426] = {.lex_state = 5},
  [427] = {.lex_state = 0},
  [428] = {.lex_state = 5},
  [429] = {.lex_state = 0},
  [430] = {.lex_state = 0},
  [431] = {.lex_state = 14},
  [432] = {.lex_state = 0},
  [433] = {.lex_state = 0},
  [434] = {.lex_state = 0},
  [435] = {.lex_state = 5},
  [436] = {.lex_state = 5},
  [437] = {.lex_state = 0},
  [438] = {.lex_state = 0},
  [439] = {.lex_state = 16},
  [440] = {.lex_state = 2},
  [441] = {.lex_state = 9},
  [442] = {.lex_state = 2},
  [443] = {.lex_state = 0},
  [444] = {.lex_state = 143},
  [445] = {.lex_state = 0},
  [446] = {.lex_state = 0},
  [447] = {.lex_state = 0},
  [448] = {.lex_state = 0},
  [449] = {.lex_state = 0},
  [450] = {.lex_state = 0},
  [451] = {.lex_state = 0},
  [452] = {.lex_state = 0},
  [453] = {.lex_state = 5},
  [454] = {.lex_state = 2},
  [455] = {.lex_state = 0},
  [456] = {.lex_state = 0},
  [457] = {.lex_state = 2},
  [458] = {.lex_state = 0},
  [459] = {.lex_state = 0},
  [460] = {.lex_state = 2},
  [461] = {.lex_state = 0},
  [462] = {.lex_state = 5},
  [463] = {.lex_state = 0},
  [464] = {.lex_state = 5},
  [465] = {.lex_state = 2},
  [466] = {.lex_state = 5},
  [467] = {.lex_state = 0},
  [468] = {.lex_state = 0},
  [469] = {.lex_state = 144},
  [470] = {.lex_state = 0},
  [471] = {.lex_state = 5},
  [472] = {.lex_state = 0},
  [473] = {.lex_state = 2},
  [474] = {.lex_state = 0},
  [475] = {.lex_state = 0},
  [476] = {.lex_state = 5},
  [477] = {.lex_state = 0},
  [478] = {.lex_state = 0},
  [479] = {.lex_state = 143},
  [480] = {.lex_state = 0},
  [481] = {.lex_state = 143},
  [482] = {.lex_state = 0},
  [483] = {.lex_state = 5},
  [484] = {.lex_state = 0},
  [485] = {.lex_state = 2},
  [486] = {.lex_state = 16},
  [487] = {.lex_state = 0},
  [488] = {.lex_state = 0},
  [489] = {.lex_state = 0},
  [490] = {.lex_state = 0},
  [491] = {.lex_state = 0},
  [492] = {.lex_state = 2},
  [493] = {.lex_state = 144},
  [494] = {.lex_state = 5},
  [495] = {.lex_state = 2},
  [496] = {.lex_state = 16},
  [497] = {.lex_state = 144},
  [498] = {.lex_state = 1},
  [499] = {.lex_state = 0},
  [500] = {.lex_state = 0},
  [501] = {.lex_state = 0},
  [502] = {.lex_state = 0},
  [503] = {.lex_state = 0},
  [504] = {.lex_state = 0},
  [505] = {.lex_state = 0},
  [506] = {.lex_state = 2},
  [507] = {.lex_state = 0},
  [508] = {.lex_state = 2},
  [509] = {.lex_state = 0},
  [510] = {.lex_state = 0},
  [511] = {.lex_state = 2},
  [512] = {.lex_state = 2},
  [513] = {.lex_state = 2},
  [514] = {.lex_state = 2},
  [515] = {.lex_state = 0},
  [516] = {.lex_state = 0},
  [517] = {.lex_state = 5},
  [518] = {.lex_state = 0},
  [519] = {.lex_state = 0},
  [520] = {.lex_state = 5},
  [521] = {.lex_state = 0},
  [522] = {.lex_state = 0},
  [523] = {.lex_state = 5},
  [524] = {.lex_state = 0},
  [525] = {.lex_state = 0},
  [526] = {.lex_state = 0},
  [527] = {.lex_state = 0},
  [528] = {.lex_state = 0},
  [529] = {.lex_state = 144},
  [530] = {.lex_state = 5},
  [531] = {.lex_state = 1},
  [532] = {.lex_state = 1},
  [533] = {.lex_state = 16},
  [534] = {.lex_state = 0},
  [535] = {.lex_state = 0},
  [536] = {.lex_state = 2},
  [537] = {.lex_state = 0},
  [538] = {.lex_state = 0},
  [539] = {.lex_state = 5},
  [540] = {.lex_state = 0},
  [541] = {.lex_state = 0},
  [542] = {.lex_state = 0},
  [543] = {.lex_state = 5},
  [544] = {.lex_state = 0},
  [545] = {.lex_state = 2},
  [546] = {.lex_state = 0},
  [547] = {.lex_state = 2},
  [548] = {.lex_state = 19},
  [549] = {.lex_state = 5},
  [550] = {.lex_state = 18},
  [551] = {.lex_state = 0},
  [552] = {.lex_state = 0},
  [553] = {.lex_state = 2},
  [554] = {.lex_state = 2},
  [555] = {.lex_state = 5},
  [556] = {.lex_state = 5},
  [557] = {.lex_state = 0},
  [558] = {.lex_state = 143},
  [559] = {.lex_state = 0},
  [560] = {.lex_state = 0},
  [561] = {.lex_state = 0},
  [562] = {.lex_state = 5},
  [563] = {.lex_state = 0},
  [564] = {.lex_state = 0},
  [565] = {.lex_state = 1},
  [566] = {.lex_state = 1},
  [567] = {.lex_state = 143},
  [568] = {.lex_state = 0},
  [569] = {.lex_state = 5},
  [570] = {.lex_state = 5},
  [571] = {.lex_state = 1},
  [572] = {.lex_state = 1},
  [573] = {.lex_state = 1},
  [574] = {.lex_state = 1},
  [575] = {.lex_state = 1},
  [576] = {.lex_state = 5},
  [577] = {.lex_state = 0},
  [578] = {.lex_state = 5},
  [579] = {.lex_state = 5},
  [580] = {.lex_state = 1},
  [581] = {.lex_state = 1},
  [582] = {.lex_state = 1},
  [583] = {.lex_state = 1},
  [584] = {.lex_state = 5},
  [585] = {.lex_state = 1},
  [586] = {.lex_state = 1},
  [587] = {.lex_state = 0},
  [588] = {.lex_state = 1},
  [589] = {.lex_state = 1},
  [590] = {.lex_state = 5},
  [591] = {.lex_state = 1},
  [592] = {.lex_state = 1},
  [593] = {.lex_state = 0},
  [594] = {.lex_state = 5},
  [595] = {.lex_state = 5},
  [596] = {.lex_state = 0},
  [597] = {.lex_state = 5},
  [598] = {.lex_state = 0},
  [599] = {.lex_state = 0},
  [600] = {.lex_state = 0},
  [601] = {.lex_state = 0},
  [602] = {.lex_state = 5},
  [603] = {.lex_state = 1},
  [604] = {.lex_state = 0},
  [605] = {.lex_state = 0},
  [606] = {.lex_state = 5},
  [607] = {.lex_state = 5},
  [608] = {.lex_state = 0},
  [609] = {.lex_state = 5},
  [610] = {.lex_state = 0},
  [611] = {.lex_state = 5},
  [612] = {.lex_state = 0},
  [613] = {.lex_state = 5},
  [614] = {.lex_state = 0},
  [615] = {.lex_state = 0},
  [616] = {.lex_state = 0},
  [617] = {.lex_state = 0},
  [618] = {.lex_state = 0},
  [619] = {.lex_state = 0},
  [620] = {.lex_state = 0},
  [621] = {.lex_state = 5},
  [622] = {.lex_state = 2},
  [623] = {.lex_state = 0},
  [624] = {.lex_state = 143},
  [625] = {.lex_state = 2},
  [626] = {.lex_state = 143},
  [627] = {.lex_state = 0},
  [628] = {.lex_state = 5},
  [629] = {.lex_state = 0},
  [630] = {.lex_state = 5},
  [631] = {.lex_state = 0},
  [632] = {.lex_state = 0},
  [633] = {.lex_state = 0},
  [634] = {.lex_state = 0},
  [635] = {.lex_state = 0},
  [636] = {.lex_state = 5},
  [637] = {.lex_state = 5},
  [638] = {.lex_state = 5},
  [639] = {.lex_state = 5},
  [640] = {.lex_state = 5},
  [641] = {(TSStateId)(-1)},
  [642] = {(TSStateId)(-1)},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym_block_comment] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_POUND] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_fn] = ACTIONS(1),
    [anon_sym_entity] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_pipeline] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_port] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_impl] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_trait] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [anon_sym_mod] = ACTIONS(1),
    [anon_sym_DOLLARconfig] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_reg] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_decl] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_DOLLARif] = ACTIONS(1),
    [anon_sym_DOLLARelse] = ACTIONS(1),
    [anon_sym_assert] = ACTIONS(1),
    [anon_sym_reset] = ACTIONS(1),
    [anon_sym_initial] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [sym_op_div] = ACTIONS(1),
    [sym_op_mod] = ACTIONS(1),
    [sym_op_equals] = ACTIONS(1),
    [sym_op_ne] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [sym_op_le] = ACTIONS(1),
    [sym_op_ge] = ACTIONS(1),
    [sym_op_lshift] = ACTIONS(1),
    [sym_op_rshift] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [sym_op_bitwise_xor] = ACTIONS(1),
    [sym_op_bitwise_or] = ACTIONS(1),
    [sym_op_logical_and] = ACTIONS(1),
    [sym_op_logical_or] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_match] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_inst] = ACTIONS(1),
    [anon_sym_COLON_COLON_LT] = ACTIONS(1),
    [anon_sym_COLON_COLON_DOLLAR_LT] = ACTIONS(1),
    [anon_sym_stage] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym___builtin__] = ACTIONS(1),
    [anon_sym_DOLLAR_LPAREN] = ACTIONS(1),
    [sym_self] = ACTIONS(1),
    [anon_sym_inv] = ACTIONS(1),
    [anon_sym_int] = ACTIONS(1),
    [anon_sym_bool] = ACTIONS(1),
    [anon_sym_clock] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [aux_sym_int_literal_token1] = ACTIONS(1),
    [aux_sym_int_literal_token2] = ACTIONS(1),
    [aux_sym_int_literal_token3] = ACTIONS(1),
    [sym_doc_comment] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_SLASH_STAR] = ACTIONS(7),
  },
  [1] = {
    [sym_source_file] = STATE(598),
    [sym_attribute] = STATE(290),
    [sym__item] = STATE(247),
    [sym_unit_definition] = STATE(267),
    [sym__unit_head] = STATE(377),
    [sym__pipeline_start] = STATE(562),
    [sym_struct_definition] = STATE(267),
    [sym_enum_definition] = STATE(267),
    [sym_impl] = STATE(267),
    [sym_trait] = STATE(267),
    [sym_use] = STATE(267),
    [sym_mod] = STATE(267),
    [sym_comptime_config] = STATE(267),
    [sym_block_comment] = STATE(1),
    [aux_sym_source_file_repeat1] = STATE(153),
    [aux_sym__item_repeat1] = STATE(156),
    [ts_builtin_sym_end] = ACTIONS(9),
    [anon_sym_POUND] = ACTIONS(11),
    [anon_sym_fn] = ACTIONS(13),
    [anon_sym_entity] = ACTIONS(13),
    [anon_sym_pipeline] = ACTIONS(15),
    [anon_sym_struct] = ACTIONS(17),
    [anon_sym_enum] = ACTIONS(19),
    [anon_sym_impl] = ACTIONS(21),
    [anon_sym_trait] = ACTIONS(23),
    [anon_sym_use] = ACTIONS(25),
    [anon_sym_mod] = ACTIONS(27),
    [anon_sym_DOLLARconfig] = ACTIONS(29),
    [sym_doc_comment] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_SLASH_STAR] = ACTIONS(7),
  },
  [2] = {
    [sym_block] = STATE(133),
    [sym__statement] = STATE(143),
    [sym_let_binding] = STATE(627),
    [sym_reg_statement] = STATE(627),
    [sym_set_statement] = STATE(627),
    [sym_decl_statement] = STATE(627),
    [sym_pipeline_reg_marker] = STATE(627),
    [sym_pipeline_stage_name] = STATE(147),
    [sym_comptime_if] = STATE(147),
    [sym_assert_statement] = STATE(627),
    [sym__expression] = STATE(92),
    [sym_op_sub] = STATE(31),
    [sym_binary_expression] = STATE(144),
    [sym_unary_expression] = STATE(144),
    [sym_if_expression] = STATE(133),
    [sym_match_expression] = STATE(133),
    [sym__base_expression] = STATE(144),
    [sym__simple_base_expression] = STATE(136),
    [sym_field_access] = STATE(133),
    [sym_method_call] = STATE(133),
    [sym_index] = STATE(133),
    [sym_array_literal] = STATE(133),
    [sym_tuple_literal] = STATE(133),
    [sym_paren_expression] = STATE(133),
    [sym_function_call] = STATE(133),
    [sym_entity_instance] = STATE(133),
    [sym_pipeline_instance] = STATE(133),
    [sym_stage_reference] = STATE(133),
    [sym_bool_literal] = STATE(133),
    [sym_scoped_identifier] = STATE(71),
    [sym__path] = STATE(577),
    [sym__scoped_or_raw_ident] = STATE(66),
    [sym_int_literal] = STATE(133),
    [sym_block_comment] = STATE(2),
    [aux_sym_block_repeat1] = STATE(3),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_RBRACE] = ACTIONS(37),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_reg] = ACTIONS(41),
    [anon_sym_set] = ACTIONS(43),
    [anon_sym_decl] = ACTIONS(45),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_DOLLARif] = ACTIONS(51),
    [anon_sym_assert] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(59),
    [anon_sym_inst] = ACTIONS(61),
    [anon_sym_stage] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [sym_self] = ACTIONS(67),
    [sym_identifier] = ACTIONS(69),
    [anon_sym_COLON_COLON] = ACTIONS(71),
    [aux_sym_int_literal_token1] = ACTIONS(73),
    [aux_sym_int_literal_token2] = ACTIONS(75),
    [aux_sym_int_literal_token3] = ACTIONS(75),
    [sym_doc_comment] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_SLASH_STAR] = ACTIONS(7),
  },
  [3] = {
    [sym_block] = STATE(133),
    [sym__statement] = STATE(143),
    [sym_let_binding] = STATE(627),
    [sym_reg_statement] = STATE(627),
    [sym_set_statement] = STATE(627),
    [sym_decl_statement] = STATE(627),
    [sym_pipeline_reg_marker] = STATE(627),
    [sym_pipeline_stage_name] = STATE(147),
    [sym_comptime_if] = STATE(147),
    [sym_assert_statement] = STATE(627),
    [sym__expression] = STATE(89),
    [sym_op_sub] = STATE(31),
    [sym_binary_expression] = STATE(144),
    [sym_unary_expression] = STATE(144),
    [sym_if_expression] = STATE(133),
    [sym_match_expression] = STATE(133),
    [sym__base_expression] = STATE(144),
    [sym__simple_base_expression] = STATE(136),
    [sym_field_access] = STATE(133),
    [sym_method_call] = STATE(133),
    [sym_index] = STATE(133),
    [sym_array_literal] = STATE(133),
    [sym_tuple_literal] = STATE(133),
    [sym_paren_expression] = STATE(133),
    [sym_function_call] = STATE(133),
    [sym_entity_instance] = STATE(133),
    [sym_pipeline_instance] = STATE(133),
    [sym_stage_reference] = STATE(133),
    [sym_bool_literal] = STATE(133),
    [sym_scoped_identifier] = STATE(71),
    [sym__path] = STATE(577),
    [sym__scoped_or_raw_ident] = STATE(66),
    [sym_int_literal] = STATE(133),
    [sym_block_comment] = STATE(3),
    [aux_sym_block_repeat1] = STATE(67),
    [anon_sym_LBRACK] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [anon_sym_RBRACE] = ACTIONS(77),
    [anon_sym_let] = ACTIONS(39),
    [anon_sym_reg] = ACTIONS(41),
    [anon_sym_set] = ACTIONS(43),
    [anon_sym_decl] = ACTIONS(45),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_DOLLARif] = ACTIONS(51),
    [anon_sym_assert] = ACTIONS(53),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_match] = ACTIONS(59),
    [anon_sym_inst] = ACTIONS(61),
    [anon_sym_stage] = ACTIONS(63),
    [anon_sym_true] = ACTIONS(65),
    [anon_sym_false] = ACTIONS(65),
    [sym_self] = ACTIONS(67),
    [sym_identifier] = ACTIONS(69),
    [anon_sym_COLON_COLON] = ACTIONS(71),
    [aux_sym_int_literal_token1] = ACTIONS(73),
    [aux_sym_int_literal_token2] = ACTIONS(75),
    [aux_sym_int_literal_token3] = ACTIONS(75),
    [sym_doc_comment] = ACTIONS(3),
    [sym_line_comment] = ACTIONS(5),
    [anon_sym_SLASH_STAR] = ACTIONS(7),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(4), 1,
      sym_block_comment,
    ACTIONS(81), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(79), 40,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
      anon_sym_STAR,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_EQ_GT,
      anon_sym_DOT,
      anon_sym___builtin__,
  [63] = 28,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(83), 1,
      anon_sym_RBRACK,
    STATE(5), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(75), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [169] = 28,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(85), 1,
      anon_sym_RBRACK,
    STATE(6), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(76), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [275] = 28,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(87), 1,
      anon_sym_RPAREN,
    STATE(7), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(77), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [381] = 28,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(89), 1,
      anon_sym_RPAREN,
    STATE(8), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(74), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [487] = 28,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(91), 1,
      anon_sym_RPAREN,
    STATE(9), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(81), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [593] = 28,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(93), 1,
      anon_sym_RBRACK,
    STATE(10), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(76), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [699] = 28,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(95), 1,
      anon_sym_RPAREN,
    STATE(11), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(76), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [805] = 28,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(97), 1,
      anon_sym_RPAREN,
    STATE(12), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(81), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [911] = 28,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(99), 1,
      anon_sym_RPAREN,
    STATE(13), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(76), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [1017] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(14), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(102), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [1120] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(15), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(62), 1,
      sym__expression,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [1223] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(16), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(61), 1,
      sym__expression,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [1326] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(17), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(57), 1,
      sym__expression,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [1429] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(18), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(63), 1,
      sym__expression,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [1532] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(19), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(60), 1,
      sym__expression,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [1635] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(20), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(64), 1,
      sym__expression,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [1738] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(21), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(65), 1,
      sym__expression,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [1841] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(22), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(55), 1,
      sym__expression,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [1944] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(23), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(56), 1,
      sym__expression,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [2047] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(24), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(58), 1,
      sym__expression,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [2150] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(25), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(59), 1,
      sym__expression,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [2253] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(26), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(99), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [2356] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(27), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(78), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [2459] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(28), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(86), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [2562] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(29), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(97), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [2665] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(30), 1,
      sym_block_comment,
    STATE(31), 1,
      sym_op_sub,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(72), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [2768] = 26,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(54), 1,
      sym__expression,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(31), 2,
      sym_op_sub,
      sym_block_comment,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [2869] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(32), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(87), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [2972] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(33), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(80), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [3075] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(34), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(82), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [3178] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(35), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(76), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [3281] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(36), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(79), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [3384] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(37), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(88), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [3487] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(38), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(83), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [3590] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(39), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(98), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [3693] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(40), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(91), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [3796] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(41), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(81), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [3899] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(42), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(93), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [4002] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(43), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(94), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [4105] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(44), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(95), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [4208] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(45), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(96), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [4311] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(46), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(73), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [4414] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(47), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(85), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [4517] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(48), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(100), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [4620] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(49), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(101), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [4723] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(31), 1,
      anon_sym_LBRACK,
    ACTIONS(33), 1,
      anon_sym_LPAREN,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(57), 1,
      anon_sym_if,
    ACTIONS(59), 1,
      anon_sym_match,
    ACTIONS(61), 1,
      anon_sym_inst,
    ACTIONS(63), 1,
      anon_sym_stage,
    ACTIONS(67), 1,
      sym_self,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(31), 1,
      sym_op_sub,
    STATE(50), 1,
      sym_block_comment,
    STATE(66), 1,
      sym__scoped_or_raw_ident,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(90), 1,
      sym__expression,
    STATE(136), 1,
      sym__simple_base_expression,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(144), 3,
      sym_binary_expression,
      sym_unary_expression,
      sym__base_expression,
    ACTIONS(47), 4,
      anon_sym_STAR,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
    STATE(133), 15,
      sym_block,
      sym_if_expression,
      sym_match_expression,
      sym_field_access,
      sym_method_call,
      sym_index,
      sym_array_literal,
      sym_tuple_literal,
      sym_paren_expression,
      sym_function_call,
      sym_entity_instance,
      sym_pipeline_instance,
      sym_stage_reference,
      sym_bool_literal,
      sym_int_literal,
  [4826] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(51), 1,
      sym_block_comment,
    ACTIONS(103), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(101), 37,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_else,
      anon_sym_DOT,
      anon_sym___builtin__,
  [4886] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(52), 1,
      sym_block_comment,
    ACTIONS(107), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(105), 37,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_else,
      anon_sym_DOT,
      anon_sym___builtin__,
  [4946] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(53), 1,
      sym_block_comment,
    ACTIONS(111), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(109), 37,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_else,
      anon_sym_DOT,
      anon_sym___builtin__,
  [5006] = 16,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(54), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
    ACTIONS(115), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(113), 22,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym___builtin__,
  [5083] = 23,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(55), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
    ACTIONS(119), 5,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(117), 14,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_op_le,
      sym_op_ge,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym___builtin__,
  [5174] = 22,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(56), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
    ACTIONS(119), 5,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(117), 16,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym___builtin__,
  [5263] = 29,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(119), 1,
      anon_sym_EQ,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(57), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
    ACTIONS(117), 11,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym___builtin__,
  [5366] = 21,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(58), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
    ACTIONS(119), 5,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(117), 18,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym___builtin__,
  [5453] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(119), 1,
      anon_sym_EQ,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(59), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
    ACTIONS(117), 9,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_BQUOTE,
      anon_sym___builtin__,
  [5560] = 26,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(60), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
    ACTIONS(119), 3,
      anon_sym_EQ,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(117), 12,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym___builtin__,
  [5657] = 28,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(61), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(119), 2,
      anon_sym_EQ,
      sym_op_bitwise_or,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
    ACTIONS(117), 11,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym___builtin__,
  [5758] = 27,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(62), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(119), 2,
      anon_sym_EQ,
      sym_op_bitwise_or,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
    ACTIONS(117), 12,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym___builtin__,
  [5857] = 30,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(119), 1,
      anon_sym_EQ,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(63), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
    ACTIONS(117), 10,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym___builtin__,
  [5962] = 16,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(64), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
    ACTIONS(119), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(117), 22,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym___builtin__,
  [6039] = 19,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(65), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
    ACTIONS(119), 5,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(117), 20,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym___builtin__,
  [6122] = 13,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(151), 1,
      anon_sym_LPAREN,
    ACTIONS(155), 1,
      anon_sym_COLON_COLON_LT,
    ACTIONS(157), 1,
      anon_sym_COLON_COLON_DOLLAR_LT,
    ACTIONS(159), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(66), 1,
      sym_block_comment,
    STATE(119), 1,
      sym_argument_list,
    STATE(382), 1,
      sym_turbofish,
    STATE(121), 2,
      sym__named_argument_list,
      sym__positional_argument_list,
    ACTIONS(153), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(149), 23,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [6191] = 16,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(163), 1,
      anon_sym_let,
    ACTIONS(166), 1,
      anon_sym_reg,
    ACTIONS(169), 1,
      anon_sym_set,
    ACTIONS(172), 1,
      anon_sym_decl,
    ACTIONS(175), 1,
      anon_sym_SQUOTE,
    ACTIONS(178), 1,
      anon_sym_DOLLARif,
    ACTIONS(181), 1,
      anon_sym_assert,
    STATE(143), 1,
      sym__statement,
    STATE(67), 2,
      sym_block_comment,
      aux_sym_block_repeat1,
    STATE(147), 2,
      sym_pipeline_stage_name,
      sym_comptime_if,
    STATE(627), 6,
      sym_let_binding,
      sym_reg_statement,
      sym_set_statement,
      sym_decl_statement,
      sym_pipeline_reg_marker,
      sym_assert_statement,
    ACTIONS(184), 9,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
    ACTIONS(161), 12,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
  [6266] = 13,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(151), 1,
      anon_sym_LPAREN,
    ACTIONS(155), 1,
      anon_sym_COLON_COLON_LT,
    ACTIONS(157), 1,
      anon_sym_COLON_COLON_DOLLAR_LT,
    ACTIONS(159), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(68), 1,
      sym_block_comment,
    STATE(109), 1,
      sym_argument_list,
    STATE(375), 1,
      sym_turbofish,
    STATE(121), 2,
      sym__named_argument_list,
      sym__positional_argument_list,
    ACTIONS(188), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(186), 23,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [6335] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(69), 1,
      sym_block_comment,
    ACTIONS(192), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
      anon_sym_COLON_COLON,
    ACTIONS(190), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_EQ_GT,
      anon_sym_DOT,
      anon_sym_COLON_COLON_LT,
      anon_sym_COLON_COLON_DOLLAR_LT,
      anon_sym___builtin__,
      anon_sym_DOLLAR_LPAREN,
  [6389] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(70), 1,
      sym_block_comment,
    ACTIONS(196), 8,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
      anon_sym_COLON_COLON,
    ACTIONS(194), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_EQ_GT,
      anon_sym_DOT,
      anon_sym_COLON_COLON_LT,
      anon_sym_COLON_COLON_DOLLAR_LT,
      anon_sym___builtin__,
      anon_sym_DOLLAR_LPAREN,
  [6443] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(202), 1,
      anon_sym_COLON_COLON,
    STATE(71), 1,
      sym_block_comment,
    ACTIONS(200), 7,
      anon_sym_COLON,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(198), 29,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_for,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_EQ_GT,
      anon_sym_DOT,
      anon_sym_COLON_COLON_LT,
      anon_sym_COLON_COLON_DOLLAR_LT,
      anon_sym___builtin__,
      anon_sym_DOLLAR_LPAREN,
  [6499] = 33,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(206), 1,
      anon_sym_COMMA,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(72), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    STATE(384), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
    ACTIONS(204), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym___builtin__,
  [6606] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(73), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
    ACTIONS(210), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym___builtin__,
  [6708] = 33,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(212), 1,
      anon_sym_RPAREN,
    ACTIONS(214), 1,
      anon_sym_COMMA,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(74), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    STATE(515), 1,
      aux_sym_array_literal_repeat1,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [6813] = 33,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(216), 1,
      anon_sym_RBRACK,
    ACTIONS(218), 1,
      anon_sym_COMMA,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(75), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    STATE(488), 1,
      aux_sym_array_literal_repeat1,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [6918] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(76), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
    ACTIONS(220), 3,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [7019] = 33,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(222), 1,
      anon_sym_RPAREN,
    ACTIONS(224), 1,
      anon_sym_COMMA,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(77), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    STATE(490), 1,
      aux_sym__positional_argument_list_repeat1,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [7124] = 32,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(226), 1,
      anon_sym_RPAREN,
    ACTIONS(228), 1,
      anon_sym_COMMA,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(78), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [7226] = 32,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(230), 1,
      anon_sym_LBRACE,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(79), 1,
      sym_block_comment,
    STATE(137), 1,
      sym_match_block,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [7328] = 32,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(80), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    STATE(593), 1,
      sym_block,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [7430] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(81), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    ACTIONS(232), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [7530] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(82), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    ACTIONS(234), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [7630] = 32,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(236), 1,
      anon_sym_COMMA,
    ACTIONS(238), 1,
      anon_sym_RBRACE,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(83), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [7732] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(84), 1,
      sym_block_comment,
    ACTIONS(242), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(240), 27,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_EQ_GT,
      anon_sym_DOT,
      anon_sym___builtin__,
  [7782] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(244), 1,
      anon_sym_SEMI,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(85), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [7881] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(246), 1,
      anon_sym_EQ,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(86), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [7980] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(248), 1,
      anon_sym_SEMI,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(87), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [8079] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(250), 1,
      anon_sym_SEMI,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(88), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [8178] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(252), 1,
      anon_sym_RBRACE,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(89), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [8277] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(254), 1,
      anon_sym_SEMI,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(90), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [8376] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(256), 1,
      anon_sym_SEMI,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(91), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [8475] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(77), 1,
      anon_sym_RBRACE,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(92), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [8574] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(258), 1,
      anon_sym_COLON,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(93), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [8673] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(260), 1,
      anon_sym_RPAREN,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(94), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [8772] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(262), 1,
      anon_sym_SEMI,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(95), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [8871] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(264), 1,
      anon_sym_COMMA,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(96), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [8970] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(266), 1,
      anon_sym_SEMI,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(97), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [9069] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(268), 1,
      anon_sym_RBRACE,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(98), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [9168] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(270), 1,
      anon_sym_RBRACK,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(99), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [9267] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(272), 1,
      anon_sym_SEMI,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(100), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [9366] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(274), 1,
      anon_sym_RPAREN,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(101), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [9465] = 31,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(55), 1,
      anon_sym_DASH,
    ACTIONS(121), 1,
      anon_sym_STAR,
    ACTIONS(123), 1,
      anon_sym_PLUS,
    ACTIONS(125), 1,
      sym_op_div,
    ACTIONS(127), 1,
      sym_op_mod,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    ACTIONS(139), 1,
      anon_sym_AMP,
    ACTIONS(141), 1,
      sym_op_bitwise_xor,
    ACTIONS(143), 1,
      sym_op_bitwise_or,
    ACTIONS(145), 1,
      sym_op_logical_and,
    ACTIONS(147), 1,
      sym_op_logical_or,
    ACTIONS(208), 1,
      anon_sym_BQUOTE,
    ACTIONS(276), 1,
      anon_sym_RBRACE,
    STATE(19), 1,
      sym_op_bitwise_and,
    STATE(20), 1,
      sym__op_mul_like,
    STATE(21), 1,
      sym__op_add_like,
    STATE(22), 1,
      sym__op_relational,
    STATE(23), 1,
      sym__op_eq_like,
    STATE(24), 1,
      sym__op_shifty,
    STATE(25), 1,
      sym_op_custom_infix,
    STATE(102), 1,
      sym_block_comment,
    STATE(197), 1,
      sym_op_mul,
    ACTIONS(129), 2,
      sym_op_equals,
      sym_op_ne,
    ACTIONS(131), 2,
      sym_op_lshift,
      sym_op_rshift,
    ACTIONS(137), 2,
      sym_op_le,
      sym_op_ge,
    STATE(178), 2,
      sym_op_add,
      sym_op_sub,
    STATE(204), 2,
      sym_op_lt,
      sym_op_gt,
  [9564] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(103), 1,
      sym_block_comment,
    ACTIONS(280), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(278), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [9611] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(104), 1,
      sym_block_comment,
    ACTIONS(284), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(282), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [9658] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(105), 1,
      sym_block_comment,
    ACTIONS(288), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(286), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [9705] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(106), 1,
      sym_block_comment,
    ACTIONS(292), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(290), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [9752] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(107), 1,
      sym_block_comment,
    ACTIONS(296), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(294), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [9799] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(108), 1,
      sym_block_comment,
    ACTIONS(300), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(298), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [9846] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(109), 1,
      sym_block_comment,
    ACTIONS(304), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(302), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [9893] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(110), 1,
      sym_block_comment,
    ACTIONS(308), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(306), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [9940] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(111), 1,
      sym_block_comment,
    ACTIONS(312), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(310), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [9987] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(112), 1,
      sym_block_comment,
    ACTIONS(316), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(314), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10034] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(113), 1,
      sym_block_comment,
    ACTIONS(320), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(318), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10081] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(114), 1,
      sym_block_comment,
    ACTIONS(324), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(322), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10128] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(115), 1,
      sym_block_comment,
    ACTIONS(328), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(326), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10175] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(116), 1,
      sym_block_comment,
    ACTIONS(332), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(330), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10222] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(117), 1,
      sym_block_comment,
    ACTIONS(336), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(334), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10269] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(118), 1,
      sym_block_comment,
    ACTIONS(340), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(338), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10316] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(119), 1,
      sym_block_comment,
    ACTIONS(344), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(342), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10363] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(120), 1,
      sym_block_comment,
    ACTIONS(348), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(346), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10410] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(121), 1,
      sym_block_comment,
    ACTIONS(352), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(350), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10457] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(122), 1,
      sym_block_comment,
    ACTIONS(356), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(354), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10504] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(362), 1,
      anon_sym_DOLLARelse,
    STATE(123), 1,
      sym_block_comment,
    STATE(146), 1,
      sym_comptime_else,
    ACTIONS(358), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    ACTIONS(360), 14,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_assert,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
  [10555] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(124), 1,
      sym_block_comment,
    ACTIONS(366), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(364), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10602] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(125), 1,
      sym_block_comment,
    ACTIONS(370), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(368), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10649] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(126), 1,
      sym_block_comment,
    ACTIONS(374), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(372), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10696] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(127), 1,
      sym_block_comment,
    ACTIONS(378), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(376), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10743] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(128), 1,
      sym_block_comment,
    ACTIONS(382), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(380), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10790] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(129), 1,
      sym_block_comment,
    ACTIONS(386), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(384), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10837] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(130), 1,
      sym_block_comment,
    ACTIONS(390), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(388), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10884] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(131), 1,
      sym_block_comment,
    ACTIONS(394), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(392), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10931] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(132), 1,
      sym_block_comment,
    ACTIONS(398), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(396), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [10978] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(133), 1,
      sym_block_comment,
    ACTIONS(153), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(149), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [11025] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(362), 1,
      anon_sym_DOLLARelse,
    STATE(134), 1,
      sym_block_comment,
    STATE(148), 1,
      sym_comptime_else,
    ACTIONS(400), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    ACTIONS(402), 14,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_assert,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
  [11076] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(135), 1,
      sym_block_comment,
    ACTIONS(406), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(404), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [11123] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(408), 1,
      anon_sym_LBRACK,
    ACTIONS(414), 1,
      anon_sym_DOT,
    STATE(136), 1,
      sym_block_comment,
    ACTIONS(412), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(410), 22,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym___builtin__,
  [11174] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(137), 1,
      sym_block_comment,
    ACTIONS(418), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(416), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [11221] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(138), 1,
      sym_block_comment,
    ACTIONS(422), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(420), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [11268] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(139), 1,
      sym_block_comment,
    ACTIONS(426), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(424), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [11315] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(140), 1,
      sym_block_comment,
    ACTIONS(430), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(428), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [11362] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(141), 1,
      sym_block_comment,
    ACTIONS(434), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(432), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [11409] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(142), 1,
      sym_block_comment,
    ACTIONS(438), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(436), 24,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym_DOT,
      anon_sym___builtin__,
  [11456] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(143), 1,
      sym_block_comment,
    ACTIONS(440), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    ACTIONS(442), 14,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_assert,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
  [11501] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(144), 1,
      sym_block_comment,
    ACTIONS(446), 6,
      anon_sym_EQ,
      sym_op_div,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_AMP,
      sym_op_bitwise_or,
    ACTIONS(444), 22,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_PLUS,
      anon_sym_DASH,
      sym_op_mod,
      sym_op_equals,
      sym_op_ne,
      sym_op_le,
      sym_op_ge,
      sym_op_lshift,
      sym_op_rshift,
      sym_op_bitwise_xor,
      sym_op_logical_and,
      sym_op_logical_or,
      anon_sym_BQUOTE,
      anon_sym___builtin__,
  [11546] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(145), 1,
      sym_block_comment,
    ACTIONS(448), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    ACTIONS(450), 14,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_assert,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
  [11591] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(146), 1,
      sym_block_comment,
    ACTIONS(400), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    ACTIONS(402), 14,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_assert,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
  [11636] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(147), 1,
      sym_block_comment,
    ACTIONS(452), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    ACTIONS(454), 14,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_assert,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
  [11681] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(148), 1,
      sym_block_comment,
    ACTIONS(456), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    ACTIONS(458), 14,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_assert,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
  [11726] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(149), 1,
      sym_block_comment,
    ACTIONS(460), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    ACTIONS(462), 14,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_assert,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
  [11771] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(150), 1,
      sym_block_comment,
    ACTIONS(464), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    ACTIONS(466), 14,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_assert,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
  [11816] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(151), 1,
      sym_block_comment,
    ACTIONS(468), 14,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    ACTIONS(470), 14,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_assert,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
  [11861] = 21,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(474), 1,
      anon_sym_POUND,
    ACTIONS(480), 1,
      anon_sym_pipeline,
    ACTIONS(483), 1,
      anon_sym_struct,
    ACTIONS(486), 1,
      anon_sym_enum,
    ACTIONS(489), 1,
      anon_sym_impl,
    ACTIONS(492), 1,
      anon_sym_trait,
    ACTIONS(495), 1,
      anon_sym_use,
    ACTIONS(498), 1,
      anon_sym_mod,
    ACTIONS(501), 1,
      anon_sym_DOLLARconfig,
    STATE(156), 1,
      aux_sym__item_repeat1,
    STATE(247), 1,
      sym__item,
    STATE(290), 1,
      sym_attribute,
    STATE(377), 1,
      sym__unit_head,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(472), 2,
      ts_builtin_sym_end,
      anon_sym_RBRACE,
    ACTIONS(477), 2,
      anon_sym_fn,
      anon_sym_entity,
    STATE(152), 2,
      sym_block_comment,
      aux_sym_source_file_repeat1,
    STATE(267), 8,
      sym_unit_definition,
      sym_struct_definition,
      sym_enum_definition,
      sym_impl,
      sym_trait,
      sym_use,
      sym_mod,
      sym_comptime_config,
  [11935] = 22,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(17), 1,
      anon_sym_struct,
    ACTIONS(19), 1,
      anon_sym_enum,
    ACTIONS(21), 1,
      anon_sym_impl,
    ACTIONS(23), 1,
      anon_sym_trait,
    ACTIONS(25), 1,
      anon_sym_use,
    ACTIONS(27), 1,
      anon_sym_mod,
    ACTIONS(29), 1,
      anon_sym_DOLLARconfig,
    ACTIONS(504), 1,
      ts_builtin_sym_end,
    STATE(152), 1,
      aux_sym_source_file_repeat1,
    STATE(153), 1,
      sym_block_comment,
    STATE(156), 1,
      aux_sym__item_repeat1,
    STATE(247), 1,
      sym__item,
    STATE(290), 1,
      sym_attribute,
    STATE(377), 1,
      sym__unit_head,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
    STATE(267), 8,
      sym_unit_definition,
      sym_struct_definition,
      sym_enum_definition,
      sym_impl,
      sym_trait,
      sym_use,
      sym_mod,
      sym_comptime_config,
  [12010] = 22,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(17), 1,
      anon_sym_struct,
    ACTIONS(19), 1,
      anon_sym_enum,
    ACTIONS(21), 1,
      anon_sym_impl,
    ACTIONS(23), 1,
      anon_sym_trait,
    ACTIONS(25), 1,
      anon_sym_use,
    ACTIONS(27), 1,
      anon_sym_mod,
    ACTIONS(29), 1,
      anon_sym_DOLLARconfig,
    ACTIONS(506), 1,
      anon_sym_RBRACE,
    STATE(152), 1,
      aux_sym_source_file_repeat1,
    STATE(154), 1,
      sym_block_comment,
    STATE(156), 1,
      aux_sym__item_repeat1,
    STATE(247), 1,
      sym__item,
    STATE(290), 1,
      sym_attribute,
    STATE(377), 1,
      sym__unit_head,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
    STATE(267), 8,
      sym_unit_definition,
      sym_struct_definition,
      sym_enum_definition,
      sym_impl,
      sym_trait,
      sym_use,
      sym_mod,
      sym_comptime_config,
  [12085] = 22,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(17), 1,
      anon_sym_struct,
    ACTIONS(19), 1,
      anon_sym_enum,
    ACTIONS(21), 1,
      anon_sym_impl,
    ACTIONS(23), 1,
      anon_sym_trait,
    ACTIONS(25), 1,
      anon_sym_use,
    ACTIONS(27), 1,
      anon_sym_mod,
    ACTIONS(29), 1,
      anon_sym_DOLLARconfig,
    ACTIONS(508), 1,
      anon_sym_RBRACE,
    STATE(154), 1,
      aux_sym_source_file_repeat1,
    STATE(155), 1,
      sym_block_comment,
    STATE(156), 1,
      aux_sym__item_repeat1,
    STATE(247), 1,
      sym__item,
    STATE(290), 1,
      sym_attribute,
    STATE(377), 1,
      sym__unit_head,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
    STATE(267), 8,
      sym_unit_definition,
      sym_struct_definition,
      sym_enum_definition,
      sym_impl,
      sym_trait,
      sym_use,
      sym_mod,
      sym_comptime_config,
  [12160] = 19,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(11), 1,
      anon_sym_POUND,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(17), 1,
      anon_sym_struct,
    ACTIONS(19), 1,
      anon_sym_enum,
    ACTIONS(21), 1,
      anon_sym_impl,
    ACTIONS(23), 1,
      anon_sym_trait,
    ACTIONS(25), 1,
      anon_sym_use,
    ACTIONS(27), 1,
      anon_sym_mod,
    ACTIONS(29), 1,
      anon_sym_DOLLARconfig,
    STATE(156), 1,
      sym_block_comment,
    STATE(236), 1,
      aux_sym__item_repeat1,
    STATE(290), 1,
      sym_attribute,
    STATE(377), 1,
      sym__unit_head,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
    STATE(270), 8,
      sym_unit_definition,
      sym_struct_definition,
      sym_enum_definition,
      sym_impl,
      sym_trait,
      sym_use,
      sym_mod,
      sym_comptime_config,
  [12226] = 18,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(516), 1,
      anon_sym_GT,
    ACTIONS(518), 1,
      anon_sym_AMP,
    ACTIONS(520), 1,
      anon_sym_inv,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(526), 1,
      aux_sym_int_literal_token1,
    STATE(157), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(457), 1,
      sym_type,
    ACTIONS(528), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [12288] = 18,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(530), 1,
      anon_sym_RPAREN,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    STATE(158), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(457), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [12350] = 19,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(536), 1,
      anon_sym_LPAREN,
    ACTIONS(538), 1,
      anon_sym_RBRACE,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(159), 1,
      sym_block_comment,
    STATE(176), 1,
      aux_sym_match_block_repeat1,
    STATE(289), 1,
      sym__scoped_or_raw_ident,
    STATE(314), 1,
      sym_match_arm,
    STATE(563), 1,
      sym_last_match_arm,
    STATE(566), 1,
      sym__pattern,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(362), 5,
      sym_bool_literal,
      sym_tuple_pattern,
      sym_named_unpack,
      sym_positional_unpack,
      sym_int_literal,
  [12414] = 18,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    ACTIONS(540), 1,
      anon_sym_RPAREN,
    STATE(160), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(489), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [12476] = 18,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(518), 1,
      anon_sym_AMP,
    ACTIONS(520), 1,
      anon_sym_inv,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(526), 1,
      aux_sym_int_literal_token1,
    ACTIONS(542), 1,
      anon_sym_GT,
    STATE(161), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(457), 1,
      sym_type,
    ACTIONS(528), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [12538] = 18,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(518), 1,
      anon_sym_AMP,
    ACTIONS(520), 1,
      anon_sym_inv,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(526), 1,
      aux_sym_int_literal_token1,
    ACTIONS(544), 1,
      anon_sym_GT,
    STATE(162), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(440), 1,
      sym_type,
    ACTIONS(528), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [12600] = 18,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(518), 1,
      anon_sym_AMP,
    ACTIONS(520), 1,
      anon_sym_inv,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(526), 1,
      aux_sym_int_literal_token1,
    ACTIONS(546), 1,
      anon_sym_GT,
    STATE(163), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(465), 1,
      sym_type,
    ACTIONS(528), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [12662] = 18,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(518), 1,
      anon_sym_AMP,
    ACTIONS(520), 1,
      anon_sym_inv,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(526), 1,
      aux_sym_int_literal_token1,
    ACTIONS(548), 1,
      anon_sym_GT,
    STATE(164), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(457), 1,
      sym_type,
    ACTIONS(528), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [12724] = 18,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(518), 1,
      anon_sym_AMP,
    ACTIONS(520), 1,
      anon_sym_inv,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(526), 1,
      aux_sym_int_literal_token1,
    ACTIONS(550), 1,
      anon_sym_GT,
    STATE(165), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(457), 1,
      sym_type,
    ACTIONS(528), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [12786] = 18,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    ACTIONS(552), 1,
      anon_sym_RPAREN,
    STATE(166), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(457), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [12848] = 18,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    ACTIONS(554), 1,
      anon_sym_RPAREN,
    STATE(167), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(507), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [12910] = 18,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(518), 1,
      anon_sym_AMP,
    ACTIONS(520), 1,
      anon_sym_inv,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(526), 1,
      aux_sym_int_literal_token1,
    ACTIONS(556), 1,
      anon_sym_GT,
    STATE(168), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(457), 1,
      sym_type,
    ACTIONS(528), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [12972] = 18,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(518), 1,
      anon_sym_AMP,
    ACTIONS(520), 1,
      anon_sym_inv,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(526), 1,
      aux_sym_int_literal_token1,
    ACTIONS(558), 1,
      anon_sym_GT,
    STATE(169), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(511), 1,
      sym_type,
    ACTIONS(528), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [13034] = 18,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    ACTIONS(560), 1,
      anon_sym_RPAREN,
    STATE(170), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(457), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [13096] = 18,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    ACTIONS(562), 1,
      anon_sym_RPAREN,
    STATE(171), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(457), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [13158] = 18,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(518), 1,
      anon_sym_AMP,
    ACTIONS(520), 1,
      anon_sym_inv,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(526), 1,
      aux_sym_int_literal_token1,
    ACTIONS(564), 1,
      anon_sym_GT,
    STATE(172), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(457), 1,
      sym_type,
    ACTIONS(528), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [13220] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    STATE(173), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(635), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [13279] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(174), 1,
      sym_block_comment,
    ACTIONS(568), 9,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
    ACTIONS(566), 11,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
  [13316] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(175), 1,
      sym_block_comment,
    ACTIONS(572), 9,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
    ACTIONS(570), 11,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
  [13353] = 18,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(536), 1,
      anon_sym_LPAREN,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(176), 1,
      sym_block_comment,
    STATE(209), 1,
      aux_sym_match_block_repeat1,
    STATE(289), 1,
      sym__scoped_or_raw_ident,
    STATE(314), 1,
      sym_match_arm,
    STATE(566), 1,
      sym__pattern,
    STATE(577), 1,
      sym__path,
    STATE(616), 1,
      sym_last_match_arm,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(362), 5,
      sym_bool_literal,
      sym_tuple_pattern,
      sym_named_unpack,
      sym_positional_unpack,
      sym_int_literal,
  [13414] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(177), 1,
      sym_block_comment,
    ACTIONS(576), 9,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
    ACTIONS(574), 11,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
  [13451] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(178), 1,
      sym_block_comment,
    ACTIONS(580), 9,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
    ACTIONS(578), 11,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
  [13488] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(518), 1,
      anon_sym_AMP,
    ACTIONS(520), 1,
      anon_sym_inv,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(526), 1,
      aux_sym_int_literal_token1,
    STATE(179), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(553), 1,
      sym_type,
    ACTIONS(528), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [13547] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    STATE(180), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(587), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [13606] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    STATE(181), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(281), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [13665] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    STATE(182), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(457), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [13724] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    STATE(183), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(619), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [13783] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    STATE(184), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(283), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [13842] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    STATE(185), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(452), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [13901] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(186), 1,
      sym_block_comment,
    ACTIONS(584), 9,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
    ACTIONS(582), 11,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
  [13938] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    STATE(187), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(376), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [13997] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    STATE(188), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(568), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [14056] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    STATE(189), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(369), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [14115] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    STATE(190), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(564), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [14174] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    STATE(191), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(622), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [14233] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(526), 1,
      aux_sym_int_literal_token1,
    ACTIONS(586), 1,
      anon_sym_LBRACK,
    ACTIONS(588), 1,
      anon_sym_LPAREN,
    ACTIONS(590), 1,
      anon_sym_LBRACE,
    ACTIONS(592), 1,
      anon_sym_AMP,
    ACTIONS(594), 1,
      anon_sym_inv,
    ACTIONS(598), 1,
      sym_identifier,
    STATE(192), 1,
      sym_block_comment,
    STATE(498), 1,
      sym__base_type,
    STATE(571), 1,
      sym_type,
    ACTIONS(528), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(532), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(596), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(565), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [14292] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    STATE(193), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(596), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [14351] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(194), 1,
      sym_block_comment,
    ACTIONS(602), 9,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
    ACTIONS(600), 11,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
  [14388] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(195), 1,
      sym_block_comment,
    ACTIONS(606), 9,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
    ACTIONS(604), 11,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
  [14425] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    STATE(196), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(500), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [14484] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(197), 1,
      sym_block_comment,
    ACTIONS(610), 9,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
    ACTIONS(608), 11,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
  [14521] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(198), 1,
      sym_block_comment,
    ACTIONS(614), 9,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
    ACTIONS(612), 11,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
  [14558] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(518), 1,
      anon_sym_AMP,
    ACTIONS(520), 1,
      anon_sym_inv,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(526), 1,
      aux_sym_int_literal_token1,
    STATE(199), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(457), 1,
      sym_type,
    ACTIONS(528), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [14617] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(518), 1,
      anon_sym_AMP,
    ACTIONS(520), 1,
      anon_sym_inv,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(526), 1,
      aux_sym_int_literal_token1,
    STATE(200), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(281), 1,
      sym_type,
    ACTIONS(528), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [14676] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(518), 1,
      anon_sym_AMP,
    ACTIONS(520), 1,
      anon_sym_inv,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(526), 1,
      aux_sym_int_literal_token1,
    STATE(201), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(283), 1,
      sym_type,
    ACTIONS(528), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [14735] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(202), 1,
      sym_block_comment,
    ACTIONS(618), 9,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
    ACTIONS(616), 11,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
  [14772] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(203), 1,
      sym_block_comment,
    ACTIONS(622), 9,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
    ACTIONS(620), 11,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
  [14809] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(204), 1,
      sym_block_comment,
    ACTIONS(626), 9,
      anon_sym_if,
      anon_sym_match,
      anon_sym_inst,
      anon_sym_stage,
      anon_sym_true,
      anon_sym_false,
      sym_self,
      sym_identifier,
      aux_sym_int_literal_token1,
    ACTIONS(624), 11,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
      anon_sym_DASH,
      anon_sym_AMP,
      anon_sym_BANG,
      anon_sym_TILDE,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
  [14846] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(526), 1,
      aux_sym_int_literal_token1,
    ACTIONS(586), 1,
      anon_sym_LBRACK,
    ACTIONS(588), 1,
      anon_sym_LPAREN,
    ACTIONS(590), 1,
      anon_sym_LBRACE,
    ACTIONS(592), 1,
      anon_sym_AMP,
    ACTIONS(594), 1,
      anon_sym_inv,
    ACTIONS(598), 1,
      sym_identifier,
    STATE(205), 1,
      sym_block_comment,
    STATE(498), 1,
      sym__base_type,
    STATE(573), 1,
      sym_type,
    ACTIONS(528), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(532), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(596), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(565), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [14905] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(526), 1,
      aux_sym_int_literal_token1,
    ACTIONS(586), 1,
      anon_sym_LBRACK,
    ACTIONS(588), 1,
      anon_sym_LPAREN,
    ACTIONS(590), 1,
      anon_sym_LBRACE,
    ACTIONS(592), 1,
      anon_sym_AMP,
    ACTIONS(594), 1,
      anon_sym_inv,
    ACTIONS(598), 1,
      sym_identifier,
    STATE(206), 1,
      sym_block_comment,
    STATE(498), 1,
      sym__base_type,
    STATE(574), 1,
      sym_type,
    ACTIONS(528), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(532), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(596), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(565), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [14964] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    STATE(207), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(618), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [15023] = 17,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(510), 1,
      anon_sym_LBRACK,
    ACTIONS(512), 1,
      anon_sym_LPAREN,
    ACTIONS(514), 1,
      anon_sym_LBRACE,
    ACTIONS(524), 1,
      sym_identifier,
    ACTIONS(532), 1,
      anon_sym_AMP,
    ACTIONS(534), 1,
      anon_sym_inv,
    STATE(208), 1,
      sym_block_comment,
    STATE(233), 1,
      sym__base_type,
    STATE(374), 1,
      sym_type,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(237), 2,
      sym_builtin_type,
      sym_int_literal,
    ACTIONS(522), 3,
      anon_sym_int,
      anon_sym_bool,
      anon_sym_clock,
    STATE(288), 4,
      sym_tuple_type,
      sym_array_type,
      sym_wire,
      sym_inverted,
  [15082] = 16,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(628), 1,
      anon_sym_LPAREN,
    ACTIONS(634), 1,
      sym_identifier,
    ACTIONS(637), 1,
      anon_sym_COLON_COLON,
    ACTIONS(640), 1,
      aux_sym_int_literal_token1,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(289), 1,
      sym__scoped_or_raw_ident,
    STATE(314), 1,
      sym_match_arm,
    STATE(577), 1,
      sym__path,
    STATE(580), 1,
      sym__pattern,
    ACTIONS(631), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(643), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(209), 2,
      sym_block_comment,
      aux_sym_match_block_repeat1,
    STATE(362), 5,
      sym_bool_literal,
      sym_tuple_pattern,
      sym_named_unpack,
      sym_positional_unpack,
      sym_int_literal,
  [15138] = 16,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(646), 1,
      anon_sym_RBRACE,
    ACTIONS(648), 1,
      anon_sym_let,
    ACTIONS(650), 1,
      anon_sym_reg,
    ACTIONS(652), 1,
      anon_sym_set,
    ACTIONS(654), 1,
      anon_sym_decl,
    ACTIONS(656), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_DOLLARif,
    ACTIONS(660), 1,
      anon_sym_assert,
    STATE(210), 1,
      sym_block_comment,
    STATE(212), 1,
      aux_sym_block_repeat1,
    STATE(320), 1,
      sym__statement,
    STATE(321), 2,
      sym_pipeline_stage_name,
      sym_comptime_if,
    STATE(608), 6,
      sym_let_binding,
      sym_reg_statement,
      sym_set_statement,
      sym_decl_statement,
      sym_pipeline_reg_marker,
      sym_assert_statement,
  [15193] = 16,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(536), 1,
      anon_sym_LPAREN,
    ACTIONS(662), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(211), 1,
      sym_block_comment,
    STATE(289), 1,
      sym__scoped_or_raw_ident,
    STATE(551), 1,
      sym__pattern,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(362), 5,
      sym_bool_literal,
      sym_tuple_pattern,
      sym_named_unpack,
      sym_positional_unpack,
      sym_int_literal,
  [15248] = 16,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(648), 1,
      anon_sym_let,
    ACTIONS(650), 1,
      anon_sym_reg,
    ACTIONS(652), 1,
      anon_sym_set,
    ACTIONS(654), 1,
      anon_sym_decl,
    ACTIONS(656), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_DOLLARif,
    ACTIONS(660), 1,
      anon_sym_assert,
    ACTIONS(664), 1,
      anon_sym_RBRACE,
    STATE(212), 1,
      sym_block_comment,
    STATE(219), 1,
      aux_sym_block_repeat1,
    STATE(320), 1,
      sym__statement,
    STATE(321), 2,
      sym_pipeline_stage_name,
      sym_comptime_if,
    STATE(608), 6,
      sym_let_binding,
      sym_reg_statement,
      sym_set_statement,
      sym_decl_statement,
      sym_pipeline_reg_marker,
      sym_assert_statement,
  [15303] = 16,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(536), 1,
      anon_sym_LPAREN,
    ACTIONS(666), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(213), 1,
      sym_block_comment,
    STATE(289), 1,
      sym__scoped_or_raw_ident,
    STATE(491), 1,
      sym__pattern,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(362), 5,
      sym_bool_literal,
      sym_tuple_pattern,
      sym_named_unpack,
      sym_positional_unpack,
      sym_int_literal,
  [15358] = 16,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(536), 1,
      anon_sym_LPAREN,
    ACTIONS(668), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(214), 1,
      sym_block_comment,
    STATE(289), 1,
      sym__scoped_or_raw_ident,
    STATE(551), 1,
      sym__pattern,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(362), 5,
      sym_bool_literal,
      sym_tuple_pattern,
      sym_named_unpack,
      sym_positional_unpack,
      sym_int_literal,
  [15413] = 16,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(536), 1,
      anon_sym_LPAREN,
    ACTIONS(670), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(215), 1,
      sym_block_comment,
    STATE(289), 1,
      sym__scoped_or_raw_ident,
    STATE(478), 1,
      sym__pattern,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(362), 5,
      sym_bool_literal,
      sym_tuple_pattern,
      sym_named_unpack,
      sym_positional_unpack,
      sym_int_literal,
  [15468] = 16,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(536), 1,
      anon_sym_LPAREN,
    ACTIONS(672), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(216), 1,
      sym_block_comment,
    STATE(289), 1,
      sym__scoped_or_raw_ident,
    STATE(551), 1,
      sym__pattern,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(362), 5,
      sym_bool_literal,
      sym_tuple_pattern,
      sym_named_unpack,
      sym_positional_unpack,
      sym_int_literal,
  [15523] = 16,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(536), 1,
      anon_sym_LPAREN,
    ACTIONS(674), 1,
      anon_sym_RPAREN,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(217), 1,
      sym_block_comment,
    STATE(289), 1,
      sym__scoped_or_raw_ident,
    STATE(551), 1,
      sym__pattern,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(362), 5,
      sym_bool_literal,
      sym_tuple_pattern,
      sym_named_unpack,
      sym_positional_unpack,
      sym_int_literal,
  [15578] = 16,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(648), 1,
      anon_sym_let,
    ACTIONS(650), 1,
      anon_sym_reg,
    ACTIONS(652), 1,
      anon_sym_set,
    ACTIONS(654), 1,
      anon_sym_decl,
    ACTIONS(656), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_DOLLARif,
    ACTIONS(660), 1,
      anon_sym_assert,
    ACTIONS(676), 1,
      anon_sym_RBRACE,
    STATE(218), 1,
      sym_block_comment,
    STATE(221), 1,
      aux_sym_block_repeat1,
    STATE(320), 1,
      sym__statement,
    STATE(321), 2,
      sym_pipeline_stage_name,
      sym_comptime_if,
    STATE(608), 6,
      sym_let_binding,
      sym_reg_statement,
      sym_set_statement,
      sym_decl_statement,
      sym_pipeline_reg_marker,
      sym_assert_statement,
  [15633] = 15,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(161), 1,
      anon_sym_RBRACE,
    ACTIONS(678), 1,
      anon_sym_let,
    ACTIONS(681), 1,
      anon_sym_reg,
    ACTIONS(684), 1,
      anon_sym_set,
    ACTIONS(687), 1,
      anon_sym_decl,
    ACTIONS(690), 1,
      anon_sym_SQUOTE,
    ACTIONS(693), 1,
      anon_sym_DOLLARif,
    ACTIONS(696), 1,
      anon_sym_assert,
    STATE(320), 1,
      sym__statement,
    STATE(219), 2,
      sym_block_comment,
      aux_sym_block_repeat1,
    STATE(321), 2,
      sym_pipeline_stage_name,
      sym_comptime_if,
    STATE(608), 6,
      sym_let_binding,
      sym_reg_statement,
      sym_set_statement,
      sym_decl_statement,
      sym_pipeline_reg_marker,
      sym_assert_statement,
  [15686] = 16,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(648), 1,
      anon_sym_let,
    ACTIONS(650), 1,
      anon_sym_reg,
    ACTIONS(652), 1,
      anon_sym_set,
    ACTIONS(654), 1,
      anon_sym_decl,
    ACTIONS(656), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_DOLLARif,
    ACTIONS(660), 1,
      anon_sym_assert,
    ACTIONS(699), 1,
      anon_sym_RBRACE,
    STATE(219), 1,
      aux_sym_block_repeat1,
    STATE(220), 1,
      sym_block_comment,
    STATE(320), 1,
      sym__statement,
    STATE(321), 2,
      sym_pipeline_stage_name,
      sym_comptime_if,
    STATE(608), 6,
      sym_let_binding,
      sym_reg_statement,
      sym_set_statement,
      sym_decl_statement,
      sym_pipeline_reg_marker,
      sym_assert_statement,
  [15741] = 16,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(648), 1,
      anon_sym_let,
    ACTIONS(650), 1,
      anon_sym_reg,
    ACTIONS(652), 1,
      anon_sym_set,
    ACTIONS(654), 1,
      anon_sym_decl,
    ACTIONS(656), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_DOLLARif,
    ACTIONS(660), 1,
      anon_sym_assert,
    ACTIONS(701), 1,
      anon_sym_RBRACE,
    STATE(219), 1,
      aux_sym_block_repeat1,
    STATE(221), 1,
      sym_block_comment,
    STATE(320), 1,
      sym__statement,
    STATE(321), 2,
      sym_pipeline_stage_name,
      sym_comptime_if,
    STATE(608), 6,
      sym_let_binding,
      sym_reg_statement,
      sym_set_statement,
      sym_decl_statement,
      sym_pipeline_reg_marker,
      sym_assert_statement,
  [15796] = 16,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(648), 1,
      anon_sym_let,
    ACTIONS(650), 1,
      anon_sym_reg,
    ACTIONS(652), 1,
      anon_sym_set,
    ACTIONS(654), 1,
      anon_sym_decl,
    ACTIONS(656), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_DOLLARif,
    ACTIONS(660), 1,
      anon_sym_assert,
    ACTIONS(703), 1,
      anon_sym_RBRACE,
    STATE(222), 1,
      sym_block_comment,
    STATE(223), 1,
      aux_sym_block_repeat1,
    STATE(320), 1,
      sym__statement,
    STATE(321), 2,
      sym_pipeline_stage_name,
      sym_comptime_if,
    STATE(608), 6,
      sym_let_binding,
      sym_reg_statement,
      sym_set_statement,
      sym_decl_statement,
      sym_pipeline_reg_marker,
      sym_assert_statement,
  [15851] = 16,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(648), 1,
      anon_sym_let,
    ACTIONS(650), 1,
      anon_sym_reg,
    ACTIONS(652), 1,
      anon_sym_set,
    ACTIONS(654), 1,
      anon_sym_decl,
    ACTIONS(656), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_DOLLARif,
    ACTIONS(660), 1,
      anon_sym_assert,
    ACTIONS(705), 1,
      anon_sym_RBRACE,
    STATE(219), 1,
      aux_sym_block_repeat1,
    STATE(223), 1,
      sym_block_comment,
    STATE(320), 1,
      sym__statement,
    STATE(321), 2,
      sym_pipeline_stage_name,
      sym_comptime_if,
    STATE(608), 6,
      sym_let_binding,
      sym_reg_statement,
      sym_set_statement,
      sym_decl_statement,
      sym_pipeline_reg_marker,
      sym_assert_statement,
  [15906] = 16,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(648), 1,
      anon_sym_let,
    ACTIONS(650), 1,
      anon_sym_reg,
    ACTIONS(652), 1,
      anon_sym_set,
    ACTIONS(654), 1,
      anon_sym_decl,
    ACTIONS(656), 1,
      anon_sym_SQUOTE,
    ACTIONS(658), 1,
      anon_sym_DOLLARif,
    ACTIONS(660), 1,
      anon_sym_assert,
    ACTIONS(707), 1,
      anon_sym_RBRACE,
    STATE(220), 1,
      aux_sym_block_repeat1,
    STATE(224), 1,
      sym_block_comment,
    STATE(320), 1,
      sym__statement,
    STATE(321), 2,
      sym_pipeline_stage_name,
      sym_comptime_if,
    STATE(608), 6,
      sym_let_binding,
      sym_reg_statement,
      sym_set_statement,
      sym_decl_statement,
      sym_pipeline_reg_marker,
      sym_assert_statement,
  [15961] = 15,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(536), 1,
      anon_sym_LPAREN,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(225), 1,
      sym_block_comment,
    STATE(289), 1,
      sym__scoped_or_raw_ident,
    STATE(526), 1,
      sym__pattern,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(362), 5,
      sym_bool_literal,
      sym_tuple_pattern,
      sym_named_unpack,
      sym_positional_unpack,
      sym_int_literal,
  [16013] = 15,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(69), 1,
      sym_identifier,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(536), 1,
      anon_sym_LPAREN,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(226), 1,
      sym_block_comment,
    STATE(289), 1,
      sym__scoped_or_raw_ident,
    STATE(551), 1,
      sym__pattern,
    STATE(577), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(362), 5,
      sym_bool_literal,
      sym_tuple_pattern,
      sym_named_unpack,
      sym_positional_unpack,
      sym_int_literal,
  [16065] = 15,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(536), 1,
      anon_sym_LPAREN,
    ACTIONS(709), 1,
      sym_identifier,
    ACTIONS(711), 1,
      anon_sym_COLON_COLON,
    STATE(227), 1,
      sym_block_comment,
    STATE(289), 1,
      sym__scoped_or_raw_ident,
    STATE(345), 1,
      sym_scoped_identifier,
    STATE(529), 1,
      sym__pattern,
    STATE(629), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(362), 5,
      sym_bool_literal,
      sym_tuple_pattern,
      sym_named_unpack,
      sym_positional_unpack,
      sym_int_literal,
  [16117] = 15,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    ACTIONS(536), 1,
      anon_sym_LPAREN,
    ACTIONS(709), 1,
      sym_identifier,
    ACTIONS(711), 1,
      anon_sym_COLON_COLON,
    STATE(228), 1,
      sym_block_comment,
    STATE(289), 1,
      sym__scoped_or_raw_ident,
    STATE(343), 1,
      sym__pattern,
    STATE(345), 1,
      sym_scoped_identifier,
    STATE(629), 1,
      sym__path,
    ACTIONS(65), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    STATE(362), 5,
      sym_bool_literal,
      sym_tuple_pattern,
      sym_named_unpack,
      sym_positional_unpack,
      sym_int_literal,
  [16169] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(229), 1,
      sym_block_comment,
    ACTIONS(713), 14,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_COMMA,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16198] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(230), 1,
      sym_block_comment,
    ACTIONS(715), 14,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_COMMA,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16227] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(231), 1,
      sym_block_comment,
    ACTIONS(717), 14,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_COMMA,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16256] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(232), 1,
      sym_block_comment,
    ACTIONS(719), 14,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_COMMA,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16285] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(723), 1,
      anon_sym_LT,
    STATE(233), 1,
      sym_block_comment,
    STATE(282), 1,
      sym__generic_list,
    ACTIONS(721), 12,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_GT,
      anon_sym___builtin__,
  [16318] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(234), 1,
      sym_block_comment,
    ACTIONS(725), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16346] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(235), 1,
      sym_block_comment,
    ACTIONS(727), 13,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym___builtin__,
  [16374] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(729), 1,
      anon_sym_POUND,
    STATE(290), 1,
      sym_attribute,
    STATE(236), 2,
      sym_block_comment,
      aux_sym__item_repeat1,
    ACTIONS(732), 10,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16406] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(237), 1,
      sym_block_comment,
    ACTIONS(734), 13,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym___builtin__,
  [16434] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(238), 1,
      sym_block_comment,
    ACTIONS(736), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16462] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(239), 1,
      sym_block_comment,
    ACTIONS(738), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16490] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(240), 1,
      sym_block_comment,
    ACTIONS(740), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16518] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(241), 1,
      sym_block_comment,
    ACTIONS(742), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16546] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(242), 1,
      sym_block_comment,
    ACTIONS(744), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16574] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(243), 1,
      sym_block_comment,
    ACTIONS(746), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16602] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(244), 1,
      sym_block_comment,
    ACTIONS(748), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16630] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(245), 1,
      sym_block_comment,
    ACTIONS(750), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16658] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(246), 1,
      sym_block_comment,
    ACTIONS(752), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16686] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(247), 1,
      sym_block_comment,
    ACTIONS(754), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16714] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(248), 1,
      sym_block_comment,
    ACTIONS(756), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16742] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(249), 1,
      sym_block_comment,
    ACTIONS(758), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16770] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(250), 1,
      sym_block_comment,
    ACTIONS(760), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16798] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(251), 1,
      sym_block_comment,
    ACTIONS(762), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16826] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(252), 1,
      sym_block_comment,
    ACTIONS(764), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16854] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(253), 1,
      sym_block_comment,
    ACTIONS(766), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16882] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(254), 1,
      sym_block_comment,
    ACTIONS(768), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16910] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(255), 1,
      sym_block_comment,
    ACTIONS(770), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16938] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(256), 1,
      sym_block_comment,
    ACTIONS(772), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16966] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(257), 1,
      sym_block_comment,
    ACTIONS(774), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [16994] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(258), 1,
      sym_block_comment,
    ACTIONS(776), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17022] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(259), 1,
      sym_block_comment,
    ACTIONS(778), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17050] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(260), 1,
      sym_block_comment,
    ACTIONS(780), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17078] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(261), 1,
      sym_block_comment,
    ACTIONS(782), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17106] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(262), 1,
      sym_block_comment,
    ACTIONS(784), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17134] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(263), 1,
      sym_block_comment,
    ACTIONS(786), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17162] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(264), 1,
      sym_block_comment,
    ACTIONS(788), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17190] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(265), 1,
      sym_block_comment,
    ACTIONS(790), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17218] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(266), 1,
      sym_block_comment,
    ACTIONS(792), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17246] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(267), 1,
      sym_block_comment,
    ACTIONS(794), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17274] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(268), 1,
      sym_block_comment,
    ACTIONS(796), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17302] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(269), 1,
      sym_block_comment,
    ACTIONS(798), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17330] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(270), 1,
      sym_block_comment,
    ACTIONS(800), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17358] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(271), 1,
      sym_block_comment,
    ACTIONS(802), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17386] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(272), 1,
      sym_block_comment,
    ACTIONS(804), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17414] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(273), 1,
      sym_block_comment,
    ACTIONS(806), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17442] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(274), 1,
      sym_block_comment,
    ACTIONS(808), 13,
      ts_builtin_sym_end,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_RBRACE,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17470] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(275), 1,
      sym_block_comment,
    ACTIONS(810), 12,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_GT,
      anon_sym___builtin__,
  [17497] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(276), 1,
      sym_block_comment,
    ACTIONS(812), 12,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_GT,
      anon_sym___builtin__,
  [17524] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(277), 1,
      sym_block_comment,
    ACTIONS(814), 12,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_GT,
      anon_sym___builtin__,
  [17551] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(278), 1,
      sym_block_comment,
    ACTIONS(816), 12,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_GT,
      anon_sym___builtin__,
  [17578] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(279), 1,
      sym_block_comment,
    ACTIONS(818), 12,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_GT,
      anon_sym___builtin__,
  [17605] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(280), 1,
      sym_block_comment,
    ACTIONS(820), 12,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_GT,
      anon_sym___builtin__,
  [17632] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(281), 1,
      sym_block_comment,
    ACTIONS(822), 12,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_GT,
      anon_sym___builtin__,
  [17659] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(282), 1,
      sym_block_comment,
    ACTIONS(824), 12,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_GT,
      anon_sym___builtin__,
  [17686] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(283), 1,
      sym_block_comment,
    ACTIONS(826), 12,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_GT,
      anon_sym___builtin__,
  [17713] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(284), 1,
      sym_block_comment,
    ACTIONS(828), 12,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_GT,
      anon_sym___builtin__,
  [17740] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(285), 1,
      sym_block_comment,
    ACTIONS(830), 12,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_GT,
      anon_sym___builtin__,
  [17767] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(286), 1,
      sym_block_comment,
    ACTIONS(832), 12,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_GT,
      anon_sym___builtin__,
  [17794] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(287), 1,
      sym_block_comment,
    ACTIONS(834), 12,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_GT,
      anon_sym___builtin__,
  [17821] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(288), 1,
      sym_block_comment,
    ACTIONS(721), 12,
      anon_sym_RBRACK,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_where,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_GT,
      anon_sym___builtin__,
  [17848] = 10,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(836), 1,
      anon_sym_LPAREN,
    ACTIONS(840), 1,
      anon_sym_EQ,
    ACTIONS(842), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(289), 1,
      sym_block_comment,
    STATE(341), 1,
      sym__named_pattern_list,
    STATE(342), 1,
      sym__positional_pattern_list,
    ACTIONS(838), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_EQ_GT,
  [17884] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(290), 1,
      sym_block_comment,
    ACTIONS(844), 11,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17910] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(291), 1,
      sym_block_comment,
    ACTIONS(846), 11,
      anon_sym_POUND,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_impl,
      anon_sym_trait,
      anon_sym_use,
      anon_sym_mod,
      anon_sym_DOLLARconfig,
  [17936] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(848), 1,
      anon_sym_DOLLARelse,
    STATE(292), 1,
      sym_block_comment,
    STATE(324), 1,
      sym_comptime_else,
    ACTIONS(358), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_assert,
  [17965] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(848), 1,
      anon_sym_DOLLARelse,
    STATE(293), 1,
      sym_block_comment,
    STATE(325), 1,
      sym_comptime_else,
    ACTIONS(400), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_assert,
  [17994] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(852), 1,
      anon_sym_RBRACE,
    STATE(294), 1,
      sym_block_comment,
    ACTIONS(850), 4,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    ACTIONS(854), 4,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      aux_sym_int_literal_token1,
  [18022] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(295), 1,
      sym_block_comment,
    ACTIONS(464), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_assert,
  [18045] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(856), 1,
      anon_sym_RBRACE,
    STATE(296), 1,
      sym_block_comment,
    STATE(308), 1,
      aux_sym_impl_repeat1,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [18080] = 9,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    STATE(297), 1,
      sym_block_comment,
    STATE(414), 1,
      sym__comptime_operator,
    STATE(503), 2,
      sym_op_lt,
      sym_op_gt,
    ACTIONS(858), 3,
      sym_op_equals,
      sym_op_le,
      sym_op_ge,
  [18111] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(860), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      sym_block_comment,
    STATE(308), 1,
      aux_sym_impl_repeat1,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [18146] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(862), 1,
      anon_sym_RBRACE,
    STATE(299), 1,
      sym_block_comment,
    STATE(308), 1,
      aux_sym_impl_repeat1,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [18181] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(864), 1,
      anon_sym_RBRACE,
    STATE(300), 1,
      sym_block_comment,
    STATE(311), 1,
      aux_sym_impl_repeat1,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [18216] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(866), 1,
      anon_sym_RBRACE,
    STATE(301), 1,
      sym_block_comment,
    STATE(328), 1,
      aux_sym_impl_repeat1,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [18251] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(868), 1,
      anon_sym_RBRACE,
    STATE(302), 1,
      sym_block_comment,
    STATE(308), 1,
      aux_sym_impl_repeat1,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [18286] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(870), 1,
      anon_sym_RBRACE,
    STATE(303), 1,
      sym_block_comment,
    STATE(308), 1,
      aux_sym_impl_repeat1,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [18321] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(872), 1,
      anon_sym_RBRACE,
    STATE(304), 1,
      sym_block_comment,
    STATE(308), 1,
      aux_sym_impl_repeat1,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [18356] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(874), 1,
      anon_sym_RBRACE,
    STATE(305), 1,
      sym_block_comment,
    STATE(331), 1,
      aux_sym_impl_repeat1,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [18391] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(870), 1,
      anon_sym_RBRACE,
    STATE(302), 1,
      aux_sym_impl_repeat1,
    STATE(306), 1,
      sym_block_comment,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [18426] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(876), 1,
      anon_sym_RBRACE,
    STATE(304), 1,
      aux_sym_impl_repeat1,
    STATE(307), 1,
      sym_block_comment,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [18461] = 10,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(881), 1,
      anon_sym_pipeline,
    ACTIONS(884), 1,
      anon_sym_RBRACE,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(878), 2,
      anon_sym_fn,
      anon_sym_entity,
    STATE(308), 2,
      sym_block_comment,
      aux_sym_impl_repeat1,
  [18494] = 10,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(889), 1,
      anon_sym_pipeline,
    ACTIONS(892), 1,
      anon_sym_RBRACE,
    STATE(365), 1,
      sym__unit_head,
    STATE(432), 1,
      sym_unit_declaration,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(886), 2,
      anon_sym_fn,
      anon_sym_entity,
    STATE(309), 2,
      sym_block_comment,
      aux_sym_trait_repeat1,
  [18527] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(894), 1,
      anon_sym_RBRACE,
    STATE(309), 1,
      aux_sym_trait_repeat1,
    STATE(310), 1,
      sym_block_comment,
    STATE(365), 1,
      sym__unit_head,
    STATE(432), 1,
      sym_unit_declaration,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [18562] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(896), 1,
      anon_sym_RBRACE,
    STATE(308), 1,
      aux_sym_impl_repeat1,
    STATE(311), 1,
      sym_block_comment,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [18597] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(898), 1,
      anon_sym_RBRACE,
    STATE(309), 1,
      aux_sym_trait_repeat1,
    STATE(312), 1,
      sym_block_comment,
    STATE(365), 1,
      sym__unit_head,
    STATE(432), 1,
      sym_unit_declaration,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [18632] = 12,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(900), 1,
      anon_sym_POUND,
    ACTIONS(902), 1,
      anon_sym_RPAREN,
    ACTIONS(904), 1,
      sym_self,
    ACTIONS(906), 1,
      sym_identifier,
    STATE(313), 1,
      sym_block_comment,
    STATE(385), 1,
      aux_sym__item_repeat1,
    STATE(482), 1,
      sym_typed_parameter,
    STATE(530), 1,
      sym_attribute,
    STATE(626), 1,
      sym_parameter,
  [18669] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(314), 1,
      sym_block_comment,
    ACTIONS(908), 4,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    ACTIONS(910), 4,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      aux_sym_int_literal_token1,
  [18694] = 9,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(133), 1,
      anon_sym_LT,
    ACTIONS(135), 1,
      anon_sym_GT,
    STATE(315), 1,
      sym_block_comment,
    STATE(433), 1,
      sym__comptime_operator,
    STATE(503), 2,
      sym_op_lt,
      sym_op_gt,
    ACTIONS(858), 3,
      sym_op_equals,
      sym_op_le,
      sym_op_ge,
  [18725] = 12,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(155), 1,
      anon_sym_COLON_COLON_LT,
    ACTIONS(157), 1,
      anon_sym_COLON_COLON_DOLLAR_LT,
    ACTIONS(912), 1,
      sym_identifier,
    ACTIONS(914), 1,
      anon_sym_COLON_COLON,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(316), 1,
      sym_block_comment,
    STATE(391), 1,
      sym_turbofish,
    STATE(393), 1,
      sym__scoped_or_raw_ident,
    STATE(577), 1,
      sym__path,
  [18762] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(151), 1,
      anon_sym_LPAREN,
    ACTIONS(155), 1,
      anon_sym_COLON_COLON_LT,
    ACTIONS(157), 1,
      anon_sym_COLON_COLON_DOLLAR_LT,
    ACTIONS(159), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(138), 1,
      sym_argument_list,
    STATE(317), 1,
      sym_block_comment,
    STATE(387), 1,
      sym_turbofish,
    STATE(121), 2,
      sym__named_argument_list,
      sym__positional_argument_list,
  [18797] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(151), 1,
      anon_sym_LPAREN,
    ACTIONS(155), 1,
      anon_sym_COLON_COLON_LT,
    ACTIONS(157), 1,
      anon_sym_COLON_COLON_DOLLAR_LT,
    ACTIONS(159), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(116), 1,
      sym_argument_list,
    STATE(318), 1,
      sym_block_comment,
    STATE(395), 1,
      sym_turbofish,
    STATE(121), 2,
      sym__named_argument_list,
      sym__positional_argument_list,
  [18832] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(319), 1,
      sym_block_comment,
    ACTIONS(850), 4,
      anon_sym_LPAREN,
      anon_sym_COLON_COLON,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
    ACTIONS(854), 4,
      anon_sym_true,
      anon_sym_false,
      sym_identifier,
      aux_sym_int_literal_token1,
  [18857] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(320), 1,
      sym_block_comment,
    ACTIONS(440), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_assert,
  [18880] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(321), 1,
      sym_block_comment,
    ACTIONS(452), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_assert,
  [18903] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(322), 1,
      sym_block_comment,
    ACTIONS(448), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_assert,
  [18926] = 12,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(900), 1,
      anon_sym_POUND,
    ACTIONS(916), 1,
      anon_sym_RPAREN,
    ACTIONS(918), 1,
      anon_sym_COMMA,
    ACTIONS(920), 1,
      sym_identifier,
    STATE(323), 1,
      sym_block_comment,
    STATE(385), 1,
      aux_sym__item_repeat1,
    STATE(446), 1,
      sym_typed_parameter,
    STATE(530), 1,
      sym_attribute,
    STATE(626), 1,
      sym_parameter,
  [18963] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(324), 1,
      sym_block_comment,
    ACTIONS(400), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_assert,
  [18986] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(325), 1,
      sym_block_comment,
    ACTIONS(456), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_assert,
  [19009] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(326), 1,
      sym_block_comment,
    ACTIONS(468), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_assert,
  [19032] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(327), 1,
      sym_block_comment,
    ACTIONS(460), 8,
      anon_sym_RBRACE,
      anon_sym_let,
      anon_sym_reg,
      anon_sym_set,
      anon_sym_decl,
      anon_sym_SQUOTE,
      anon_sym_DOLLARif,
      anon_sym_assert,
  [19055] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(922), 1,
      anon_sym_RBRACE,
    STATE(308), 1,
      aux_sym_impl_repeat1,
    STATE(328), 1,
      sym_block_comment,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [19090] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(924), 1,
      anon_sym_RBRACE,
    STATE(298), 1,
      aux_sym_impl_repeat1,
    STATE(329), 1,
      sym_block_comment,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [19125] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(926), 1,
      anon_sym_RBRACE,
    STATE(299), 1,
      aux_sym_impl_repeat1,
    STATE(330), 1,
      sym_block_comment,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [19160] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(928), 1,
      anon_sym_RBRACE,
    STATE(308), 1,
      aux_sym_impl_repeat1,
    STATE(331), 1,
      sym_block_comment,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [19195] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(930), 1,
      anon_sym_RBRACE,
    STATE(296), 1,
      aux_sym_impl_repeat1,
    STATE(332), 1,
      sym_block_comment,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [19230] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(932), 1,
      anon_sym_RBRACE,
    STATE(312), 1,
      aux_sym_trait_repeat1,
    STATE(333), 1,
      sym_block_comment,
    STATE(365), 1,
      sym__unit_head,
    STATE(432), 1,
      sym_unit_declaration,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [19265] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(856), 1,
      anon_sym_RBRACE,
    STATE(303), 1,
      aux_sym_impl_repeat1,
    STATE(334), 1,
      sym_block_comment,
    STATE(377), 1,
      sym__unit_head,
    STATE(410), 1,
      sym_unit_definition,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [19300] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(15), 1,
      anon_sym_pipeline,
    ACTIONS(898), 1,
      anon_sym_RBRACE,
    STATE(310), 1,
      aux_sym_trait_repeat1,
    STATE(335), 1,
      sym_block_comment,
    STATE(365), 1,
      sym__unit_head,
    STATE(432), 1,
      sym_unit_declaration,
    STATE(562), 1,
      sym__pipeline_start,
    ACTIONS(13), 2,
      anon_sym_fn,
      anon_sym_entity,
  [19335] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(936), 1,
      anon_sym_EQ,
    STATE(336), 1,
      sym_block_comment,
    ACTIONS(934), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_EQ_GT,
  [19359] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(940), 1,
      anon_sym_EQ,
    STATE(337), 1,
      sym_block_comment,
    ACTIONS(938), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_EQ_GT,
  [19383] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(900), 1,
      anon_sym_POUND,
    ACTIONS(920), 1,
      sym_identifier,
    ACTIONS(942), 1,
      anon_sym_RBRACE,
    STATE(338), 1,
      sym_block_comment,
    STATE(385), 1,
      aux_sym__item_repeat1,
    STATE(450), 1,
      sym_typed_parameter,
    STATE(530), 1,
      sym_attribute,
    STATE(626), 1,
      sym_parameter,
  [19417] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(946), 1,
      anon_sym_EQ,
    STATE(339), 1,
      sym_block_comment,
    ACTIONS(944), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_EQ_GT,
  [19441] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(900), 1,
      anon_sym_POUND,
    ACTIONS(920), 1,
      sym_identifier,
    ACTIONS(948), 1,
      anon_sym_RPAREN,
    STATE(340), 1,
      sym_block_comment,
    STATE(385), 1,
      aux_sym__item_repeat1,
    STATE(450), 1,
      sym_typed_parameter,
    STATE(530), 1,
      sym_attribute,
    STATE(626), 1,
      sym_parameter,
  [19475] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(952), 1,
      anon_sym_EQ,
    STATE(341), 1,
      sym_block_comment,
    ACTIONS(950), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_EQ_GT,
  [19499] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(956), 1,
      anon_sym_EQ,
    STATE(342), 1,
      sym_block_comment,
    ACTIONS(954), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_EQ_GT,
  [19523] = 10,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(958), 1,
      anon_sym_COLON,
    ACTIONS(960), 1,
      anon_sym_EQ,
    ACTIONS(962), 1,
      anon_sym_reset,
    ACTIONS(964), 1,
      anon_sym_initial,
    STATE(343), 1,
      sym_block_comment,
    STATE(364), 1,
      aux_sym_reg_statement_repeat1,
    STATE(469), 2,
      sym_reg_reset,
      sym_reg_initial,
  [19555] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(900), 1,
      anon_sym_POUND,
    ACTIONS(920), 1,
      sym_identifier,
    ACTIONS(966), 1,
      anon_sym_RPAREN,
    STATE(344), 1,
      sym_block_comment,
    STATE(385), 1,
      aux_sym__item_repeat1,
    STATE(450), 1,
      sym_typed_parameter,
    STATE(530), 1,
      sym_attribute,
    STATE(626), 1,
      sym_parameter,
  [19589] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(200), 1,
      anon_sym_COLON,
    ACTIONS(968), 1,
      anon_sym_COLON_COLON,
    STATE(345), 1,
      sym_block_comment,
    ACTIONS(198), 5,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_DOLLAR_LPAREN,
  [19615] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(192), 1,
      anon_sym_COLON,
    STATE(346), 1,
      sym_block_comment,
    ACTIONS(190), 6,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_COLON_COLON,
  [19639] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(972), 1,
      anon_sym_EQ,
    STATE(347), 1,
      sym_block_comment,
    ACTIONS(970), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_EQ_GT,
  [19663] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(976), 1,
      anon_sym_EQ,
    STATE(348), 1,
      sym_block_comment,
    ACTIONS(974), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_EQ_GT,
  [19687] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(980), 1,
      anon_sym_EQ,
    STATE(349), 1,
      sym_block_comment,
    ACTIONS(978), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_EQ_GT,
  [19711] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(912), 1,
      sym_identifier,
    ACTIONS(982), 1,
      anon_sym_LT,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(350), 1,
      sym_block_comment,
    STATE(378), 1,
      sym_generic_parameters,
    STATE(420), 1,
      sym__scoped_or_raw_ident,
    STATE(577), 1,
      sym__path,
  [19745] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(900), 1,
      anon_sym_POUND,
    ACTIONS(920), 1,
      sym_identifier,
    ACTIONS(984), 1,
      anon_sym_RBRACE,
    STATE(351), 1,
      sym_block_comment,
    STATE(385), 1,
      aux_sym__item_repeat1,
    STATE(450), 1,
      sym_typed_parameter,
    STATE(530), 1,
      sym_attribute,
    STATE(626), 1,
      sym_parameter,
  [19779] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(988), 1,
      anon_sym_EQ,
    STATE(352), 1,
      sym_block_comment,
    ACTIONS(986), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_EQ_GT,
  [19803] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(992), 1,
      anon_sym_EQ,
    STATE(353), 1,
      sym_block_comment,
    ACTIONS(990), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_EQ_GT,
  [19827] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(900), 1,
      anon_sym_POUND,
    ACTIONS(920), 1,
      sym_identifier,
    ACTIONS(994), 1,
      anon_sym_RPAREN,
    STATE(354), 1,
      sym_block_comment,
    STATE(385), 1,
      aux_sym__item_repeat1,
    STATE(450), 1,
      sym_typed_parameter,
    STATE(530), 1,
      sym_attribute,
    STATE(626), 1,
      sym_parameter,
  [19861] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(998), 1,
      anon_sym_EQ,
    STATE(355), 1,
      sym_block_comment,
    ACTIONS(996), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_EQ_GT,
  [19885] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(900), 1,
      anon_sym_POUND,
    ACTIONS(920), 1,
      sym_identifier,
    ACTIONS(1000), 1,
      anon_sym_RBRACE,
    STATE(356), 1,
      sym_block_comment,
    STATE(385), 1,
      aux_sym__item_repeat1,
    STATE(504), 1,
      sym_typed_parameter,
    STATE(530), 1,
      sym_attribute,
    STATE(626), 1,
      sym_parameter,
  [19919] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1004), 1,
      anon_sym_EQ,
    STATE(357), 1,
      sym_block_comment,
    ACTIONS(1002), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_EQ_GT,
  [19943] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1008), 1,
      anon_sym_EQ,
    STATE(358), 1,
      sym_block_comment,
    ACTIONS(1006), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_EQ_GT,
  [19967] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(900), 1,
      anon_sym_POUND,
    ACTIONS(920), 1,
      sym_identifier,
    ACTIONS(1010), 1,
      anon_sym_RPAREN,
    STATE(359), 1,
      sym_block_comment,
    STATE(385), 1,
      aux_sym__item_repeat1,
    STATE(447), 1,
      sym_typed_parameter,
    STATE(530), 1,
      sym_attribute,
    STATE(626), 1,
      sym_parameter,
  [20001] = 11,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(900), 1,
      anon_sym_POUND,
    ACTIONS(920), 1,
      sym_identifier,
    ACTIONS(1010), 1,
      anon_sym_RPAREN,
    STATE(360), 1,
      sym_block_comment,
    STATE(385), 1,
      aux_sym__item_repeat1,
    STATE(450), 1,
      sym_typed_parameter,
    STATE(530), 1,
      sym_attribute,
    STATE(626), 1,
      sym_parameter,
  [20035] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1014), 1,
      anon_sym_EQ,
    STATE(361), 1,
      sym_block_comment,
    ACTIONS(1012), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_EQ_GT,
  [20059] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(840), 1,
      anon_sym_EQ,
    STATE(362), 1,
      sym_block_comment,
    ACTIONS(838), 6,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_EQ_GT,
  [20083] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(196), 1,
      anon_sym_COLON,
    STATE(363), 1,
      sym_block_comment,
    ACTIONS(194), 6,
      anon_sym_LPAREN,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
      anon_sym_DOLLAR_LPAREN,
      anon_sym_COLON_COLON,
  [20107] = 9,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(962), 1,
      anon_sym_reset,
    ACTIONS(964), 1,
      anon_sym_initial,
    ACTIONS(1016), 1,
      anon_sym_EQ,
    STATE(364), 1,
      sym_block_comment,
    STATE(371), 1,
      aux_sym_reg_statement_repeat1,
    STATE(469), 2,
      sym_reg_reset,
      sym_reg_initial,
  [20136] = 9,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(1018), 1,
      anon_sym_SEMI,
    ACTIONS(1020), 1,
      anon_sym___builtin__,
    STATE(365), 1,
      sym_block_comment,
    STATE(397), 1,
      sym__body_or_builtin,
    STATE(238), 2,
      sym_block,
      sym_builtin_marker,
  [20165] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1024), 1,
      anon_sym_DASH_GT,
    ACTIONS(1026), 1,
      anon_sym_where,
    STATE(366), 1,
      sym_block_comment,
    STATE(458), 1,
      sym_where_clause,
    ACTIONS(1022), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym___builtin__,
  [20192] = 9,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(962), 1,
      anon_sym_reset,
    ACTIONS(964), 1,
      anon_sym_initial,
    ACTIONS(1028), 1,
      anon_sym_EQ,
    STATE(367), 1,
      sym_block_comment,
    STATE(371), 1,
      aux_sym_reg_statement_repeat1,
    STATE(469), 2,
      sym_reg_reset,
      sym_reg_initial,
  [20221] = 10,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(900), 1,
      anon_sym_POUND,
    ACTIONS(920), 1,
      sym_identifier,
    STATE(368), 1,
      sym_block_comment,
    STATE(385), 1,
      aux_sym__item_repeat1,
    STATE(450), 1,
      sym_typed_parameter,
    STATE(530), 1,
      sym_attribute,
    STATE(626), 1,
      sym_parameter,
  [20252] = 9,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(962), 1,
      anon_sym_reset,
    ACTIONS(964), 1,
      anon_sym_initial,
    ACTIONS(1030), 1,
      anon_sym_EQ,
    STATE(367), 1,
      aux_sym_reg_statement_repeat1,
    STATE(369), 1,
      sym_block_comment,
    STATE(469), 2,
      sym_reg_reset,
      sym_reg_initial,
  [20281] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1026), 1,
      anon_sym_where,
    ACTIONS(1034), 1,
      anon_sym_DASH_GT,
    STATE(370), 1,
      sym_block_comment,
    STATE(487), 1,
      sym_where_clause,
    ACTIONS(1032), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym___builtin__,
  [20308] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1036), 1,
      anon_sym_EQ,
    ACTIONS(1038), 1,
      anon_sym_reset,
    ACTIONS(1041), 1,
      anon_sym_initial,
    STATE(371), 2,
      sym_block_comment,
      aux_sym_reg_statement_repeat1,
    STATE(469), 2,
      sym_reg_reset,
      sym_reg_initial,
  [20335] = 10,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(912), 1,
      sym_identifier,
    ACTIONS(1044), 1,
      anon_sym_LPAREN,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(317), 1,
      sym__scoped_or_raw_ident,
    STATE(372), 1,
      sym_block_comment,
    STATE(577), 1,
      sym__path,
  [20366] = 9,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(912), 1,
      sym_identifier,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(373), 1,
      sym_block_comment,
    STATE(518), 1,
      sym__scoped_or_raw_ident,
    STATE(577), 1,
      sym__path,
  [20394] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1026), 1,
      anon_sym_where,
    STATE(374), 1,
      sym_block_comment,
    STATE(455), 1,
      sym_where_clause,
    ACTIONS(1046), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym___builtin__,
  [20418] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(151), 1,
      anon_sym_LPAREN,
    ACTIONS(159), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(117), 1,
      sym_argument_list,
    STATE(375), 1,
      sym_block_comment,
    STATE(121), 2,
      sym__named_argument_list,
      sym__positional_argument_list,
  [20444] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1026), 1,
      anon_sym_where,
    STATE(376), 1,
      sym_block_comment,
    STATE(501), 1,
      sym_where_clause,
    ACTIONS(1048), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym___builtin__,
  [20468] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(1020), 1,
      anon_sym___builtin__,
    STATE(268), 1,
      sym__body_or_builtin,
    STATE(377), 1,
      sym_block_comment,
    STATE(238), 2,
      sym_block,
      sym_builtin_marker,
  [20494] = 9,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(912), 1,
      sym_identifier,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(378), 1,
      sym_block_comment,
    STATE(427), 1,
      sym__scoped_or_raw_ident,
    STATE(577), 1,
      sym__path,
  [20522] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(379), 1,
      sym_block_comment,
    ACTIONS(1050), 5,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LBRACE,
      anon_sym___builtin__,
  [20542] = 9,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(912), 1,
      sym_identifier,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(380), 1,
      sym_block_comment,
    STATE(468), 1,
      sym__scoped_or_raw_ident,
    STATE(577), 1,
      sym__path,
  [20570] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(151), 1,
      anon_sym_LPAREN,
    ACTIONS(159), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(135), 1,
      sym_argument_list,
    STATE(381), 1,
      sym_block_comment,
    STATE(121), 2,
      sym__named_argument_list,
      sym__positional_argument_list,
  [20596] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(151), 1,
      anon_sym_LPAREN,
    ACTIONS(159), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(141), 1,
      sym_argument_list,
    STATE(382), 1,
      sym_block_comment,
    STATE(121), 2,
      sym__named_argument_list,
      sym__positional_argument_list,
  [20622] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(383), 1,
      sym_block_comment,
    ACTIONS(1052), 5,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LBRACE,
      anon_sym___builtin__,
  [20642] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(206), 1,
      anon_sym_COMMA,
    STATE(384), 1,
      sym_block_comment,
    STATE(388), 1,
      aux_sym_where_clause_repeat1,
    ACTIONS(1054), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym___builtin__,
  [20666] = 9,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(900), 1,
      anon_sym_POUND,
    ACTIONS(920), 1,
      sym_identifier,
    STATE(385), 1,
      sym_block_comment,
    STATE(435), 1,
      aux_sym__item_repeat1,
    STATE(530), 1,
      sym_attribute,
    STATE(567), 1,
      sym_parameter,
  [20694] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(386), 1,
      sym_block_comment,
    ACTIONS(1056), 5,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LBRACE,
      anon_sym___builtin__,
  [20714] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(151), 1,
      anon_sym_LPAREN,
    ACTIONS(159), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(107), 1,
      sym_argument_list,
    STATE(387), 1,
      sym_block_comment,
    STATE(121), 2,
      sym__named_argument_list,
      sym__positional_argument_list,
  [20740] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1060), 1,
      anon_sym_COMMA,
    STATE(388), 2,
      sym_block_comment,
      aux_sym_where_clause_repeat1,
    ACTIONS(1058), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym___builtin__,
  [20762] = 9,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(912), 1,
      sym_identifier,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(389), 1,
      sym_block_comment,
    STATE(445), 1,
      sym__scoped_or_raw_ident,
    STATE(577), 1,
      sym__path,
  [20790] = 9,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(912), 1,
      sym_identifier,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(390), 1,
      sym_block_comment,
    STATE(474), 1,
      sym__scoped_or_raw_ident,
    STATE(577), 1,
      sym__path,
  [20818] = 9,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(912), 1,
      sym_identifier,
    STATE(71), 1,
      sym_scoped_identifier,
    STATE(381), 1,
      sym__scoped_or_raw_ident,
    STATE(391), 1,
      sym_block_comment,
    STATE(577), 1,
      sym__path,
  [20846] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(392), 1,
      sym_block_comment,
    ACTIONS(1063), 5,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LBRACE,
      anon_sym___builtin__,
  [20866] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(151), 1,
      anon_sym_LPAREN,
    ACTIONS(159), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(125), 1,
      sym_argument_list,
    STATE(393), 1,
      sym_block_comment,
    STATE(121), 2,
      sym__named_argument_list,
      sym__positional_argument_list,
  [20892] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(394), 1,
      sym_block_comment,
    ACTIONS(1065), 5,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LBRACE,
      anon_sym___builtin__,
  [20912] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(151), 1,
      anon_sym_LPAREN,
    ACTIONS(159), 1,
      anon_sym_DOLLAR_LPAREN,
    STATE(127), 1,
      sym_argument_list,
    STATE(395), 1,
      sym_block_comment,
    STATE(121), 2,
      sym__named_argument_list,
      sym__positional_argument_list,
  [20938] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(396), 1,
      sym_block_comment,
    ACTIONS(1067), 5,
      anon_sym_SEMI,
      anon_sym_DASH_GT,
      anon_sym_where,
      anon_sym_LBRACE,
      anon_sym___builtin__,
  [20958] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(397), 1,
      sym_block_comment,
    ACTIONS(1069), 4,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_RBRACE,
  [20977] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(398), 1,
      sym_block_comment,
    ACTIONS(79), 4,
      anon_sym_COMMA,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_RPAREN_DOT,
  [20996] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      sym_identifier,
    ACTIONS(1071), 1,
      anon_sym_RPAREN,
    STATE(399), 1,
      sym_block_comment,
    STATE(479), 1,
      sym_parameter,
    STATE(527), 1,
      sym_named_pattern_param,
  [21021] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1073), 1,
      anon_sym_COMMA,
    ACTIONS(220), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(400), 2,
      sym_block_comment,
      aux_sym_array_literal_repeat1,
  [21042] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(253), 1,
      sym_int_literal,
    STATE(401), 1,
      sym_block_comment,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
  [21065] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(402), 1,
      sym_block_comment,
    ACTIONS(1076), 4,
      anon_sym_LPAREN,
      anon_sym_DOLLAR_LPAREN,
      sym_identifier,
      anon_sym_COLON_COLON,
  [21084] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(403), 1,
      sym_block_comment,
    ACTIONS(1078), 4,
      anon_sym_LPAREN,
      anon_sym_DOLLAR_LPAREN,
      sym_identifier,
      anon_sym_COLON_COLON,
  [21103] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(982), 1,
      anon_sym_LT,
    ACTIONS(1080), 1,
      anon_sym_LBRACE,
    STATE(234), 1,
      sym_braced_parameter_list,
    STATE(404), 1,
      sym_block_comment,
    STATE(524), 1,
      sym_generic_parameters,
  [21128] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      sym_identifier,
    ACTIONS(1082), 1,
      anon_sym_RPAREN,
    STATE(405), 1,
      sym_block_comment,
    STATE(444), 1,
      sym_parameter,
    STATE(525), 1,
      sym__named_argument,
  [21153] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      sym_identifier,
    ACTIONS(1084), 1,
      anon_sym_RPAREN,
    STATE(406), 1,
      sym_block_comment,
    STATE(444), 1,
      sym_parameter,
    STATE(525), 1,
      sym__named_argument,
  [21178] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1086), 1,
      anon_sym_POUND,
    ACTIONS(1088), 1,
      anon_sym_GT,
    ACTIONS(1090), 1,
      sym_identifier,
    STATE(407), 1,
      sym_block_comment,
    STATE(547), 1,
      sym_generic_param,
  [21203] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1086), 1,
      anon_sym_POUND,
    ACTIONS(1090), 1,
      sym_identifier,
    ACTIONS(1092), 1,
      anon_sym_GT,
    STATE(408), 1,
      sym_block_comment,
    STATE(485), 1,
      sym_generic_param,
  [21228] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(409), 1,
      sym_block_comment,
    ACTIONS(1094), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      sym_identifier,
      anon_sym_COLON_COLON,
  [21247] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(410), 1,
      sym_block_comment,
    ACTIONS(1096), 4,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_RBRACE,
  [21266] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(411), 1,
      sym_block_comment,
    ACTIONS(1098), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      sym_identifier,
      anon_sym_COLON_COLON,
  [21285] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      sym_identifier,
    ACTIONS(1100), 1,
      anon_sym_RPAREN,
    STATE(412), 1,
      sym_block_comment,
    STATE(443), 1,
      sym__named_argument,
    STATE(444), 1,
      sym_parameter,
  [21310] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      sym_identifier,
    ACTIONS(1102), 1,
      anon_sym_RPAREN,
    STATE(413), 1,
      sym_block_comment,
    STATE(479), 1,
      sym_parameter,
    STATE(527), 1,
      sym_named_pattern_param,
  [21335] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(414), 1,
      sym_block_comment,
    STATE(605), 1,
      sym_int_literal,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
  [21358] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(982), 1,
      anon_sym_LT,
    ACTIONS(1080), 1,
      anon_sym_LBRACE,
    STATE(271), 1,
      sym_braced_parameter_list,
    STATE(415), 1,
      sym_block_comment,
    STATE(535), 1,
      sym_generic_parameters,
  [21383] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(71), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1104), 1,
      sym_identifier,
    STATE(416), 1,
      sym_block_comment,
    STATE(542), 1,
      sym_scoped_identifier,
    STATE(577), 1,
      sym__path,
  [21408] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1080), 1,
      anon_sym_LBRACE,
    STATE(417), 1,
      sym_block_comment,
    STATE(521), 1,
      sym_braced_parameter_list,
    ACTIONS(1106), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [21431] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(418), 1,
      sym_block_comment,
    ACTIONS(1108), 4,
      anon_sym_LPAREN,
      anon_sym_DOLLAR_LPAREN,
      sym_identifier,
      anon_sym_COLON_COLON,
  [21450] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1086), 1,
      anon_sym_POUND,
    ACTIONS(1090), 1,
      sym_identifier,
    ACTIONS(1110), 1,
      anon_sym_GT,
    STATE(419), 1,
      sym_block_comment,
    STATE(547), 1,
      sym_generic_param,
  [21475] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1112), 1,
      anon_sym_for,
    ACTIONS(1114), 1,
      anon_sym_LBRACE,
    ACTIONS(1116), 1,
      anon_sym_LT,
    STATE(420), 1,
      sym_block_comment,
    STATE(528), 1,
      sym_generic_parameters,
  [21500] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1086), 1,
      anon_sym_POUND,
    ACTIONS(1090), 1,
      sym_identifier,
    ACTIONS(1118), 1,
      anon_sym_GT,
    STATE(421), 1,
      sym_block_comment,
    STATE(547), 1,
      sym_generic_param,
  [21525] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1086), 1,
      anon_sym_POUND,
    ACTIONS(1090), 1,
      sym_identifier,
    ACTIONS(1120), 1,
      anon_sym_GT,
    STATE(422), 1,
      sym_block_comment,
    STATE(547), 1,
      sym_generic_param,
  [21550] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(423), 1,
      sym_block_comment,
    ACTIONS(1122), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      sym_identifier,
      anon_sym_COLON_COLON,
  [21569] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(424), 1,
      sym_block_comment,
    ACTIONS(1124), 4,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      sym_identifier,
      anon_sym_COLON_COLON,
  [21588] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(982), 1,
      anon_sym_LT,
    ACTIONS(1126), 1,
      anon_sym_LBRACE,
    STATE(246), 1,
      sym_enum_body,
    STATE(425), 1,
      sym_block_comment,
    STATE(546), 1,
      sym_generic_parameters,
  [21613] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(426), 1,
      sym_block_comment,
    ACTIONS(1128), 4,
      anon_sym_LPAREN,
      anon_sym_DOLLAR_LPAREN,
      sym_identifier,
      anon_sym_COLON_COLON,
  [21632] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1116), 1,
      anon_sym_LT,
    ACTIONS(1130), 1,
      anon_sym_for,
    ACTIONS(1132), 1,
      anon_sym_LBRACE,
    STATE(427), 1,
      sym_block_comment,
    STATE(552), 1,
      sym_generic_parameters,
  [21657] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      sym_identifier,
    ACTIONS(1134), 1,
      anon_sym_RPAREN,
    STATE(428), 1,
      sym_block_comment,
    STATE(479), 1,
      sym_parameter,
    STATE(480), 1,
      sym_named_pattern_param,
  [21682] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(35), 1,
      anon_sym_LBRACE,
    ACTIONS(1136), 1,
      anon_sym_if,
    STATE(429), 1,
      sym_block_comment,
    STATE(114), 2,
      sym_block,
      sym_if_expression,
  [21705] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(982), 1,
      anon_sym_LT,
    ACTIONS(1138), 1,
      anon_sym_LPAREN,
    STATE(370), 1,
      sym_parameter_list,
    STATE(430), 1,
      sym_block_comment,
    STATE(544), 1,
      sym_generic_parameters,
  [21730] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1142), 1,
      anon_sym___builtin__,
    ACTIONS(1144), 1,
      sym_identifier,
    STATE(431), 1,
      sym_block_comment,
    ACTIONS(1140), 2,
      anon_sym_SEMI,
      anon_sym_LBRACE,
  [21753] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(432), 1,
      sym_block_comment,
    ACTIONS(1146), 4,
      anon_sym_fn,
      anon_sym_entity,
      anon_sym_pipeline,
      anon_sym_RBRACE,
  [21772] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(73), 1,
      aux_sym_int_literal_token1,
    STATE(433), 1,
      sym_block_comment,
    STATE(632), 1,
      sym_int_literal,
    ACTIONS(75), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
  [21795] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1150), 1,
      anon_sym_COMMA,
    ACTIONS(1148), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(434), 2,
      sym_block_comment,
      aux_sym_parameter_list_repeat1,
  [21816] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(732), 1,
      sym_identifier,
    ACTIONS(1153), 1,
      anon_sym_POUND,
    STATE(530), 1,
      sym_attribute,
    STATE(435), 2,
      sym_block_comment,
      aux_sym__item_repeat1,
  [21839] = 8,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1086), 1,
      anon_sym_POUND,
    ACTIONS(1090), 1,
      sym_identifier,
    ACTIONS(1156), 1,
      anon_sym_GT,
    STATE(436), 1,
      sym_block_comment,
    STATE(506), 1,
      sym_generic_param,
  [21864] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1084), 1,
      anon_sym_RPAREN,
    ACTIONS(1158), 1,
      anon_sym_COMMA,
    STATE(437), 1,
      sym_block_comment,
    STATE(456), 1,
      aux_sym__named_argument_list_repeat1,
  [21886] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1071), 1,
      anon_sym_RPAREN,
    ACTIONS(1160), 1,
      anon_sym_COMMA,
    STATE(438), 1,
      sym_block_comment,
    STATE(467), 1,
      aux_sym__named_pattern_list_repeat1,
  [21908] = 6,
    ACTIONS(1162), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1164), 1,
      aux_sym_block_comment_token1,
    ACTIONS(1166), 1,
      anon_sym_STAR_SLASH,
    STATE(439), 1,
      sym_block_comment,
    STATE(486), 1,
      aux_sym_block_comment_repeat1,
    ACTIONS(5), 2,
      sym_doc_comment,
      sym_line_comment,
  [21928] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1168), 1,
      anon_sym_COMMA,
    ACTIONS(1170), 1,
      anon_sym_GT,
    STATE(440), 1,
      sym_block_comment,
    STATE(492), 1,
      aux_sym_turbofish_repeat1,
  [21950] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1172), 1,
      anon_sym_COLON,
    STATE(441), 1,
      sym_block_comment,
    ACTIONS(1174), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [21970] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1170), 1,
      anon_sym_GT,
    ACTIONS(1176), 1,
      anon_sym_COMMA,
    STATE(442), 1,
      sym_block_comment,
    STATE(495), 1,
      aux_sym_turbofish_repeat2,
  [21992] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1178), 1,
      anon_sym_RPAREN,
    ACTIONS(1180), 1,
      anon_sym_COMMA,
    STATE(437), 1,
      aux_sym__named_argument_list_repeat1,
    STATE(443), 1,
      sym_block_comment,
  [22014] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1184), 1,
      anon_sym_COLON,
    STATE(444), 1,
      sym_block_comment,
    ACTIONS(1182), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [22034] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(982), 1,
      anon_sym_LT,
    ACTIONS(1186), 1,
      anon_sym_LBRACE,
    STATE(445), 1,
      sym_block_comment,
    STATE(600), 1,
      sym_generic_parameters,
  [22056] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1010), 1,
      anon_sym_RPAREN,
    ACTIONS(1188), 1,
      anon_sym_COMMA,
    STATE(446), 1,
      sym_block_comment,
    STATE(449), 1,
      aux_sym_parameter_list_repeat1,
  [22078] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(948), 1,
      anon_sym_RPAREN,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    STATE(447), 1,
      sym_block_comment,
    STATE(499), 1,
      aux_sym_parameter_list_repeat1,
  [22100] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1010), 1,
      anon_sym_RPAREN,
    ACTIONS(1188), 1,
      anon_sym_COMMA,
    STATE(434), 1,
      aux_sym_parameter_list_repeat1,
    STATE(448), 1,
      sym_block_comment,
  [22122] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(948), 1,
      anon_sym_RPAREN,
    ACTIONS(1190), 1,
      anon_sym_COMMA,
    STATE(434), 1,
      aux_sym_parameter_list_repeat1,
    STATE(449), 1,
      sym_block_comment,
  [22144] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(450), 1,
      sym_block_comment,
    ACTIONS(1148), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [22162] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(232), 1,
      anon_sym_RPAREN,
    ACTIONS(1192), 1,
      anon_sym_COMMA,
    STATE(451), 2,
      sym_block_comment,
      aux_sym__positional_argument_list_repeat1,
  [22182] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(452), 1,
      sym_block_comment,
    ACTIONS(1195), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [22200] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(550), 1,
      anon_sym_GT,
    ACTIONS(1197), 1,
      sym_identifier,
    STATE(453), 1,
      sym_block_comment,
    STATE(536), 1,
      sym_named_turbofish_arg,
  [22222] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1199), 1,
      anon_sym_COMMA,
    ACTIONS(1202), 1,
      anon_sym_GT,
    STATE(454), 2,
      sym_block_comment,
      aux_sym_turbofish_repeat2,
  [22242] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(455), 1,
      sym_block_comment,
    ACTIONS(1048), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym___builtin__,
  [22260] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1204), 1,
      anon_sym_RPAREN,
    ACTIONS(1206), 1,
      anon_sym_COMMA,
    STATE(456), 2,
      sym_block_comment,
      aux_sym__named_argument_list_repeat1,
  [22280] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(457), 1,
      sym_block_comment,
    ACTIONS(1209), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_GT,
  [22298] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(458), 1,
      sym_block_comment,
    ACTIONS(1046), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym___builtin__,
  [22316] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1209), 1,
      anon_sym_RPAREN,
    ACTIONS(1211), 1,
      anon_sym_COMMA,
    STATE(459), 2,
      sym_block_comment,
      aux_sym_turbofish_repeat1,
  [22336] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(556), 1,
      anon_sym_GT,
    ACTIONS(1214), 1,
      anon_sym_COMMA,
    STATE(460), 1,
      sym_block_comment,
    STATE(513), 1,
      aux_sym_turbofish_repeat1,
  [22358] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(530), 1,
      anon_sym_RPAREN,
    ACTIONS(1216), 1,
      anon_sym_COMMA,
    STATE(459), 1,
      aux_sym_turbofish_repeat1,
    STATE(461), 1,
      sym_block_comment,
  [22380] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1218), 1,
      anon_sym_RBRACE,
    ACTIONS(1220), 1,
      sym_identifier,
    STATE(462), 1,
      sym_block_comment,
    STATE(537), 1,
      sym_enum_member,
  [22402] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1222), 1,
      anon_sym_COMMA,
    ACTIONS(1225), 1,
      anon_sym_RBRACE,
    STATE(463), 2,
      sym_block_comment,
      aux_sym_enum_body_repeat1,
  [22422] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1086), 1,
      anon_sym_POUND,
    ACTIONS(1090), 1,
      sym_identifier,
    STATE(464), 1,
      sym_block_comment,
    STATE(547), 1,
      sym_generic_param,
  [22444] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1227), 1,
      anon_sym_COMMA,
    ACTIONS(1229), 1,
      anon_sym_GT,
    STATE(460), 1,
      aux_sym_turbofish_repeat1,
    STATE(465), 1,
      sym_block_comment,
  [22466] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1220), 1,
      sym_identifier,
    ACTIONS(1231), 1,
      anon_sym_RBRACE,
    STATE(466), 1,
      sym_block_comment,
    STATE(505), 1,
      sym_enum_member,
  [22488] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1233), 1,
      anon_sym_RPAREN,
    ACTIONS(1235), 1,
      anon_sym_COMMA,
    STATE(467), 2,
      sym_block_comment,
      aux_sym__named_pattern_list_repeat1,
  [22508] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(982), 1,
      anon_sym_LT,
    ACTIONS(1238), 1,
      anon_sym_LBRACE,
    STATE(468), 1,
      sym_block_comment,
    STATE(604), 1,
      sym_generic_parameters,
  [22530] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(469), 1,
      sym_block_comment,
    ACTIONS(1240), 3,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
  [22548] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(984), 1,
      anon_sym_RBRACE,
    ACTIONS(1242), 1,
      anon_sym_COMMA,
    STATE(434), 1,
      aux_sym_parameter_list_repeat1,
    STATE(470), 1,
      sym_block_comment,
  [22570] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1220), 1,
      sym_identifier,
    ACTIONS(1244), 1,
      anon_sym_RBRACE,
    STATE(471), 1,
      sym_block_comment,
    STATE(537), 1,
      sym_enum_member,
  [22592] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1244), 1,
      anon_sym_RBRACE,
    ACTIONS(1246), 1,
      anon_sym_COMMA,
    STATE(463), 1,
      aux_sym_enum_body_repeat1,
    STATE(472), 1,
      sym_block_comment,
  [22614] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1248), 1,
      anon_sym_COMMA,
    ACTIONS(1251), 1,
      anon_sym_GT,
    STATE(473), 2,
      sym_block_comment,
      aux_sym_generic_parameters_repeat1,
  [22634] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(982), 1,
      anon_sym_LT,
    ACTIONS(1253), 1,
      anon_sym_LBRACE,
    STATE(474), 1,
      sym_block_comment,
    STATE(599), 1,
      sym_generic_parameters,
  [22656] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(662), 1,
      anon_sym_RPAREN,
    ACTIONS(1255), 1,
      anon_sym_COMMA,
    STATE(475), 1,
      sym_block_comment,
    STATE(516), 1,
      aux_sym_tuple_pattern_repeat1,
  [22678] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      sym_identifier,
    STATE(444), 1,
      sym_parameter,
    STATE(476), 1,
      sym_block_comment,
    STATE(525), 1,
      sym__named_argument,
  [22700] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1257), 1,
      anon_sym_SEMI,
    ACTIONS(1259), 1,
      anon_sym_COMMA,
    STATE(477), 1,
      sym_block_comment,
    STATE(502), 1,
      aux_sym_decl_statement_repeat1,
  [22722] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1261), 1,
      anon_sym_RPAREN,
    ACTIONS(1263), 1,
      anon_sym_COMMA,
    STATE(478), 1,
      sym_block_comment,
    STATE(519), 1,
      aux_sym_tuple_pattern_repeat1,
  [22744] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1267), 1,
      anon_sym_COLON,
    STATE(479), 1,
      sym_block_comment,
    ACTIONS(1265), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [22764] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1269), 1,
      anon_sym_RPAREN,
    ACTIONS(1271), 1,
      anon_sym_COMMA,
    STATE(438), 1,
      aux_sym__named_pattern_list_repeat1,
    STATE(480), 1,
      sym_block_comment,
  [22786] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(481), 1,
      sym_block_comment,
    ACTIONS(1273), 3,
      anon_sym_RPAREN,
      anon_sym_COLON,
      anon_sym_COMMA,
  [22804] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(916), 1,
      anon_sym_RPAREN,
    ACTIONS(1275), 1,
      anon_sym_COMMA,
    STATE(448), 1,
      aux_sym_parameter_list_repeat1,
    STATE(482), 1,
      sym_block_comment,
  [22826] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(920), 1,
      sym_identifier,
    STATE(479), 1,
      sym_parameter,
    STATE(483), 1,
      sym_block_comment,
    STATE(527), 1,
      sym_named_pattern_param,
  [22848] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1277), 1,
      anon_sym_SEMI,
    ACTIONS(1279), 1,
      anon_sym_COMMA,
    STATE(484), 2,
      sym_block_comment,
      aux_sym_decl_statement_repeat1,
  [22868] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1282), 1,
      anon_sym_COMMA,
    ACTIONS(1284), 1,
      anon_sym_GT,
    STATE(485), 1,
      sym_block_comment,
    STATE(512), 1,
      aux_sym_generic_parameters_repeat1,
  [22890] = 6,
    ACTIONS(1162), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1164), 1,
      aux_sym_block_comment_token1,
    ACTIONS(1286), 1,
      anon_sym_STAR_SLASH,
    STATE(486), 1,
      sym_block_comment,
    STATE(496), 1,
      aux_sym_block_comment_repeat1,
    ACTIONS(5), 2,
      sym_doc_comment,
      sym_line_comment,
  [22910] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(487), 1,
      sym_block_comment,
    ACTIONS(1022), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym___builtin__,
  [22928] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(85), 1,
      anon_sym_RBRACK,
    ACTIONS(1288), 1,
      anon_sym_COMMA,
    STATE(400), 1,
      aux_sym_array_literal_repeat1,
    STATE(488), 1,
      sym_block_comment,
  [22950] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1290), 1,
      anon_sym_RPAREN,
    ACTIONS(1292), 1,
      anon_sym_COMMA,
    STATE(461), 1,
      aux_sym_turbofish_repeat1,
    STATE(489), 1,
      sym_block_comment,
  [22972] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(91), 1,
      anon_sym_RPAREN,
    ACTIONS(1294), 1,
      anon_sym_COMMA,
    STATE(451), 1,
      aux_sym__positional_argument_list_repeat1,
    STATE(490), 1,
      sym_block_comment,
  [22994] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1296), 1,
      anon_sym_RPAREN,
    ACTIONS(1298), 1,
      anon_sym_COMMA,
    STATE(475), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(491), 1,
      sym_block_comment,
  [23016] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(516), 1,
      anon_sym_GT,
    ACTIONS(1300), 1,
      anon_sym_COMMA,
    STATE(492), 1,
      sym_block_comment,
    STATE(513), 1,
      aux_sym_turbofish_repeat1,
  [23038] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(493), 1,
      sym_block_comment,
    ACTIONS(1302), 3,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
  [23056] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(516), 1,
      anon_sym_GT,
    ACTIONS(1197), 1,
      sym_identifier,
    STATE(494), 1,
      sym_block_comment,
    STATE(536), 1,
      sym_named_turbofish_arg,
  [23078] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(516), 1,
      anon_sym_GT,
    ACTIONS(1304), 1,
      anon_sym_COMMA,
    STATE(454), 1,
      aux_sym_turbofish_repeat2,
    STATE(495), 1,
      sym_block_comment,
  [23100] = 5,
    ACTIONS(1162), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1306), 1,
      aux_sym_block_comment_token1,
    ACTIONS(1309), 1,
      anon_sym_STAR_SLASH,
    ACTIONS(5), 2,
      sym_doc_comment,
      sym_line_comment,
    STATE(496), 2,
      sym_block_comment,
      aux_sym_block_comment_repeat1,
  [23118] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(497), 1,
      sym_block_comment,
    ACTIONS(1311), 3,
      anon_sym_EQ,
      anon_sym_reset,
      anon_sym_initial,
  [23136] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(721), 1,
      anon_sym_RPAREN_DOT,
    ACTIONS(1313), 1,
      anon_sym_LT,
    STATE(498), 1,
      sym_block_comment,
    STATE(575), 1,
      sym__generic_list,
  [23158] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(966), 1,
      anon_sym_RPAREN,
    ACTIONS(1315), 1,
      anon_sym_COMMA,
    STATE(434), 1,
      aux_sym_parameter_list_repeat1,
    STATE(499), 1,
      sym_block_comment,
  [23180] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(500), 1,
      sym_block_comment,
    ACTIONS(1317), 3,
      anon_sym_RPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [23198] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(501), 1,
      sym_block_comment,
    ACTIONS(1319), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym___builtin__,
  [23216] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1321), 1,
      anon_sym_SEMI,
    ACTIONS(1323), 1,
      anon_sym_COMMA,
    STATE(484), 1,
      aux_sym_decl_statement_repeat1,
    STATE(502), 1,
      sym_block_comment,
  [23238] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1325), 1,
      aux_sym_int_literal_token1,
    STATE(503), 1,
      sym_block_comment,
    ACTIONS(1327), 2,
      aux_sym_int_literal_token2,
      aux_sym_int_literal_token3,
  [23258] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1329), 1,
      anon_sym_COMMA,
    ACTIONS(1331), 1,
      anon_sym_RBRACE,
    STATE(470), 1,
      aux_sym_parameter_list_repeat1,
    STATE(504), 1,
      sym_block_comment,
  [23280] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1333), 1,
      anon_sym_COMMA,
    ACTIONS(1335), 1,
      anon_sym_RBRACE,
    STATE(472), 1,
      aux_sym_enum_body_repeat1,
    STATE(505), 1,
      sym_block_comment,
  [23302] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1337), 1,
      anon_sym_COMMA,
    ACTIONS(1339), 1,
      anon_sym_GT,
    STATE(506), 1,
      sym_block_comment,
    STATE(508), 1,
      aux_sym_generic_parameters_repeat1,
  [23324] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1341), 1,
      anon_sym_RPAREN,
    ACTIONS(1343), 1,
      anon_sym_COMMA,
    STATE(507), 1,
      sym_block_comment,
    STATE(510), 1,
      aux_sym_turbofish_repeat1,
  [23346] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1110), 1,
      anon_sym_GT,
    ACTIONS(1345), 1,
      anon_sym_COMMA,
    STATE(473), 1,
      aux_sym_generic_parameters_repeat1,
    STATE(508), 1,
      sym_block_comment,
  [23368] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1347), 1,
      anon_sym_SEMI,
    ACTIONS(1349), 1,
      anon_sym_LPAREN,
    ACTIONS(1351), 1,
      anon_sym_STAR,
    STATE(509), 1,
      sym_block_comment,
  [23390] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(560), 1,
      anon_sym_RPAREN,
    ACTIONS(1353), 1,
      anon_sym_COMMA,
    STATE(459), 1,
      aux_sym_turbofish_repeat1,
    STATE(510), 1,
      sym_block_comment,
  [23412] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1355), 1,
      anon_sym_COMMA,
    ACTIONS(1357), 1,
      anon_sym_GT,
    STATE(511), 1,
      sym_block_comment,
    STATE(514), 1,
      aux_sym_turbofish_repeat1,
  [23434] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1088), 1,
      anon_sym_GT,
    ACTIONS(1359), 1,
      anon_sym_COMMA,
    STATE(473), 1,
      aux_sym_generic_parameters_repeat1,
    STATE(512), 1,
      sym_block_comment,
  [23456] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1209), 1,
      anon_sym_GT,
    ACTIONS(1361), 1,
      anon_sym_COMMA,
    STATE(513), 2,
      sym_block_comment,
      aux_sym_turbofish_repeat1,
  [23476] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(564), 1,
      anon_sym_GT,
    ACTIONS(1364), 1,
      anon_sym_COMMA,
    STATE(513), 1,
      aux_sym_turbofish_repeat1,
    STATE(514), 1,
      sym_block_comment,
  [23498] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(95), 1,
      anon_sym_RPAREN,
    ACTIONS(1366), 1,
      anon_sym_COMMA,
    STATE(400), 1,
      aux_sym_array_literal_repeat1,
    STATE(515), 1,
      sym_block_comment,
  [23520] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1368), 1,
      anon_sym_RPAREN,
    ACTIONS(1370), 1,
      anon_sym_COMMA,
    STATE(516), 2,
      sym_block_comment,
      aux_sym_tuple_pattern_repeat1,
  [23540] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(544), 1,
      anon_sym_GT,
    ACTIONS(1197), 1,
      sym_identifier,
    STATE(442), 1,
      sym_named_turbofish_arg,
    STATE(517), 1,
      sym_block_comment,
  [23562] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(982), 1,
      anon_sym_LT,
    ACTIONS(1373), 1,
      anon_sym_LBRACE,
    STATE(518), 1,
      sym_block_comment,
    STATE(612), 1,
      sym_generic_parameters,
  [23584] = 7,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(674), 1,
      anon_sym_RPAREN,
    ACTIONS(1375), 1,
      anon_sym_COMMA,
    STATE(516), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(519), 1,
      sym_block_comment,
  [23606] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1379), 1,
      sym_identifier,
    STATE(520), 1,
      sym_block_comment,
    ACTIONS(1377), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
  [23626] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(521), 1,
      sym_block_comment,
    ACTIONS(1381), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [23643] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(522), 1,
      sym_block_comment,
    ACTIONS(1277), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [23660] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1383), 1,
      anon_sym_SEMI,
    ACTIONS(1385), 1,
      sym_identifier,
    STATE(523), 1,
      sym_block_comment,
  [23679] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1080), 1,
      anon_sym_LBRACE,
    STATE(271), 1,
      sym_braced_parameter_list,
    STATE(524), 1,
      sym_block_comment,
  [23698] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(525), 1,
      sym_block_comment,
    ACTIONS(1204), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [23715] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(526), 1,
      sym_block_comment,
    ACTIONS(1387), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [23732] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(527), 1,
      sym_block_comment,
    ACTIONS(1233), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [23749] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1130), 1,
      anon_sym_for,
    ACTIONS(1132), 1,
      anon_sym_LBRACE,
    STATE(528), 1,
      sym_block_comment,
  [23768] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1389), 1,
      anon_sym_COLON,
    ACTIONS(1391), 1,
      anon_sym_EQ,
    STATE(529), 1,
      sym_block_comment,
  [23787] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(530), 1,
      sym_block_comment,
    ACTIONS(844), 2,
      anon_sym_POUND,
      sym_identifier,
  [23804] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(531), 1,
      sym_block_comment,
    ACTIONS(727), 2,
      anon_sym_LT,
      anon_sym_RPAREN_DOT,
  [23821] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(532), 1,
      sym_block_comment,
    ACTIONS(734), 2,
      anon_sym_LT,
      anon_sym_RPAREN_DOT,
  [23838] = 4,
    ACTIONS(1162), 1,
      anon_sym_SLASH_STAR,
    STATE(533), 1,
      sym_block_comment,
    ACTIONS(5), 2,
      sym_doc_comment,
      sym_line_comment,
    ACTIONS(1393), 2,
      aux_sym_block_comment_token1,
      anon_sym_STAR_SLASH,
  [23853] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(534), 1,
      sym_block_comment,
    ACTIONS(1124), 2,
      anon_sym_for,
      anon_sym_LBRACE,
  [23870] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1080), 1,
      anon_sym_LBRACE,
    STATE(244), 1,
      sym_braced_parameter_list,
    STATE(535), 1,
      sym_block_comment,
  [23889] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(536), 1,
      sym_block_comment,
    ACTIONS(1202), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [23906] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(537), 1,
      sym_block_comment,
    ACTIONS(1225), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [23923] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(538), 1,
      sym_block_comment,
    ACTIONS(1094), 2,
      anon_sym_for,
      anon_sym_LBRACE,
  [23940] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1321), 1,
      anon_sym_SEMI,
    ACTIONS(1385), 1,
      sym_identifier,
    STATE(539), 1,
      sym_block_comment,
  [23959] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(540), 1,
      sym_block_comment,
    ACTIONS(1098), 2,
      anon_sym_for,
      anon_sym_LBRACE,
  [23976] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(541), 1,
      sym_block_comment,
    ACTIONS(1122), 2,
      anon_sym_for,
      anon_sym_LBRACE,
  [23993] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(968), 1,
      anon_sym_COLON_COLON,
    ACTIONS(1395), 1,
      anon_sym_SEMI,
    STATE(542), 1,
      sym_block_comment,
  [24012] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1220), 1,
      sym_identifier,
    STATE(537), 1,
      sym_enum_member,
    STATE(543), 1,
      sym_block_comment,
  [24031] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1138), 1,
      anon_sym_LPAREN,
    STATE(366), 1,
      sym_parameter_list,
    STATE(544), 1,
      sym_block_comment,
  [24050] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(545), 1,
      sym_block_comment,
    ACTIONS(1397), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [24067] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1126), 1,
      anon_sym_LBRACE,
    STATE(243), 1,
      sym_enum_body,
    STATE(546), 1,
      sym_block_comment,
  [24086] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(547), 1,
      sym_block_comment,
    ACTIONS(1251), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [24103] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1399), 1,
      anon_sym_port,
    ACTIONS(1401), 1,
      sym_identifier,
    STATE(548), 1,
      sym_block_comment,
  [24122] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1197), 1,
      sym_identifier,
    STATE(536), 1,
      sym_named_turbofish_arg,
    STATE(549), 1,
      sym_block_comment,
  [24141] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1403), 1,
      anon_sym_inst,
    ACTIONS(1405), 1,
      sym_identifier,
    STATE(550), 1,
      sym_block_comment,
  [24160] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(551), 1,
      sym_block_comment,
    ACTIONS(1368), 2,
      anon_sym_RPAREN,
      anon_sym_COMMA,
  [24177] = 6,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1407), 1,
      anon_sym_for,
    ACTIONS(1409), 1,
      anon_sym_LBRACE,
    STATE(552), 1,
      sym_block_comment,
  [24196] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(553), 1,
      sym_block_comment,
    ACTIONS(1411), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [24213] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(554), 1,
      sym_block_comment,
    ACTIONS(1413), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [24230] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    STATE(555), 1,
      sym_block_comment,
    ACTIONS(846), 2,
      anon_sym_POUND,
      sym_identifier,
  [24247] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1415), 1,
      sym_identifier,
    STATE(556), 1,
      sym_block_comment,
  [24263] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1417), 1,
      anon_sym_LPAREN,
    STATE(557), 1,
      sym_block_comment,
  [24279] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1419), 1,
      anon_sym_COLON,
    STATE(558), 1,
      sym_block_comment,
  [24295] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1421), 1,
      anon_sym_LBRACE,
    STATE(559), 1,
      sym_block_comment,
  [24311] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1423), 1,
      anon_sym_RBRACK,
    STATE(560), 1,
      sym_block_comment,
  [24327] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1425), 1,
      anon_sym_RPAREN,
    STATE(561), 1,
      sym_block_comment,
  [24343] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1427), 1,
      sym_identifier,
    STATE(562), 1,
      sym_block_comment,
  [24359] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1429), 1,
      anon_sym_RBRACE,
    STATE(563), 1,
      sym_block_comment,
  [24375] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1431), 1,
      anon_sym_SEMI,
    STATE(564), 1,
      sym_block_comment,
  [24391] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(721), 1,
      anon_sym_RPAREN_DOT,
    STATE(565), 1,
      sym_block_comment,
  [24407] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1433), 1,
      anon_sym_EQ_GT,
    STATE(566), 1,
      sym_block_comment,
  [24423] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1435), 1,
      anon_sym_COLON,
    STATE(567), 1,
      sym_block_comment,
  [24439] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1437), 1,
      anon_sym_RBRACK,
    STATE(568), 1,
      sym_block_comment,
  [24455] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1439), 1,
      sym_identifier,
    STATE(569), 1,
      sym_block_comment,
  [24471] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1441), 1,
      sym_identifier,
    STATE(570), 1,
      sym_block_comment,
  [24487] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1443), 1,
      anon_sym_RPAREN_DOT,
    STATE(571), 1,
      sym_block_comment,
  [24503] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(814), 1,
      anon_sym_RPAREN_DOT,
    STATE(572), 1,
      sym_block_comment,
  [24519] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(822), 1,
      anon_sym_RPAREN_DOT,
    STATE(573), 1,
      sym_block_comment,
  [24535] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(826), 1,
      anon_sym_RPAREN_DOT,
    STATE(574), 1,
      sym_block_comment,
  [24551] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(824), 1,
      anon_sym_RPAREN_DOT,
    STATE(575), 1,
      sym_block_comment,
  [24567] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1445), 1,
      sym_identifier,
    STATE(576), 1,
      sym_block_comment,
  [24583] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1447), 1,
      anon_sym_COLON_COLON,
    STATE(577), 1,
      sym_block_comment,
  [24599] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1449), 1,
      sym_identifier,
    STATE(578), 1,
      sym_block_comment,
  [24615] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1451), 1,
      sym_identifier,
    STATE(579), 1,
      sym_block_comment,
  [24631] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1453), 1,
      anon_sym_EQ_GT,
    STATE(580), 1,
      sym_block_comment,
  [24647] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(812), 1,
      anon_sym_RPAREN_DOT,
    STATE(581), 1,
      sym_block_comment,
  [24663] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(832), 1,
      anon_sym_RPAREN_DOT,
    STATE(582), 1,
      sym_block_comment,
  [24679] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(820), 1,
      anon_sym_RPAREN_DOT,
    STATE(583), 1,
      sym_block_comment,
  [24695] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1455), 1,
      sym_identifier,
    STATE(584), 1,
      sym_block_comment,
  [24711] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(818), 1,
      anon_sym_RPAREN_DOT,
    STATE(585), 1,
      sym_block_comment,
  [24727] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(828), 1,
      anon_sym_RPAREN_DOT,
    STATE(586), 1,
      sym_block_comment,
  [24743] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1457), 1,
      anon_sym_SEMI,
    STATE(587), 1,
      sym_block_comment,
  [24759] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(830), 1,
      anon_sym_RPAREN_DOT,
    STATE(588), 1,
      sym_block_comment,
  [24775] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(834), 1,
      anon_sym_RPAREN_DOT,
    STATE(589), 1,
      sym_block_comment,
  [24791] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1459), 1,
      sym_identifier,
    STATE(590), 1,
      sym_block_comment,
  [24807] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(816), 1,
      anon_sym_RPAREN_DOT,
    STATE(591), 1,
      sym_block_comment,
  [24823] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(810), 1,
      anon_sym_RPAREN_DOT,
    STATE(592), 1,
      sym_block_comment,
  [24839] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1461), 1,
      anon_sym_else,
    STATE(593), 1,
      sym_block_comment,
  [24855] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1385), 1,
      sym_identifier,
    STATE(594), 1,
      sym_block_comment,
  [24871] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1463), 1,
      sym_identifier,
    STATE(595), 1,
      sym_block_comment,
  [24887] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1465), 1,
      anon_sym_RPAREN,
    STATE(596), 1,
      sym_block_comment,
  [24903] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1467), 1,
      sym_identifier,
    STATE(597), 1,
      sym_block_comment,
  [24919] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1469), 1,
      ts_builtin_sym_end,
    STATE(598), 1,
      sym_block_comment,
  [24935] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1471), 1,
      anon_sym_LBRACE,
    STATE(599), 1,
      sym_block_comment,
  [24951] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1473), 1,
      anon_sym_LBRACE,
    STATE(600), 1,
      sym_block_comment,
  [24967] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1475), 1,
      anon_sym_RBRACK,
    STATE(601), 1,
      sym_block_comment,
  [24983] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1477), 1,
      sym_identifier,
    STATE(602), 1,
      sym_block_comment,
  [24999] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1479), 1,
      anon_sym_RPAREN_DOT,
    STATE(603), 1,
      sym_block_comment,
  [25015] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1481), 1,
      anon_sym_LBRACE,
    STATE(604), 1,
      sym_block_comment,
  [25031] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1483), 1,
      anon_sym_LBRACE,
    STATE(605), 1,
      sym_block_comment,
  [25047] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1485), 1,
      sym_identifier,
    STATE(606), 1,
      sym_block_comment,
  [25063] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1487), 1,
      sym_identifier,
    STATE(607), 1,
      sym_block_comment,
  [25079] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1489), 1,
      anon_sym_SEMI,
    STATE(608), 1,
      sym_block_comment,
  [25095] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1491), 1,
      sym_identifier,
    STATE(609), 1,
      sym_block_comment,
  [25111] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1493), 1,
      anon_sym_LPAREN,
    STATE(610), 1,
      sym_block_comment,
  [25127] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1495), 1,
      sym_identifier,
    STATE(611), 1,
      sym_block_comment,
  [25143] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1497), 1,
      anon_sym_LBRACE,
    STATE(612), 1,
      sym_block_comment,
  [25159] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1499), 1,
      sym_identifier,
    STATE(613), 1,
      sym_block_comment,
  [25175] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1501), 1,
      anon_sym_LBRACK,
    STATE(614), 1,
      sym_block_comment,
  [25191] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1503), 1,
      anon_sym_LPAREN,
    STATE(615), 1,
      sym_block_comment,
  [25207] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1505), 1,
      anon_sym_RBRACE,
    STATE(616), 1,
      sym_block_comment,
  [25223] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1507), 1,
      anon_sym_BQUOTE,
    STATE(617), 1,
      sym_block_comment,
  [25239] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1509), 1,
      anon_sym_RBRACK,
    STATE(618), 1,
      sym_block_comment,
  [25255] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1511), 1,
      anon_sym_RPAREN,
    STATE(619), 1,
      sym_block_comment,
  [25271] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1513), 1,
      anon_sym_LBRACE,
    STATE(620), 1,
      sym_block_comment,
  [25287] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1515), 1,
      sym_identifier,
    STATE(621), 1,
      sym_block_comment,
  [25303] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1517), 1,
      anon_sym_EQ,
    STATE(622), 1,
      sym_block_comment,
  [25319] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(968), 1,
      anon_sym_COLON_COLON,
    STATE(623), 1,
      sym_block_comment,
  [25335] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1519), 1,
      anon_sym_COLON,
    STATE(624), 1,
      sym_block_comment,
  [25351] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1521), 1,
      anon_sym_EQ,
    STATE(625), 1,
      sym_block_comment,
  [25367] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1523), 1,
      anon_sym_COLON,
    STATE(626), 1,
      sym_block_comment,
  [25383] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1525), 1,
      anon_sym_SEMI,
    STATE(627), 1,
      sym_block_comment,
  [25399] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1527), 1,
      sym_identifier,
    STATE(628), 1,
      sym_block_comment,
  [25415] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1529), 1,
      anon_sym_COLON_COLON,
    STATE(629), 1,
      sym_block_comment,
  [25431] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1531), 1,
      sym_identifier,
    STATE(630), 1,
      sym_block_comment,
  [25447] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1533), 1,
      anon_sym_LPAREN,
    STATE(631), 1,
      sym_block_comment,
  [25463] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1535), 1,
      anon_sym_LBRACE,
    STATE(632), 1,
      sym_block_comment,
  [25479] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1537), 1,
      anon_sym_LBRACE,
    STATE(633), 1,
      sym_block_comment,
  [25495] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1539), 1,
      anon_sym_LBRACK,
    STATE(634), 1,
      sym_block_comment,
  [25511] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1541), 1,
      anon_sym_SEMI,
    STATE(635), 1,
      sym_block_comment,
  [25527] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1543), 1,
      sym_identifier,
    STATE(636), 1,
      sym_block_comment,
  [25543] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1545), 1,
      sym_identifier,
    STATE(637), 1,
      sym_block_comment,
  [25559] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1547), 1,
      sym_identifier,
    STATE(638), 1,
      sym_block_comment,
  [25575] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1549), 1,
      sym_identifier,
    STATE(639), 1,
      sym_block_comment,
  [25591] = 5,
    ACTIONS(3), 1,
      sym_doc_comment,
    ACTIONS(5), 1,
      sym_line_comment,
    ACTIONS(7), 1,
      anon_sym_SLASH_STAR,
    ACTIONS(1551), 1,
      sym_identifier,
    STATE(640), 1,
      sym_block_comment,
  [25607] = 1,
    ACTIONS(1553), 1,
      ts_builtin_sym_end,
  [25611] = 1,
    ACTIONS(1555), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(4)] = 0,
  [SMALL_STATE(5)] = 63,
  [SMALL_STATE(6)] = 169,
  [SMALL_STATE(7)] = 275,
  [SMALL_STATE(8)] = 381,
  [SMALL_STATE(9)] = 487,
  [SMALL_STATE(10)] = 593,
  [SMALL_STATE(11)] = 699,
  [SMALL_STATE(12)] = 805,
  [SMALL_STATE(13)] = 911,
  [SMALL_STATE(14)] = 1017,
  [SMALL_STATE(15)] = 1120,
  [SMALL_STATE(16)] = 1223,
  [SMALL_STATE(17)] = 1326,
  [SMALL_STATE(18)] = 1429,
  [SMALL_STATE(19)] = 1532,
  [SMALL_STATE(20)] = 1635,
  [SMALL_STATE(21)] = 1738,
  [SMALL_STATE(22)] = 1841,
  [SMALL_STATE(23)] = 1944,
  [SMALL_STATE(24)] = 2047,
  [SMALL_STATE(25)] = 2150,
  [SMALL_STATE(26)] = 2253,
  [SMALL_STATE(27)] = 2356,
  [SMALL_STATE(28)] = 2459,
  [SMALL_STATE(29)] = 2562,
  [SMALL_STATE(30)] = 2665,
  [SMALL_STATE(31)] = 2768,
  [SMALL_STATE(32)] = 2869,
  [SMALL_STATE(33)] = 2972,
  [SMALL_STATE(34)] = 3075,
  [SMALL_STATE(35)] = 3178,
  [SMALL_STATE(36)] = 3281,
  [SMALL_STATE(37)] = 3384,
  [SMALL_STATE(38)] = 3487,
  [SMALL_STATE(39)] = 3590,
  [SMALL_STATE(40)] = 3693,
  [SMALL_STATE(41)] = 3796,
  [SMALL_STATE(42)] = 3899,
  [SMALL_STATE(43)] = 4002,
  [SMALL_STATE(44)] = 4105,
  [SMALL_STATE(45)] = 4208,
  [SMALL_STATE(46)] = 4311,
  [SMALL_STATE(47)] = 4414,
  [SMALL_STATE(48)] = 4517,
  [SMALL_STATE(49)] = 4620,
  [SMALL_STATE(50)] = 4723,
  [SMALL_STATE(51)] = 4826,
  [SMALL_STATE(52)] = 4886,
  [SMALL_STATE(53)] = 4946,
  [SMALL_STATE(54)] = 5006,
  [SMALL_STATE(55)] = 5083,
  [SMALL_STATE(56)] = 5174,
  [SMALL_STATE(57)] = 5263,
  [SMALL_STATE(58)] = 5366,
  [SMALL_STATE(59)] = 5453,
  [SMALL_STATE(60)] = 5560,
  [SMALL_STATE(61)] = 5657,
  [SMALL_STATE(62)] = 5758,
  [SMALL_STATE(63)] = 5857,
  [SMALL_STATE(64)] = 5962,
  [SMALL_STATE(65)] = 6039,
  [SMALL_STATE(66)] = 6122,
  [SMALL_STATE(67)] = 6191,
  [SMALL_STATE(68)] = 6266,
  [SMALL_STATE(69)] = 6335,
  [SMALL_STATE(70)] = 6389,
  [SMALL_STATE(71)] = 6443,
  [SMALL_STATE(72)] = 6499,
  [SMALL_STATE(73)] = 6606,
  [SMALL_STATE(74)] = 6708,
  [SMALL_STATE(75)] = 6813,
  [SMALL_STATE(76)] = 6918,
  [SMALL_STATE(77)] = 7019,
  [SMALL_STATE(78)] = 7124,
  [SMALL_STATE(79)] = 7226,
  [SMALL_STATE(80)] = 7328,
  [SMALL_STATE(81)] = 7430,
  [SMALL_STATE(82)] = 7530,
  [SMALL_STATE(83)] = 7630,
  [SMALL_STATE(84)] = 7732,
  [SMALL_STATE(85)] = 7782,
  [SMALL_STATE(86)] = 7881,
  [SMALL_STATE(87)] = 7980,
  [SMALL_STATE(88)] = 8079,
  [SMALL_STATE(89)] = 8178,
  [SMALL_STATE(90)] = 8277,
  [SMALL_STATE(91)] = 8376,
  [SMALL_STATE(92)] = 8475,
  [SMALL_STATE(93)] = 8574,
  [SMALL_STATE(94)] = 8673,
  [SMALL_STATE(95)] = 8772,
  [SMALL_STATE(96)] = 8871,
  [SMALL_STATE(97)] = 8970,
  [SMALL_STATE(98)] = 9069,
  [SMALL_STATE(99)] = 9168,
  [SMALL_STATE(100)] = 9267,
  [SMALL_STATE(101)] = 9366,
  [SMALL_STATE(102)] = 9465,
  [SMALL_STATE(103)] = 9564,
  [SMALL_STATE(104)] = 9611,
  [SMALL_STATE(105)] = 9658,
  [SMALL_STATE(106)] = 9705,
  [SMALL_STATE(107)] = 9752,
  [SMALL_STATE(108)] = 9799,
  [SMALL_STATE(109)] = 9846,
  [SMALL_STATE(110)] = 9893,
  [SMALL_STATE(111)] = 9940,
  [SMALL_STATE(112)] = 9987,
  [SMALL_STATE(113)] = 10034,
  [SMALL_STATE(114)] = 10081,
  [SMALL_STATE(115)] = 10128,
  [SMALL_STATE(116)] = 10175,
  [SMALL_STATE(117)] = 10222,
  [SMALL_STATE(118)] = 10269,
  [SMALL_STATE(119)] = 10316,
  [SMALL_STATE(120)] = 10363,
  [SMALL_STATE(121)] = 10410,
  [SMALL_STATE(122)] = 10457,
  [SMALL_STATE(123)] = 10504,
  [SMALL_STATE(124)] = 10555,
  [SMALL_STATE(125)] = 10602,
  [SMALL_STATE(126)] = 10649,
  [SMALL_STATE(127)] = 10696,
  [SMALL_STATE(128)] = 10743,
  [SMALL_STATE(129)] = 10790,
  [SMALL_STATE(130)] = 10837,
  [SMALL_STATE(131)] = 10884,
  [SMALL_STATE(132)] = 10931,
  [SMALL_STATE(133)] = 10978,
  [SMALL_STATE(134)] = 11025,
  [SMALL_STATE(135)] = 11076,
  [SMALL_STATE(136)] = 11123,
  [SMALL_STATE(137)] = 11174,
  [SMALL_STATE(138)] = 11221,
  [SMALL_STATE(139)] = 11268,
  [SMALL_STATE(140)] = 11315,
  [SMALL_STATE(141)] = 11362,
  [SMALL_STATE(142)] = 11409,
  [SMALL_STATE(143)] = 11456,
  [SMALL_STATE(144)] = 11501,
  [SMALL_STATE(145)] = 11546,
  [SMALL_STATE(146)] = 11591,
  [SMALL_STATE(147)] = 11636,
  [SMALL_STATE(148)] = 11681,
  [SMALL_STATE(149)] = 11726,
  [SMALL_STATE(150)] = 11771,
  [SMALL_STATE(151)] = 11816,
  [SMALL_STATE(152)] = 11861,
  [SMALL_STATE(153)] = 11935,
  [SMALL_STATE(154)] = 12010,
  [SMALL_STATE(155)] = 12085,
  [SMALL_STATE(156)] = 12160,
  [SMALL_STATE(157)] = 12226,
  [SMALL_STATE(158)] = 12288,
  [SMALL_STATE(159)] = 12350,
  [SMALL_STATE(160)] = 12414,
  [SMALL_STATE(161)] = 12476,
  [SMALL_STATE(162)] = 12538,
  [SMALL_STATE(163)] = 12600,
  [SMALL_STATE(164)] = 12662,
  [SMALL_STATE(165)] = 12724,
  [SMALL_STATE(166)] = 12786,
  [SMALL_STATE(167)] = 12848,
  [SMALL_STATE(168)] = 12910,
  [SMALL_STATE(169)] = 12972,
  [SMALL_STATE(170)] = 13034,
  [SMALL_STATE(171)] = 13096,
  [SMALL_STATE(172)] = 13158,
  [SMALL_STATE(173)] = 13220,
  [SMALL_STATE(174)] = 13279,
  [SMALL_STATE(175)] = 13316,
  [SMALL_STATE(176)] = 13353,
  [SMALL_STATE(177)] = 13414,
  [SMALL_STATE(178)] = 13451,
  [SMALL_STATE(179)] = 13488,
  [SMALL_STATE(180)] = 13547,
  [SMALL_STATE(181)] = 13606,
  [SMALL_STATE(182)] = 13665,
  [SMALL_STATE(183)] = 13724,
  [SMALL_STATE(184)] = 13783,
  [SMALL_STATE(185)] = 13842,
  [SMALL_STATE(186)] = 13901,
  [SMALL_STATE(187)] = 13938,
  [SMALL_STATE(188)] = 13997,
  [SMALL_STATE(189)] = 14056,
  [SMALL_STATE(190)] = 14115,
  [SMALL_STATE(191)] = 14174,
  [SMALL_STATE(192)] = 14233,
  [SMALL_STATE(193)] = 14292,
  [SMALL_STATE(194)] = 14351,
  [SMALL_STATE(195)] = 14388,
  [SMALL_STATE(196)] = 14425,
  [SMALL_STATE(197)] = 14484,
  [SMALL_STATE(198)] = 14521,
  [SMALL_STATE(199)] = 14558,
  [SMALL_STATE(200)] = 14617,
  [SMALL_STATE(201)] = 14676,
  [SMALL_STATE(202)] = 14735,
  [SMALL_STATE(203)] = 14772,
  [SMALL_STATE(204)] = 14809,
  [SMALL_STATE(205)] = 14846,
  [SMALL_STATE(206)] = 14905,
  [SMALL_STATE(207)] = 14964,
  [SMALL_STATE(208)] = 15023,
  [SMALL_STATE(209)] = 15082,
  [SMALL_STATE(210)] = 15138,
  [SMALL_STATE(211)] = 15193,
  [SMALL_STATE(212)] = 15248,
  [SMALL_STATE(213)] = 15303,
  [SMALL_STATE(214)] = 15358,
  [SMALL_STATE(215)] = 15413,
  [SMALL_STATE(216)] = 15468,
  [SMALL_STATE(217)] = 15523,
  [SMALL_STATE(218)] = 15578,
  [SMALL_STATE(219)] = 15633,
  [SMALL_STATE(220)] = 15686,
  [SMALL_STATE(221)] = 15741,
  [SMALL_STATE(222)] = 15796,
  [SMALL_STATE(223)] = 15851,
  [SMALL_STATE(224)] = 15906,
  [SMALL_STATE(225)] = 15961,
  [SMALL_STATE(226)] = 16013,
  [SMALL_STATE(227)] = 16065,
  [SMALL_STATE(228)] = 16117,
  [SMALL_STATE(229)] = 16169,
  [SMALL_STATE(230)] = 16198,
  [SMALL_STATE(231)] = 16227,
  [SMALL_STATE(232)] = 16256,
  [SMALL_STATE(233)] = 16285,
  [SMALL_STATE(234)] = 16318,
  [SMALL_STATE(235)] = 16346,
  [SMALL_STATE(236)] = 16374,
  [SMALL_STATE(237)] = 16406,
  [SMALL_STATE(238)] = 16434,
  [SMALL_STATE(239)] = 16462,
  [SMALL_STATE(240)] = 16490,
  [SMALL_STATE(241)] = 16518,
  [SMALL_STATE(242)] = 16546,
  [SMALL_STATE(243)] = 16574,
  [SMALL_STATE(244)] = 16602,
  [SMALL_STATE(245)] = 16630,
  [SMALL_STATE(246)] = 16658,
  [SMALL_STATE(247)] = 16686,
  [SMALL_STATE(248)] = 16714,
  [SMALL_STATE(249)] = 16742,
  [SMALL_STATE(250)] = 16770,
  [SMALL_STATE(251)] = 16798,
  [SMALL_STATE(252)] = 16826,
  [SMALL_STATE(253)] = 16854,
  [SMALL_STATE(254)] = 16882,
  [SMALL_STATE(255)] = 16910,
  [SMALL_STATE(256)] = 16938,
  [SMALL_STATE(257)] = 16966,
  [SMALL_STATE(258)] = 16994,
  [SMALL_STATE(259)] = 17022,
  [SMALL_STATE(260)] = 17050,
  [SMALL_STATE(261)] = 17078,
  [SMALL_STATE(262)] = 17106,
  [SMALL_STATE(263)] = 17134,
  [SMALL_STATE(264)] = 17162,
  [SMALL_STATE(265)] = 17190,
  [SMALL_STATE(266)] = 17218,
  [SMALL_STATE(267)] = 17246,
  [SMALL_STATE(268)] = 17274,
  [SMALL_STATE(269)] = 17302,
  [SMALL_STATE(270)] = 17330,
  [SMALL_STATE(271)] = 17358,
  [SMALL_STATE(272)] = 17386,
  [SMALL_STATE(273)] = 17414,
  [SMALL_STATE(274)] = 17442,
  [SMALL_STATE(275)] = 17470,
  [SMALL_STATE(276)] = 17497,
  [SMALL_STATE(277)] = 17524,
  [SMALL_STATE(278)] = 17551,
  [SMALL_STATE(279)] = 17578,
  [SMALL_STATE(280)] = 17605,
  [SMALL_STATE(281)] = 17632,
  [SMALL_STATE(282)] = 17659,
  [SMALL_STATE(283)] = 17686,
  [SMALL_STATE(284)] = 17713,
  [SMALL_STATE(285)] = 17740,
  [SMALL_STATE(286)] = 17767,
  [SMALL_STATE(287)] = 17794,
  [SMALL_STATE(288)] = 17821,
  [SMALL_STATE(289)] = 17848,
  [SMALL_STATE(290)] = 17884,
  [SMALL_STATE(291)] = 17910,
  [SMALL_STATE(292)] = 17936,
  [SMALL_STATE(293)] = 17965,
  [SMALL_STATE(294)] = 17994,
  [SMALL_STATE(295)] = 18022,
  [SMALL_STATE(296)] = 18045,
  [SMALL_STATE(297)] = 18080,
  [SMALL_STATE(298)] = 18111,
  [SMALL_STATE(299)] = 18146,
  [SMALL_STATE(300)] = 18181,
  [SMALL_STATE(301)] = 18216,
  [SMALL_STATE(302)] = 18251,
  [SMALL_STATE(303)] = 18286,
  [SMALL_STATE(304)] = 18321,
  [SMALL_STATE(305)] = 18356,
  [SMALL_STATE(306)] = 18391,
  [SMALL_STATE(307)] = 18426,
  [SMALL_STATE(308)] = 18461,
  [SMALL_STATE(309)] = 18494,
  [SMALL_STATE(310)] = 18527,
  [SMALL_STATE(311)] = 18562,
  [SMALL_STATE(312)] = 18597,
  [SMALL_STATE(313)] = 18632,
  [SMALL_STATE(314)] = 18669,
  [SMALL_STATE(315)] = 18694,
  [SMALL_STATE(316)] = 18725,
  [SMALL_STATE(317)] = 18762,
  [SMALL_STATE(318)] = 18797,
  [SMALL_STATE(319)] = 18832,
  [SMALL_STATE(320)] = 18857,
  [SMALL_STATE(321)] = 18880,
  [SMALL_STATE(322)] = 18903,
  [SMALL_STATE(323)] = 18926,
  [SMALL_STATE(324)] = 18963,
  [SMALL_STATE(325)] = 18986,
  [SMALL_STATE(326)] = 19009,
  [SMALL_STATE(327)] = 19032,
  [SMALL_STATE(328)] = 19055,
  [SMALL_STATE(329)] = 19090,
  [SMALL_STATE(330)] = 19125,
  [SMALL_STATE(331)] = 19160,
  [SMALL_STATE(332)] = 19195,
  [SMALL_STATE(333)] = 19230,
  [SMALL_STATE(334)] = 19265,
  [SMALL_STATE(335)] = 19300,
  [SMALL_STATE(336)] = 19335,
  [SMALL_STATE(337)] = 19359,
  [SMALL_STATE(338)] = 19383,
  [SMALL_STATE(339)] = 19417,
  [SMALL_STATE(340)] = 19441,
  [SMALL_STATE(341)] = 19475,
  [SMALL_STATE(342)] = 19499,
  [SMALL_STATE(343)] = 19523,
  [SMALL_STATE(344)] = 19555,
  [SMALL_STATE(345)] = 19589,
  [SMALL_STATE(346)] = 19615,
  [SMALL_STATE(347)] = 19639,
  [SMALL_STATE(348)] = 19663,
  [SMALL_STATE(349)] = 19687,
  [SMALL_STATE(350)] = 19711,
  [SMALL_STATE(351)] = 19745,
  [SMALL_STATE(352)] = 19779,
  [SMALL_STATE(353)] = 19803,
  [SMALL_STATE(354)] = 19827,
  [SMALL_STATE(355)] = 19861,
  [SMALL_STATE(356)] = 19885,
  [SMALL_STATE(357)] = 19919,
  [SMALL_STATE(358)] = 19943,
  [SMALL_STATE(359)] = 19967,
  [SMALL_STATE(360)] = 20001,
  [SMALL_STATE(361)] = 20035,
  [SMALL_STATE(362)] = 20059,
  [SMALL_STATE(363)] = 20083,
  [SMALL_STATE(364)] = 20107,
  [SMALL_STATE(365)] = 20136,
  [SMALL_STATE(366)] = 20165,
  [SMALL_STATE(367)] = 20192,
  [SMALL_STATE(368)] = 20221,
  [SMALL_STATE(369)] = 20252,
  [SMALL_STATE(370)] = 20281,
  [SMALL_STATE(371)] = 20308,
  [SMALL_STATE(372)] = 20335,
  [SMALL_STATE(373)] = 20366,
  [SMALL_STATE(374)] = 20394,
  [SMALL_STATE(375)] = 20418,
  [SMALL_STATE(376)] = 20444,
  [SMALL_STATE(377)] = 20468,
  [SMALL_STATE(378)] = 20494,
  [SMALL_STATE(379)] = 20522,
  [SMALL_STATE(380)] = 20542,
  [SMALL_STATE(381)] = 20570,
  [SMALL_STATE(382)] = 20596,
  [SMALL_STATE(383)] = 20622,
  [SMALL_STATE(384)] = 20642,
  [SMALL_STATE(385)] = 20666,
  [SMALL_STATE(386)] = 20694,
  [SMALL_STATE(387)] = 20714,
  [SMALL_STATE(388)] = 20740,
  [SMALL_STATE(389)] = 20762,
  [SMALL_STATE(390)] = 20790,
  [SMALL_STATE(391)] = 20818,
  [SMALL_STATE(392)] = 20846,
  [SMALL_STATE(393)] = 20866,
  [SMALL_STATE(394)] = 20892,
  [SMALL_STATE(395)] = 20912,
  [SMALL_STATE(396)] = 20938,
  [SMALL_STATE(397)] = 20958,
  [SMALL_STATE(398)] = 20977,
  [SMALL_STATE(399)] = 20996,
  [SMALL_STATE(400)] = 21021,
  [SMALL_STATE(401)] = 21042,
  [SMALL_STATE(402)] = 21065,
  [SMALL_STATE(403)] = 21084,
  [SMALL_STATE(404)] = 21103,
  [SMALL_STATE(405)] = 21128,
  [SMALL_STATE(406)] = 21153,
  [SMALL_STATE(407)] = 21178,
  [SMALL_STATE(408)] = 21203,
  [SMALL_STATE(409)] = 21228,
  [SMALL_STATE(410)] = 21247,
  [SMALL_STATE(411)] = 21266,
  [SMALL_STATE(412)] = 21285,
  [SMALL_STATE(413)] = 21310,
  [SMALL_STATE(414)] = 21335,
  [SMALL_STATE(415)] = 21358,
  [SMALL_STATE(416)] = 21383,
  [SMALL_STATE(417)] = 21408,
  [SMALL_STATE(418)] = 21431,
  [SMALL_STATE(419)] = 21450,
  [SMALL_STATE(420)] = 21475,
  [SMALL_STATE(421)] = 21500,
  [SMALL_STATE(422)] = 21525,
  [SMALL_STATE(423)] = 21550,
  [SMALL_STATE(424)] = 21569,
  [SMALL_STATE(425)] = 21588,
  [SMALL_STATE(426)] = 21613,
  [SMALL_STATE(427)] = 21632,
  [SMALL_STATE(428)] = 21657,
  [SMALL_STATE(429)] = 21682,
  [SMALL_STATE(430)] = 21705,
  [SMALL_STATE(431)] = 21730,
  [SMALL_STATE(432)] = 21753,
  [SMALL_STATE(433)] = 21772,
  [SMALL_STATE(434)] = 21795,
  [SMALL_STATE(435)] = 21816,
  [SMALL_STATE(436)] = 21839,
  [SMALL_STATE(437)] = 21864,
  [SMALL_STATE(438)] = 21886,
  [SMALL_STATE(439)] = 21908,
  [SMALL_STATE(440)] = 21928,
  [SMALL_STATE(441)] = 21950,
  [SMALL_STATE(442)] = 21970,
  [SMALL_STATE(443)] = 21992,
  [SMALL_STATE(444)] = 22014,
  [SMALL_STATE(445)] = 22034,
  [SMALL_STATE(446)] = 22056,
  [SMALL_STATE(447)] = 22078,
  [SMALL_STATE(448)] = 22100,
  [SMALL_STATE(449)] = 22122,
  [SMALL_STATE(450)] = 22144,
  [SMALL_STATE(451)] = 22162,
  [SMALL_STATE(452)] = 22182,
  [SMALL_STATE(453)] = 22200,
  [SMALL_STATE(454)] = 22222,
  [SMALL_STATE(455)] = 22242,
  [SMALL_STATE(456)] = 22260,
  [SMALL_STATE(457)] = 22280,
  [SMALL_STATE(458)] = 22298,
  [SMALL_STATE(459)] = 22316,
  [SMALL_STATE(460)] = 22336,
  [SMALL_STATE(461)] = 22358,
  [SMALL_STATE(462)] = 22380,
  [SMALL_STATE(463)] = 22402,
  [SMALL_STATE(464)] = 22422,
  [SMALL_STATE(465)] = 22444,
  [SMALL_STATE(466)] = 22466,
  [SMALL_STATE(467)] = 22488,
  [SMALL_STATE(468)] = 22508,
  [SMALL_STATE(469)] = 22530,
  [SMALL_STATE(470)] = 22548,
  [SMALL_STATE(471)] = 22570,
  [SMALL_STATE(472)] = 22592,
  [SMALL_STATE(473)] = 22614,
  [SMALL_STATE(474)] = 22634,
  [SMALL_STATE(475)] = 22656,
  [SMALL_STATE(476)] = 22678,
  [SMALL_STATE(477)] = 22700,
  [SMALL_STATE(478)] = 22722,
  [SMALL_STATE(479)] = 22744,
  [SMALL_STATE(480)] = 22764,
  [SMALL_STATE(481)] = 22786,
  [SMALL_STATE(482)] = 22804,
  [SMALL_STATE(483)] = 22826,
  [SMALL_STATE(484)] = 22848,
  [SMALL_STATE(485)] = 22868,
  [SMALL_STATE(486)] = 22890,
  [SMALL_STATE(487)] = 22910,
  [SMALL_STATE(488)] = 22928,
  [SMALL_STATE(489)] = 22950,
  [SMALL_STATE(490)] = 22972,
  [SMALL_STATE(491)] = 22994,
  [SMALL_STATE(492)] = 23016,
  [SMALL_STATE(493)] = 23038,
  [SMALL_STATE(494)] = 23056,
  [SMALL_STATE(495)] = 23078,
  [SMALL_STATE(496)] = 23100,
  [SMALL_STATE(497)] = 23118,
  [SMALL_STATE(498)] = 23136,
  [SMALL_STATE(499)] = 23158,
  [SMALL_STATE(500)] = 23180,
  [SMALL_STATE(501)] = 23198,
  [SMALL_STATE(502)] = 23216,
  [SMALL_STATE(503)] = 23238,
  [SMALL_STATE(504)] = 23258,
  [SMALL_STATE(505)] = 23280,
  [SMALL_STATE(506)] = 23302,
  [SMALL_STATE(507)] = 23324,
  [SMALL_STATE(508)] = 23346,
  [SMALL_STATE(509)] = 23368,
  [SMALL_STATE(510)] = 23390,
  [SMALL_STATE(511)] = 23412,
  [SMALL_STATE(512)] = 23434,
  [SMALL_STATE(513)] = 23456,
  [SMALL_STATE(514)] = 23476,
  [SMALL_STATE(515)] = 23498,
  [SMALL_STATE(516)] = 23520,
  [SMALL_STATE(517)] = 23540,
  [SMALL_STATE(518)] = 23562,
  [SMALL_STATE(519)] = 23584,
  [SMALL_STATE(520)] = 23606,
  [SMALL_STATE(521)] = 23626,
  [SMALL_STATE(522)] = 23643,
  [SMALL_STATE(523)] = 23660,
  [SMALL_STATE(524)] = 23679,
  [SMALL_STATE(525)] = 23698,
  [SMALL_STATE(526)] = 23715,
  [SMALL_STATE(527)] = 23732,
  [SMALL_STATE(528)] = 23749,
  [SMALL_STATE(529)] = 23768,
  [SMALL_STATE(530)] = 23787,
  [SMALL_STATE(531)] = 23804,
  [SMALL_STATE(532)] = 23821,
  [SMALL_STATE(533)] = 23838,
  [SMALL_STATE(534)] = 23853,
  [SMALL_STATE(535)] = 23870,
  [SMALL_STATE(536)] = 23889,
  [SMALL_STATE(537)] = 23906,
  [SMALL_STATE(538)] = 23923,
  [SMALL_STATE(539)] = 23940,
  [SMALL_STATE(540)] = 23959,
  [SMALL_STATE(541)] = 23976,
  [SMALL_STATE(542)] = 23993,
  [SMALL_STATE(543)] = 24012,
  [SMALL_STATE(544)] = 24031,
  [SMALL_STATE(545)] = 24050,
  [SMALL_STATE(546)] = 24067,
  [SMALL_STATE(547)] = 24086,
  [SMALL_STATE(548)] = 24103,
  [SMALL_STATE(549)] = 24122,
  [SMALL_STATE(550)] = 24141,
  [SMALL_STATE(551)] = 24160,
  [SMALL_STATE(552)] = 24177,
  [SMALL_STATE(553)] = 24196,
  [SMALL_STATE(554)] = 24213,
  [SMALL_STATE(555)] = 24230,
  [SMALL_STATE(556)] = 24247,
  [SMALL_STATE(557)] = 24263,
  [SMALL_STATE(558)] = 24279,
  [SMALL_STATE(559)] = 24295,
  [SMALL_STATE(560)] = 24311,
  [SMALL_STATE(561)] = 24327,
  [SMALL_STATE(562)] = 24343,
  [SMALL_STATE(563)] = 24359,
  [SMALL_STATE(564)] = 24375,
  [SMALL_STATE(565)] = 24391,
  [SMALL_STATE(566)] = 24407,
  [SMALL_STATE(567)] = 24423,
  [SMALL_STATE(568)] = 24439,
  [SMALL_STATE(569)] = 24455,
  [SMALL_STATE(570)] = 24471,
  [SMALL_STATE(571)] = 24487,
  [SMALL_STATE(572)] = 24503,
  [SMALL_STATE(573)] = 24519,
  [SMALL_STATE(574)] = 24535,
  [SMALL_STATE(575)] = 24551,
  [SMALL_STATE(576)] = 24567,
  [SMALL_STATE(577)] = 24583,
  [SMALL_STATE(578)] = 24599,
  [SMALL_STATE(579)] = 24615,
  [SMALL_STATE(580)] = 24631,
  [SMALL_STATE(581)] = 24647,
  [SMALL_STATE(582)] = 24663,
  [SMALL_STATE(583)] = 24679,
  [SMALL_STATE(584)] = 24695,
  [SMALL_STATE(585)] = 24711,
  [SMALL_STATE(586)] = 24727,
  [SMALL_STATE(587)] = 24743,
  [SMALL_STATE(588)] = 24759,
  [SMALL_STATE(589)] = 24775,
  [SMALL_STATE(590)] = 24791,
  [SMALL_STATE(591)] = 24807,
  [SMALL_STATE(592)] = 24823,
  [SMALL_STATE(593)] = 24839,
  [SMALL_STATE(594)] = 24855,
  [SMALL_STATE(595)] = 24871,
  [SMALL_STATE(596)] = 24887,
  [SMALL_STATE(597)] = 24903,
  [SMALL_STATE(598)] = 24919,
  [SMALL_STATE(599)] = 24935,
  [SMALL_STATE(600)] = 24951,
  [SMALL_STATE(601)] = 24967,
  [SMALL_STATE(602)] = 24983,
  [SMALL_STATE(603)] = 24999,
  [SMALL_STATE(604)] = 25015,
  [SMALL_STATE(605)] = 25031,
  [SMALL_STATE(606)] = 25047,
  [SMALL_STATE(607)] = 25063,
  [SMALL_STATE(608)] = 25079,
  [SMALL_STATE(609)] = 25095,
  [SMALL_STATE(610)] = 25111,
  [SMALL_STATE(611)] = 25127,
  [SMALL_STATE(612)] = 25143,
  [SMALL_STATE(613)] = 25159,
  [SMALL_STATE(614)] = 25175,
  [SMALL_STATE(615)] = 25191,
  [SMALL_STATE(616)] = 25207,
  [SMALL_STATE(617)] = 25223,
  [SMALL_STATE(618)] = 25239,
  [SMALL_STATE(619)] = 25255,
  [SMALL_STATE(620)] = 25271,
  [SMALL_STATE(621)] = 25287,
  [SMALL_STATE(622)] = 25303,
  [SMALL_STATE(623)] = 25319,
  [SMALL_STATE(624)] = 25335,
  [SMALL_STATE(625)] = 25351,
  [SMALL_STATE(626)] = 25367,
  [SMALL_STATE(627)] = 25383,
  [SMALL_STATE(628)] = 25399,
  [SMALL_STATE(629)] = 25415,
  [SMALL_STATE(630)] = 25431,
  [SMALL_STATE(631)] = 25447,
  [SMALL_STATE(632)] = 25463,
  [SMALL_STATE(633)] = 25479,
  [SMALL_STATE(634)] = 25495,
  [SMALL_STATE(635)] = 25511,
  [SMALL_STATE(636)] = 25527,
  [SMALL_STATE(637)] = 25543,
  [SMALL_STATE(638)] = 25559,
  [SMALL_STATE(639)] = 25575,
  [SMALL_STATE(640)] = 25591,
  [SMALL_STATE(641)] = 25607,
  [SMALL_STATE(642)] = 25611,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [9] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 0, 0, 0),
  [11] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [13] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [17] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(350),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [29] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [31] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5),
  [33] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [35] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2),
  [37] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(227),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(556),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [49] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [51] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(32),
  [55] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(33),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(133),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [71] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4),
  [75] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(52),
  [79] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_int_literal, 1, 0, 0),
  [81] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_int_literal, 1, 0, 0),
  [83] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [85] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [89] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [91] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [95] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [97] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [101] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 4, 0, 0),
  [103] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 4, 0, 0),
  [105] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3, 0, 0),
  [107] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3, 0, 0),
  [109] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2, 0, 0),
  [111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2, 0, 0),
  [113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unary_expression, 2, 0, 0),
  [115] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unary_expression, 2, 0, 0),
  [117] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, 0, 0),
  [119] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, 0, 0),
  [121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(197),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(202),
  [135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(15),
  [143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(16),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_base_expression, 1, 0, 0),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7),
  [153] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_base_expression, 1, 0, 0),
  [155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [161] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(227),
  [166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(509),
  [169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(28),
  [172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(556),
  [175] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(638),
  [178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(570),
  [181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(32),
  [184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0),
  [186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_access, 3, 0, 0),
  [188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_access, 3, 0, 0),
  [190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 2, 0, 1),
  [192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 2, 0, 1),
  [194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_scoped_identifier, 3, 0, 2),
  [196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_scoped_identifier, 3, 0, 2),
  [198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__scoped_or_raw_ident, 1, 0, 0),
  [200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__scoped_or_raw_ident, 1, 0, 0),
  [202] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__path, 1, 0, 0),
  [204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 4, 0, 0),
  [206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 4, 0, 0),
  [212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(11),
  [216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [220] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_literal_repeat1, 2, 0, 0),
  [222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [224] = {.entry = {.count = 1, .reusable = true}}, SHIFT(9),
  [226] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [230] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__positional_argument_list_repeat1, 2, 0, 0),
  [234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_argument, 3, 0, 0),
  [236] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 3, 0, 12),
  [240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bool_literal, 1, 0, 0),
  [242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bool_literal, 1, 0, 0),
  [244] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reg_statement, 9, 0, 0),
  [246] = {.entry = {.count = 1, .reusable = false}}, SHIFT(29),
  [248] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assert_statement, 2, 0, 0),
  [250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_binding, 6, 0, 0),
  [252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_binding, 4, 0, 0),
  [256] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reg_statement, 7, 0, 0),
  [258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reg_statement, 8, 0, 0),
  [264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_set_statement, 4, 0, 0),
  [268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reg_statement, 10, 0, 0),
  [274] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [276] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stage_reference, 5, 0, 8),
  [280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_stage_reference, 5, 0, 8),
  [282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal, 2, 0, 0),
  [284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal, 2, 0, 0),
  [286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_literal, 4, 0, 0),
  [288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_literal, 4, 0, 0),
  [290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 2, 0, 0),
  [292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 2, 0, 0),
  [294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_instance, 4, 0, 0),
  [296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_entity_instance, 4, 0, 0),
  [298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_index, 4, 0, 0),
  [300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_index, 4, 0, 0),
  [302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_call, 4, 0, 5),
  [304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_call, 4, 0, 5),
  [306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__positional_argument_list, 3, 0, 0),
  [308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__positional_argument_list, 3, 0, 0),
  [310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_argument_list, 3, 0, 0),
  [312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__named_argument_list, 3, 0, 0),
  [314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal, 5, 0, 0),
  [316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal, 5, 0, 0),
  [318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_literal, 5, 0, 0),
  [320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_literal, 5, 0, 0),
  [322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_expression, 5, 0, 0),
  [324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_expression, 5, 0, 0),
  [326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 3, 0, 0),
  [328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 3, 0, 0),
  [330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_call, 5, 0, 9),
  [332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_call, 5, 0, 9),
  [334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_call, 5, 0, 5),
  [336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_call, 5, 0, 5),
  [338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__positional_argument_list, 4, 0, 0),
  [340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__positional_argument_list, 4, 0, 0),
  [342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 2, 0, 0),
  [344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 2, 0, 0),
  [346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_argument_list, 4, 0, 0),
  [348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__named_argument_list, 4, 0, 0),
  [350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 1, 0, 0),
  [352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 1, 0, 0),
  [354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_literal, 6, 0, 0),
  [356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_literal, 6, 0, 0),
  [358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comptime_if, 6, 0, 0),
  [360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comptime_if, 6, 0, 0),
  [362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_block, 4, 0, 0),
  [366] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_block, 4, 0, 0),
  [368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipeline_instance, 6, 0, 0),
  [370] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pipeline_instance, 6, 0, 0),
  [372] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stage_reference, 6, 0, 0),
  [374] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_stage_reference, 6, 0, 0),
  [376] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_call, 6, 0, 9),
  [378] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_call, 6, 0, 9),
  [380] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__positional_argument_list, 5, 0, 0),
  [382] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__positional_argument_list, 5, 0, 0),
  [384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal, 3, 0, 0),
  [386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal, 3, 0, 0),
  [388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_argument_list, 5, 0, 0),
  [390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__named_argument_list, 5, 0, 0),
  [392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_literal, 7, 0, 0),
  [394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_literal, 7, 0, 0),
  [396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_paren_expression, 3, 0, 0),
  [398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_paren_expression, 3, 0, 0),
  [400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comptime_if, 7, 0, 0),
  [402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comptime_if, 7, 0, 0),
  [404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipeline_instance, 7, 0, 0),
  [406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pipeline_instance, 7, 0, 0),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__base_expression, 1, 0, 0),
  [412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__base_expression, 1, 0, 0),
  [414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_expression, 3, 0, 0),
  [418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_expression, 3, 0, 0),
  [420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_entity_instance, 3, 0, 0),
  [422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_entity_instance, 3, 0, 0),
  [424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__positional_argument_list, 2, 0, 0),
  [426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__positional_argument_list, 2, 0, 0),
  [428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_argument_list, 2, 0, 0),
  [430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__named_argument_list, 2, 0, 0),
  [432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_call, 3, 0, 0),
  [434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_call, 3, 0, 0),
  [436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_literal, 4, 0, 0),
  [438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_literal, 4, 0, 0),
  [440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 1, 0, 0),
  [442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 1, 0, 0),
  [444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1, 0, 0),
  [446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1, 0, 0),
  [448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipeline_stage_name, 2, 0, 0),
  [450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pipeline_stage_name, 2, 0, 0),
  [452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1, 0, 0),
  [454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1, 0, 0),
  [456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comptime_if, 8, 0, 0),
  [458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comptime_if, 8, 0, 0),
  [460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comptime_else, 4, 0, 0),
  [462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comptime_else, 4, 0, 0),
  [464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 2, 0, 0),
  [466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 2, 0, 0),
  [468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comptime_else, 3, 0, 0),
  [470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_comptime_else, 3, 0, 0),
  [472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0),
  [474] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(614),
  [477] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(562),
  [480] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(610),
  [483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(548),
  [486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(621),
  [489] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(350),
  [492] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(389),
  [495] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(416),
  [498] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(597),
  [501] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 2, 0, 0), SHIFT_REPEAT(602),
  [504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_source_file, 1, 0, 0),
  [506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(201),
  [522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(235),
  [524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(237),
  [526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(184),
  [536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__op_shifty, 1, 0, 0),
  [568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__op_shifty, 1, 0, 0),
  [570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_bitwise_and, 1, 0, 0),
  [572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_bitwise_and, 1, 0, 0),
  [574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_custom_infix, 3, 0, 0),
  [576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_custom_infix, 3, 0, 0),
  [578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__op_add_like, 1, 0, 0),
  [580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__op_add_like, 1, 0, 0),
  [582] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_sub, 1, 0, 0),
  [584] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_sub, 1, 0, 0),
  [586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(206),
  [596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_mul, 1, 0, 0),
  [602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_mul, 1, 0, 0),
  [604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_add, 1, 0, 0),
  [606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_add, 1, 0, 0),
  [608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__op_mul_like, 1, 0, 0),
  [610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__op_mul_like, 1, 0, 0),
  [612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__op_eq_like, 1, 0, 0),
  [614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__op_eq_like, 1, 0, 0),
  [616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_lt, 1, 0, 0),
  [618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_lt, 1, 0, 0),
  [620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_op_gt, 1, 0, 0),
  [622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_op_gt, 1, 0, 0),
  [624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__op_relational, 1, 0, 0),
  [626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__op_relational, 1, 0, 0),
  [628] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(213),
  [631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(84),
  [634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(71),
  [637] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(630),
  [640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4),
  [643] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4),
  [646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(509),
  [652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [678] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(227),
  [681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(509),
  [684] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(28),
  [687] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(556),
  [690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(607),
  [693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(639),
  [696] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2, 0, 0), SHIFT_REPEAT(32),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(345),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_braced_parameter_list, 3, 0, 0),
  [715] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_braced_parameter_list, 2, 0, 0),
  [717] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_braced_parameter_list, 4, 0, 0),
  [719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_braced_parameter_list, 5, 0, 0),
  [721] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 1, 0, 0),
  [723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 3, 0, 0),
  [727] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_builtin_type, 1, 0, 0),
  [729] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__item_repeat1, 2, 0, 0), SHIFT_REPEAT(614),
  [732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__item_repeat1, 2, 0, 0),
  [734] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__base_type, 1, 0, 0),
  [736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__body_or_builtin, 1, 0, 0),
  [738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl, 9, 0, 10),
  [740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl, 9, 0, 11),
  [742] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl, 9, 0, 13),
  [744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 2, 0, 0),
  [746] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_definition, 4, 0, 0),
  [748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 5, 0, 0),
  [750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod, 4, 0, 0),
  [752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_definition, 3, 0, 0),
  [754] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_source_file_repeat1, 1, 0, 0),
  [756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl, 10, 0, 13),
  [758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use, 3, 0, 0),
  [760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl, 4, 0, 0),
  [762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait, 4, 0, 0),
  [764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl, 8, 0, 6),
  [766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_comptime_config, 4, 0, 0),
  [768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_mod, 5, 0, 0),
  [770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 5, 0, 0),
  [772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl, 8, 0, 11),
  [774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl, 8, 0, 7),
  [776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 4, 0, 0),
  [778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_body, 3, 0, 0),
  [780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl, 7, 0, 6),
  [782] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl, 6, 0, 0),
  [784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl, 7, 0, 0),
  [786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl, 7, 0, 4),
  [788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl, 6, 0, 4),
  [790] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait, 6, 0, 0),
  [792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl, 7, 0, 7),
  [794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__item, 1, 0, 0),
  [796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unit_definition, 2, 0, 0),
  [798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl, 5, 0, 0),
  [800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__item, 2, 0, 0),
  [802] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_definition, 4, 0, 0),
  [804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_trait, 5, 0, 0),
  [806] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_builtin_marker, 1, 0, 0),
  [808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_impl, 8, 0, 10),
  [810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__generic_list, 5, 0, 0),
  [812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 3, 0, 0),
  [814] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 2, 0, 0),
  [816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__generic_list, 4, 0, 0),
  [818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 4, 0, 0),
  [820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__generic_list, 2, 0, 0),
  [822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wire, 2, 0, 0),
  [824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 2, 0, 0),
  [826] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_inverted, 2, 0, 0),
  [828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__generic_list, 3, 0, 0),
  [830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 5, 0, 0),
  [832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type, 3, 0, 0),
  [834] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5, 0, 0),
  [836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [838] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1, 0, 0),
  [840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern, 1, 0, 0),
  [842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(428),
  [844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__item_repeat1, 1, 0, 0),
  [846] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 4, 0, 0),
  [848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [850] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_match_arm, 4, 0, 0),
  [852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_last_match_arm, 4, 0, 12),
  [854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_match_arm, 4, 0, 0),
  [856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(503),
  [860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [872] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(264),
  [878] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(562),
  [881] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_impl_repeat1, 2, 0, 0), SHIFT_REPEAT(610),
  [884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_impl_repeat1, 2, 0, 0),
  [886] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_trait_repeat1, 2, 0, 0), SHIFT_REPEAT(562),
  [889] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_trait_repeat1, 2, 0, 0), SHIFT_REPEAT(610),
  [892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_trait_repeat1, 2, 0, 0),
  [894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(323),
  [906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(481),
  [908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_match_block_repeat1, 1, 0, 0),
  [910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_match_block_repeat1, 1, 0, 0),
  [912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(630),
  [916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [918] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [924] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__positional_pattern_list, 3, 0, 0),
  [936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__positional_pattern_list, 3, 0, 0),
  [938] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 4, 0, 0),
  [940] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 4, 0, 0),
  [942] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 2, 0, 0),
  [946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 2, 0, 0),
  [948] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [950] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_unpack, 2, 0, 0),
  [952] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_named_unpack, 2, 0, 0),
  [954] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_unpack, 2, 0, 0),
  [956] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_positional_unpack, 2, 0, 0),
  [958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__path, 1, 0, 0),
  [970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 5, 0, 0),
  [972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 5, 0, 0),
  [974] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_pattern_list, 3, 0, 0),
  [976] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__named_pattern_list, 3, 0, 0),
  [978] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3, 0, 0),
  [980] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_pattern, 3, 0, 0),
  [982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [986] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__positional_pattern_list, 4, 0, 0),
  [988] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__positional_pattern_list, 4, 0, 0),
  [990] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__positional_pattern_list, 2, 0, 0),
  [992] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__positional_pattern_list, 2, 0, 0),
  [994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_pattern_list, 2, 0, 0),
  [998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__named_pattern_list, 2, 0, 0),
  [1000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [1002] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__positional_pattern_list, 5, 0, 0),
  [1004] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__positional_pattern_list, 5, 0, 0),
  [1006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_pattern_list, 5, 0, 0),
  [1008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__named_pattern_list, 5, 0, 0),
  [1010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [1012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_pattern_list, 4, 0, 0),
  [1014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__named_pattern_list, 4, 0, 0),
  [1016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [1018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [1020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [1022] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unit_head, 4, 0, 0),
  [1024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [1028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [1030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [1032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unit_head, 3, 0, 0),
  [1034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [1036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_reg_statement_repeat1, 2, 0, 0),
  [1038] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_reg_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(631),
  [1041] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_reg_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(557),
  [1044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1046] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unit_head, 5, 0, 0),
  [1048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unit_head, 6, 0, 0),
  [1050] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 5, 0, 0),
  [1052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 6, 0, 0),
  [1054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 5, 0, 0),
  [1056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 7, 0, 0),
  [1058] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0),
  [1060] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_where_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(578),
  [1063] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3, 0, 0),
  [1065] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 4, 0, 0),
  [1067] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2, 0, 0),
  [1069] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unit_declaration, 2, 0, 0),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [1073] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_literal_repeat1, 2, 0, 0), SHIFT_REPEAT(35),
  [1076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_turbofish, 3, 0, 0),
  [1078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_turbofish, 5, 0, 0),
  [1080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(356),
  [1082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [1084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [1086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [1088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [1092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [1094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_parameters, 3, 0, 0),
  [1096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_impl_repeat1, 1, 0, 0),
  [1098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_parameters, 4, 0, 0),
  [1100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [1104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [1106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member, 1, 0, 0),
  [1108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_turbofish, 2, 0, 0),
  [1110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [1112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [1114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [1116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [1118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [1120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [1122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_parameters, 5, 0, 0),
  [1124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_parameters, 2, 0, 0),
  [1126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(466),
  [1128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_turbofish, 4, 0, 0),
  [1130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [1132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [1134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [1136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [1138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [1140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 1, 0, 0),
  [1142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_where_clause, 1, 0, 0),
  [1144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(558),
  [1146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_trait_repeat1, 1, 0, 0),
  [1148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0),
  [1150] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parameter_list_repeat1, 2, 0, 0), SHIFT_REPEAT(368),
  [1153] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__item_repeat1, 2, 0, 0), SHIFT_REPEAT(634),
  [1156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [1158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [1160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(439),
  [1164] = {.entry = {.count = 1, .reusable = false}}, SHIFT(533),
  [1166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(642),
  [1168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [1172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [1174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_turbofish_arg, 1, 0, 0),
  [1176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [1178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [1180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__named_argument, 1, 0, 0),
  [1184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [1186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [1188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [1190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [1192] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__positional_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(41),
  [1195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_parameter, 3, 0, 0),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [1199] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_turbofish_repeat2, 2, 0, 0), SHIFT_REPEAT(549),
  [1202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_turbofish_repeat2, 2, 0, 0),
  [1204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__named_argument_list_repeat1, 2, 0, 0),
  [1206] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__named_argument_list_repeat1, 2, 0, 0), SHIFT_REPEAT(476),
  [1209] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_turbofish_repeat1, 2, 0, 0),
  [1211] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_turbofish_repeat1, 2, 0, 0), SHIFT_REPEAT(182),
  [1214] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [1216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [1218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(255),
  [1220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 0), SHIFT_REPEAT(543),
  [1225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_body_repeat1, 2, 0, 0),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [1233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__named_pattern_list_repeat1, 2, 0, 0),
  [1235] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__named_pattern_list_repeat1, 2, 0, 0), SHIFT_REPEAT(483),
  [1238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [1240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_reg_statement_repeat1, 1, 0, 0),
  [1242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(338),
  [1244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [1246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [1248] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_generic_parameters_repeat1, 2, 0, 0), SHIFT_REPEAT(464),
  [1251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_generic_parameters_repeat1, 2, 0, 0),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1257] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_statement, 2, 0, 0),
  [1259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [1261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [1265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_pattern_param, 1, 0, 0),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [1273] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, 0, 0),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(360),
  [1277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_decl_statement_repeat1, 2, 0, 0),
  [1279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_decl_statement_repeat1, 2, 0, 0), SHIFT_REPEAT(594),
  [1282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [1284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [1286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(641),
  [1288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [1290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [1292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [1294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [1296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(349),
  [1298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [1300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [1302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reg_initial, 4, 0, 0),
  [1304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [1306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_comment_repeat1, 2, 0, 0), SHIFT_REPEAT(533),
  [1309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_comment_repeat1, 2, 0, 0),
  [1311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_reg_reset, 6, 0, 0),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [1317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_typed_parameter, 4, 0, 0),
  [1319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__unit_head, 7, 0, 0),
  [1321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_statement, 3, 0, 0),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [1325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__comptime_operator, 1, 0, 0),
  [1327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__comptime_operator, 1, 0, 0),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1347] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipeline_reg_marker, 1, 0, 0),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1361] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_turbofish_repeat1, 2, 0, 0), SHIFT_REPEAT(199),
  [1364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(13),
  [1368] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 0),
  [1370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(226),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [1381] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member, 2, 0, 0),
  [1383] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_decl_statement, 4, 0, 0),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [1387] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_pattern_param, 3, 0, 0),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [1393] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_comment_repeat1, 1, 0, 0),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [1397] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_param, 3, 0, 3),
  [1399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(590),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(637),
  [1405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [1411] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_named_turbofish_arg, 3, 0, 0),
  [1413] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_param, 1, 0, 0),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [1431] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pipeline_reg_marker, 3, 0, 0),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [1469] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(335),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [1519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [1521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [1523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [1527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [1531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(69),
  [1533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [1537] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [1539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [1541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [1543] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pipeline_start, 4, 0, 0),
  [1545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [1551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [1553] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 3, 0, 0),
  [1555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block_comment, 2, 0, 0),
};

#ifdef __cplusplus
extern "C" {
#endif
#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_spade(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
